*=============== INTERNAL FORCES =============================================
*
*             PAPALLEL VERSION
*
*=============== GETBND ===========================================
*
      SUBROUTINE GETBND
*
      include "prcm.h"
* 
      timeb0	= cputime(0.d0) 
	VIRB=0.
      DO M      = 1,NRBB
        BR(M)     = 0.D0
        BE(M)     = 0.D0
      END DO
	do ITYP=1,NTYPES
	  if(IPOT(ITYP).eq.1.or.IPOT(ITYP).eq.2)call STRBND(ITYP)
	end do
	if(NRBB.le.0)go to 200        
	do N=1,NRBT
        I     = IBI(N)
	  ITYP	=     ITYPE(I)        ! type
C	  if(.not.LMOVE(ITYP))go to 100  ! end of the loop
	  NSP	= NSPEC(ITYP)                       
	  M	= IBUK(N)              ! site number
        J     = JBJ(N)         
*
        FNSPI     = 1.D0/DFLOAT(NSP)
*
        REQ       = RB(M)
*
        BX        = SX(J)-SX(I)
        BY        = SY(J)-SY(I)
        BZ        = SZ(J)-SZ(I)
        call PBC(BX,BY,BZ)
        BSQ       = BX*BX+BY*BY+BZ*BZ
        BD        = DSQRT(BSQ)
        R1I       = 1.D0/BD
        BBB       =  BD-REQ
	  if(ID(M).eq.0)then  
*   Harmonic potential
          FCN       = FB(M)
          DBND      = BBB*FCN
          EBDD	    = DBND*BBB
          FORB      =  -2.0D0*DBND*R1I
	  else if(ID(M).eq.1)then 
	    DDIS = DB(M)
	    ROH  = RO(M)
	    EXM	 = exp(-ROH*BBB)
	    EXMP = 1-EXM
	    EBDD = DDIS*EXMP**2
	    FORB = -2.d0*DDIS*ROH*EXM*EXMP*R1I       
*   Morse potential                 
	  else
	    write(*,*)' Wrong type of bond potential: ',ID(M)
	    write(*,*)' site ',M,' molecule ',ITYP
	    write(*,*)' Check ',NAME(ITYP),'.mol  file'
	    stop
	  end if
        BR(M)     = BR(M)+BD*FNSPI
        BE(M)     = BE(M)+EBDD*FNSPI
        PINT	    = PINT+EBDD
        HX(I)     = HX(I)-BX*FORB
        HY(I)     = HY(I)-BY*FORB
        HZ(I)     = HZ(I)-BZ*FORB
        HX(J)     = HX(J)+BX*FORB
        HY(J)     = HY(J)+BY*FORB
        HZ(J)     = HZ(J)+BZ*FORB
        VIRB	    = VIRB+FORB*BSQ
	  VIRFX	    = VIRFX+FORB*BX**2  
	  VIRFY	    = VIRFY+FORB*BY**2  
	  VIRFZ	    = VIRFZ+FORB*BZ**2  
	  if(IPRINT.ge.9)write(*,*)I,J,BD,EBDD/EFACT
*       
 100	  continue
      END DO! OF M       
*
 200  timeb	= timeb+cputime(timeb0)
      RETURN
      END
*
*=============== GETANG ===========================================
*
      SUBROUTINE GETANG
*
      include "prcm.h"
*
      IF(NRAA.LE.0) RETURN
*     
      timea0	= cputime(0.d0)
*     
      DO M      = 1,NRAA
        AR(M)     = 0.D0
        AE(M)     = 0.D0
      END DO
*
	do N=1,NRAT
	  I=IAI(N)
	  ITYP=ITYPE(I) 
        NSP       = NSPEC (ITYP)
        FNSPI     = 1.D0/DFLOAT(NSP)
*
          J         = JAJ(N)
	    K	      = KAK(N)
	    M	      = IAUK(N)
          FCN       = FA(M)
          AEQ       = RA(M)
*
          AX        = SX(I)-SX(J)
          AY        = SY(I)-SY(J)
          AZ        = SZ(I)-SZ(J)
          call PBC(AX,AY,AZ)
          ASQ       = AX*AX+AY*AY+AZ*AZ
          ASQI      = 1.D0/ASQ
*
          BX        = SX(K)-SX(J)
          BY        = SY(K)-SY(J)
          BZ        = SZ(K)-SZ(J)
          call PBC(BX,BY,BZ)
          BSQ       = BX*BX+BY*BY+BZ*BZ
          BSQI      = 1.D0/BSQ
*
          AB        = DSQRT(ASQ*BSQ)
          ABI       = 1.D0/AB
*
          COSA      = AX*BX+AY*BY+AZ*BZ
          COSA      = COSA*ABI
          COSA      = DMIN1(COSA, 1.D0)
          COSA      = DMAX1(COSA,-1.D0)
          ALF       = DACOS(COSA)
          AVA       = AVA+ALF
          SINA      = DSIN(ALF)
          SINAI     =  1.D0/SINA
          DALF      =  ALF-AEQ
          ABC       = DALF*FCN
          EANG	    = ABC*DALF	
*
          AR(M)     = AR(M)+ALF*FNSPI
          AE(M)     = AE(M)+EANG*FNSPI 
          PINT	    = PINT+EANG 
	    if(IPRINT.ge.9)write(*,*)I,J,K,ALF*TODGR,EANG/EFACT
*
*      if(nstep.eq.2)
*     x print  "(2i5,5x,3(1x,a4),f8.2,3x,f18.8)"
*     X ,m,l,nam(i),nam(j),nam(k)
*     x ,alf*180./3.1412,ABC*DALF*enerf*1.d-3
          SAB       =-2.D0*ABC*SINAI
          CAB       = SAB*COSA
          FAB       = SAB*ABI
          FAA       = CAB*ASQI
          FBB       = CAB*BSQI
*
          FAX       = FAB*BX-FAA*AX
          FAY       = FAB*BY-FAA*AY
          FAZ       = FAB*BZ-FAA*AZ
*
          FBX       = FAB*AX-FBB*BX
          FBY       = FAB*AY-FBB*BY
          FBZ       = FAB*AZ-FBB*BZ
*
          HX(I)     = HX(I)-FAX
          HY(I)     = HY(I)-FAY
          HZ(I)     = HZ(I)-FAZ
          HX(J)     = HX(J)+FAX+FBX
          HY(J)     = HY(J)+FAY+FBY
          HZ(J)     = HZ(J)+FAZ+FBZ
          HX(K)     = HX(K)-FBX
          HY(K)     = HY(K)-FBY
          HZ(K)     = HZ(K)-FBZ     
*
	    VIRFX      = VIRFX-AX*FAX-BX*FBX
	    VIRFY      = VIRFY-AY*FAY-BY*FBY
	    VIRFZ      = VIRFZ-AZ*FAZ-BZ*FBZ
      END DO! OF N
*     
*	write(*,*)TASKID,PINT*0.001*ENERF/FNOP,PINT*0.001*ENERF/FNOP
*
      timea	= timea+cputime(timea0)
      RETURN
      END
*
*=============== GETTRS ============================================== 
*
      SUBROUTINE GETTRS
*
      include "prcm.h"
*
      IF(NRTT.LE.0) RETURN
      timet0	= cputime(0.d0)
*
      DO M      = 1,NRTT
      TR(M)     = 0.D0
      TE(M)     = 0.D0
      END DO
*                 
	do N=1,NRRT
	  I	= ITI(N)
	  ITYP	= ITYPE(I)
C        if(LMOVE(ITYP))then
        NSP       = NSPEC (ITYP)
        FNSPI     = 1.D0/DFLOAT(NSP)
*
        J         = JTJ(N)
        K         = KTK(N)
        L         = LTL(N)
	  M	    = ITUK(N)
        ax        = sx(j)-sx(i)
        ay        = sy(j)-sy(i)
        az        = sz(j)-sz(i)
        bx        = sx(k)-sx(j)
        by        = sy(k)-sy(j)
        bz        = sz(k)-sz(j)
        cx        = sx(l)-sx(k)
        cy        = sy(l)-sy(k)
        cz        = sz(l)-sz(k)
*
        call PBC(AX,AY,AZ)
        call PBC(BX,BY,BZ)
        call PBC(CX,CY,CZ)
*
        ab        = ax*bx + ay*by + az*bz
        bc        = bx*cx + by*cy + bz*cz
        ac        = ax*cx + ay*cy + az*cz
        at        = ax*ax + ay*ay + az*az
        bt        = bx*bx + by*by + bz*bz
        ct        = cx*cx + cy*cy + cz*cz

        axb       = (at*bt)-(ab*ab)
        bxc       = (bt*ct)-(bc*bc)
*
        fnum      = (ab*bc)-(ac*bt)
        den       = axb*bxc
        if(den.gt.0.0d0) then 
*
          den       = dsqrt(den)         
Cosine of angle:
          co        = fnum/den
          CO        = DMIN1(CO, 1.D0)
          CO        = DMAX1(CO,-1.D0)
* Sign of angle:
      signum    = ax*(by*cz-cy*bz)+ay*(bz*cx-cz*bx)+az*(bx*cy-cx*by)
* Value of angle:
          arg       = dsign(dacos(co),signum)
          SIN1F        = dsin(arg)
	    si	= SIN1F
          if( dabs(si).lt.1.0d-12 ) si = dsign(1.0d-12,si)   
	    if(ITORS(M).eq.0)then
            FCN       = FT(M)
            TEQ       = RT(M)
            MUL       = NMUL(M)
*
*
            EARG      = MUL*ARG-TEQ
*
*...Energies:
*
            POTT      = FCN*(1.D0+DCOS(EARG))  
            DERI      = -FCN*MUL*DSIN(EARG)
	    else if(ITORS(M).eq.1)then
            FN1   = FT1(M)
            FN2   = FT2(M)
            FN3   = FT3(M)  
	      COS1F = dcos(ARG)
            COS2F =  2.D0*COS1F**2-1.D0
            COS3F = COS1F*(2.D0*COS2F-1.D0)
	      SIN2F = 2.d0*SIN1F*COS1F
	      SIN3F = SIN1F*COS2F+SIN2F*COS1F
            POTT  = FN1 * (1.D0 + COS1F)
     X             +FN2 * (1.D0 - COS2F)
     X             +FN3 * (1.D0 + COS3F)  
	      DERI	= -FN1*SIN1F+2.d0*FN2*SIN2F-3.d0*FN3*SIN3F
	    else if(ITORS(M).eq.5)then  
	      FN0   = FT(M)
            FN1   = FT1(M)
            FN2   = FT2(M)
            FN3   = FT3(M)  
            FN4   = FT4(M)
            FN5   = FT5(M)
            TEQ   = RT(M)
            EARG  = ARG-TEQ
            COSI      =  DCOS(EARG)
            COSI2     =  COSI*COSI
            COSI3     =  COSI*COSI2
            COSI4     =  COSI*COSI3
            COSI5     =  COSI*COSI4
	      SINI	=  dsin(EARG)
            POTT =    FN0+ FN1*COSI+FN2*COSI2+     FN3*COSI3+
     +                              FN4*COSI4+     FN5*COSI5 
	      DERI =  -SINI*(FN1+2.d0*FN2*COSI +3.d0*FN3*COSI2+
     +                         4.d0*FN4*COSI3+5.d0*FN5*COSI4)
	    else if(ITORS(M).eq.-1)then                        
*   Impropers
            FCN       = FT(M)
            TEQ       = RT(M)
            EARG      = ARG-TEQ
            POTT      = FCN*EARG**2  
            DERI      = 2.d0*FCN*EARG
	    else
	      write(*,*)'  Torsion type ',ITORS(M),' not supported'
	      write(*,*)'  Torsion ',I,J,K,L,' on ',NAME(ITYP)
	      stop
          end if
          TR(M)     = TR(M)+abs(ARG*FNSPI)
          TE(M)     = TE(M)+POTT*FNSPI
          PINT	= PINT+POTT
	    if(IPRINT.ge.9)write(*,*)I,J,K,L,ARG*TODGR,POTT/EFACT
*
*...Forces:
*
          de1       = DERI/den/si
          axb       = axb/den*co
          bxc       = bxc/den*co
*X
          dnum      =  cx*bt - bx*bc
          dden      = (ab*bx - ax*bt)*bxc
          FFI1      = (dnum  - dden) * de1
          dnum      = ((bx-ax)*bc - ab*cx ) + (2.0*ac*bx - cx*bt)
          dden      = axb*(bc*cx-bx*ct) + (ax*bt-at*bx-ab*(bx-ax))*bxc
          FFJ1      = (dnum - dden) * de1
          dnum      = ab*bx - ax*bt
          dden      = axb*( bt*cx - bc*bx )
          FFL1      = (dnum - dden) * de1
          FFK1      = -(ffi1+ffj1+ffl1)
*
          HX(I)     = HX(I)+ffi1
          HX(J)     = HX(J)+ffj1
          HX(K)     = HX(K)+ffk1
          HX(L)     = HX(L)+ffl1 
*Y
          dnum      =  cy*bt - by*bc
          dden      = (ab*by - ay*bt)*bxc
          FFI2      = (dnum  - dden) * de1
          dnum      = ((by-ay)*bc - ab*cy ) + (2.0*ac*by - cy*bt)
          dden      = axb*(bc*cy-by*ct) + (ay*bt-at*by-ab*(by-ay))*bxc
          FFJ2      = (dnum - dden) * de1
          dnum      = ab*by - ay*bt
          dden      = axb*( bt*cy - bc*by )
          FFL2      = (dnum - dden) * de1
          FFK2      = -(ffi2+ffj2+ffl2)
          HY(I)     = HY(I)+ffi2
          HY(J)     = HY(J)+ffj2
          HY(K)     = HY(K)+ffk2
          HY(L)     = HY(L)+ffl2
*Z
          dnum      =  cz*bt - bz*bc
          dden      = (ab*bz - az*bt)*bxc
          FFI3      = (dnum  - dden) * de1
          dnum      = ((bz-az)*bc - ab*cz ) + (2.0*ac*bz - cz*bt)
          dden      = axb*(bc*cz-bz*ct) + (az*bt-at*bz-ab*(bz-az))*bxc
          FFJ3      = (dnum - dden) * de1
          dnum      = ab*bz - az*bt
          dden      = axb*( bt*cz - bc*bz )
          FFL3      = (dnum - dden) * de1
          FFK3      = -(ffi3+ffj3+ffl3)
          HZ(I)     = HZ(I)+ffi3
          HZ(J)     = HZ(J)+ffj3
          HZ(K)     = HZ(K)+ffk3
          HZ(L)     = HZ(L)+ffl3
	    VIRFX  = VIRFX-(AX+BX)*FFI1-BX*FFJ1+CX*FFL1
	    VIRFY  = VIRFY-(AY+BY)*FFI2-BY*FFJ2+CY*FFL2
	    VIRFZ  = VIRFZ-(AZ+BZ)*FFI3-BZ*FFJ3+CZ*FFL3
	  end if    !  den > 0
*              
      END DO! OF N
*     
      timet	= timet+cputime(timet0)
      RETURN
      END
*
*=============== STRBND ===========================================
*
      SUBROUTINE STRBND(ITYP)
*      
* This routine calculates SPC water model with Morse potential 
* 
*
      include "prcm.h"
*
*.... FLEXIBLE WATER MODEL:
*                 
*  IPOT= 1 - Harmonic
*        2 - Anharmonic
      PARAMETER (AAP  = 2809.56D0 , BBP = 2809.56D0)
      PARAMETER (CCP  =  687.41D0 , DDP =   2.566D0)
      PARAMETER (EEP  = -884.63D0 , FFP = -884.63D0)
      PARAMETER (GGP  =  467.31D0 ,BBMA=1.3,BBSA=1.4  )
*
	if(NAME(ITYP)(1:3).ne.'H2O'.and.NAME(ITYP)(1:3).ne.'h2o')then
	  write(*,*)
     +'Potential of type 1 or 2 can be used only for water: ',
     +' mol. name H2O*'
	  stop
	end if
*
      NBBEG    = IADB(ITYP)
      NBEND    = NBBEG+NRB(ITYP)-1
*
      I1       = NBBEG
      I2       = I1+1
      I3       = I2+1
*
      IBEG     = IADDR(ITYP)+1
      IEND     = IADDR(ITYP+1)
      NSP      = NSPEC(ITYP)
      NSS      = NSITS(ITYP)
      FNSPI    = 1.D0/DFLOAT(NSP)
      FACT     = 1.D3/AVSNO/UNITE
      FACTOR   = FACT
*
      ROH1     = RB(I1)
      ROH2     = RB(I2)
      RH1H2    = RB(I3)
*
      AAA      = AAP*FACTOR
      BBB      = BBP*FACTOR
      DDD      = DDP
      IPT      = IPOT(ITYP)
      IF(IPT.EQ.2) THEN
        AAA      = AAA/DDD**2
        BBB      = BBB/DDD**2
      END IF
*
      CCC      = CCP*FACTOR
      EEE      = EEP*FACTOR
      FFF      = FFP*FACTOR
      GGG      = GGP*FACTOR
      BBM	= BBMA
      BBS	= BBSA
*
      EFAC     =  FKCALJ*1.D+3/AVSNO/UNITE
*
      AADD     = AAA*DDD
      BBDD     = BBB*DDD
*
      ISHF     = ISADDR(ITYP)
      IBB      = ISHF+1
      JBB      = ISHF+2
      KBB      = ISHF+3
*
      IF(IPT.EQ.2) THEN
*                                    
CM
      DO N     = TASKID+1,NSP,NUMTASK
      I        = (N-1)*NSS+IBB
      J        = (N-1)*NSS+JBB
      K        = (N-1)*NSS+KBB
*
      AX       = SX(J)-SX(I)
      AY       = SY(J)-SY(I)
      AZ       = SZ(J)-SZ(I)
*
      BX       = SX(K)-SX(I)
      BY       = SY(K)-SY(I)
      BZ       = SZ(K)-SZ(I)
*
      CX       = SX(K)-SX(J)
      CY       = SY(K)-SY(J)
      CZ       = SZ(K)-SZ(J)
*
      RRA      = AX*AX+AY*AY+AZ*AZ
      RRB      = BX*BX+BY*BY+BZ*BZ
      RRC      = CX*CX+CY*CY+CZ*CZ
      ASS      = DSQRT(RRA)
      BSS      = DSQRT(RRB)
      if(ASS.gt.BBS)then
        write(*,*)' !!! bond length ',ASS,I,J,TASKID
*        call XMOLDUMP
*        stop
      end if  
      if(BSS.gt.BBS)then
        write(*,*)' !!! bond length ',BSS,I,K,TASKID
*        call XMOLDUMP
*        stop
      end if  
      CSS      = DSQRT(RRC)
      COSA     = (AX*BX+AY*BY+AZ*BZ)/ASS/BSS
      ARG      = DACOS(COSA)
*
      SA       = ASS-ROH1
      SB       = BSS-ROH2
      SH       = CSS-RH1H2
*
      EXPA     = DEXP(-DDD*SA)
      EXPAM    = 1.D0-EXPA
      EXPB     = DEXP(-DDD*SB)
      EXPBM    = 1.D0-EXPB
*
      WB1       = AAA*EXPAM**2+EEE*SA*SH
      WB2       = BBB*EXPBM**2+FFF*SB*SH
      WB3       = CCC*SH*SH   +GGG*SA*SB
      WB        = WB1+WB2+WB3
*
      BR(I1)    = BR(I1)+ASS*FNSPI
      BR(I2)    = BR(I2)+BSS*FNSPI
      BR(I3)    = BR(I3)+CSS*FNSPI
*!    BS(I3)    = BS(I3)+ARG
*
      BE(I1)    = BE(I1)+WB1*FNSPI
      BE(I2)    = BE(I2)+WB2*FNSPI
      BE(I3)    = BE(I3)+WB3*FNSPI
      PINT	= PINT+WB1+WB2+WB3
*
      if(ASS.gt.BBM)then
        FB3A	= -2.*SA*AADD*DDD
      else
        FB3A	= -2.*AADD*EXPA*EXPAM
      end if
      FB3A     = FB3A   - EEE*SH-GGG*SB
      if(BSS.gt.BBM)then
        FB3B	= -2.*SB*BBDD*DDD
      else
        FB3B	= -2.*BBDD*EXPB*EXPBM
      end if
      FB3B     = FB3B   - FFF*SH-GGG*SA
      FB3C     = -2.0*CCC*SH            - EEE*SA-FFF*SB
*
      FB3A     = FB3A/ASS
      FB3B     = FB3B/BSS
      FB3C     = FB3C/CSS
*
      AXX       = FB3A*AX
      AYY       = FB3A*AY
      AZZ       = FB3A*AZ
*
      BXX       = FB3B*BX
      BYY       = FB3B*BY
      BZZ       = FB3B*BZ
*
      CXX       = FB3C*CX
      CYY       = FB3C*CY
      CZZ       = FB3C*CZ
*
      HX(I)    = HX(I)-AXX-BXX
      HY(I)    = HY(I)-AYY-BYY
      HZ(I)    = HZ(I)-AZZ-BZZ
*
      HX(J)    = HX(J)+AXX   -CXX
      HY(J)    = HY(J)+AYY   -CYY
      HZ(J)    = HZ(J)+AZZ   -CZZ
*
      HX(K)    = HX(K)   +BXX+CXX
      HY(K)    = HY(K)   +BYY+CYY
      HZ(K)    = HZ(K)   +BZZ+CZZ
*
	VIX	= AX*AXX + BX*BXX + CX*CXX
	VIY	= AY*AYY + BY*BYY + CY*CYY
	VIZ	= AZ*AZZ + BZ*BZZ + CZ*CZZ
	VIRB	= VIRB + VIX+VIY+VIZ
	VIRFX	= VIRFX+VIX
	VIRFY	= VIRFY+VIY
	VIRFZ	= VIRFZ+VIZ
      END DO! OF N
*
      ELSE
*
CM    harmonic flexible SPC
      DO N     = TASKID+1,NSP,NUMTASK
      I        = (N-1)*NSS+IBB
      J        = (N-1)*NSS+JBB
      K        = (N-1)*NSS+KBB
*
      AX       = SX(J)-SX(I)
      AY       = SY(J)-SY(I)
      AZ       = SZ(J)-SZ(I)
*
      BX       = SX(K)-SX(I)
      BY       = SY(K)-SY(I)
      BZ       = SZ(K)-SZ(I)
*
      CX       = SX(K)-SX(J)
      CY       = SY(K)-SY(J)
      CZ       = SZ(K)-SZ(J)
*
      RRA      = AX*AX+AY*AY+AZ*AZ
      RRB      = BX*BX+BY*BY+BZ*BZ
      RRC      = CX*CX+CY*CY+CZ*CZ
*
      ASS      = DSQRT(RRA)
      BSS      = DSQRT(RRB)
      CSS      = DSQRT(RRC)
      COSA     = (AX*BX+AY*BY+AZ*BZ)/ASS/BSS
      ARG      = DACOS(COSA)
*
      SA       = ASS-ROH1
      SB       = BSS-ROH2
      SH       = CSS-RH1H2
*
      WB1      = AAA*SA*SA+EEE*SA*SH
      WB2      = BBB*SB*SB+FFF*SB*SH 
      WB3      = CCC*SH*SH+GGG*SA*SB
      WB       = WB1+WB2+WB3
*
      BR(I1)    = BR(I1)+ASS*FNSPI
      BR(I2)    = BR(I2)+BSS*FNSPI
      BR(I3)    = BR(I3)+CSS*FNSPI
*
      BE(I1)    = BE(I1)+WB1*FNSPI
      BE(I2)    = BE(I2)+WB2*FNSPI
      BE(I3)    = BE(I3)+WB3*FNSPI
      PINT	= PINT+WB1+WB2+WB3
*
      FB3A     = -2.0*AAA*SA - EEE*SH-GGG*SB
      FB3B     = -2.0*BBB*SB - FFF*SH-GGG*SA
      FB3C     = -2.0*CCC*SH - EEE*SA-FFF*SB
*
      FB3A     = FB3A/ASS
      FB3B     = FB3B/BSS
      FB3C     = FB3C/CSS
*
      AXX       = FB3A*AX
      AYY       = FB3A*AY
      AZZ       = FB3A*AZ
*
      BXX       = FB3B*BX
      BYY       = FB3B*BY
      BZZ       = FB3B*BZ
*
      CXX       = FB3C*CX
      CYY       = FB3C*CY
      CZZ       = FB3C*CZ
*
      HX(I)    = HX(I)-AXX-BXX                           
      HY(I)    = HY(I)-AYY-BYY
      HZ(I)    = HZ(I)-AZZ-BZZ
*
      HX(J)    = HX(J)+AXX   -CXX
      HY(J)    = HY(J)+AYY   -CYY
      HZ(J)    = HZ(J)+AZZ   -CZZ
*
      HX(K)    = HX(K)   +BXX+CXX
      HY(K)    = HY(K)   +BYY+CYY
      HZ(K)    = HZ(K)   +BZZ+CZZ
*                        
	VIX	= AX*AXX + BX*BXX + CX*CXX
	VIY	= AY*AYY + BY*BYY + CY*CYY
	VIZ	= AZ*AZZ + BZ*BZZ + CZ*CZZ
	VIRB	= VIRB + VIX+VIY+VIZ
	VIRFX	= VIRFX+VIX
	VIRFY	= VIRFY+VIY
	VIRFZ	= VIRFZ+VIZ
      END DO! OF N
*
      END IF
*
*      print *,bs(1)*fnspi
*     X       ,bs(2)*fnspi
*     X       ,bs(3)*fnspi
*
	RETURN
      END
*
