*=============== SLOW FORCES =============================================
*
      SUBROUTINE FORCES
*
*  LJ and Re-part of electrostatic interactions
*
      include "prcm.h"
*
      timel0	= cputime(0.d0)
	do I=1,NTYPES
	  PES141(I)=0.d0
	  PSR141(I)=0.d0
	end do
	do I=1,MOLINT
	  POTE1(I)=0.
	  POTL1(I)=0.
	end do
*
      IF(NTYPES.EQ.1.AND.NSPEC(1).EQ.1.or.MBLN.le.0) go to 100
*
* Sum over atom pairs
CM
CM   !!! Each node has its own neigbours list !!!
CM
      DO INP      = 1,MBLN           !  pair number
 	  ISP0=NBL1(INP)                !  atom number
	  JSP=NBL2(INP)
	  ISP=iabs(ISP0)
	  ITYP=ITYPE(ISP)              !  type number
	  JTYP=ITYPE(JSP)
	  ISB =NSITE(ISP)              !  site number
  	  JSB =NSITE(JSP)   
	  if(ISP0.le.0)then 
*    Case of 1-4 interactions
	    if(ITYP.ne.JTYP)write(*,*)
     +'!!! different mol. types for 1-4 interaction:',
     +ITYP,JTYP,ISP,JSP,' SF'
	    FCTLJ=C14LJ(ITYP)
*  begin LJ14-special
	    do I=1,NNAD 
	      ILA=ILJ(I)
	      if(ILA.eq.ISB)then  
	        do J=1,NNAD 
	          JLA=ILJ(J)
	          if(JLA.eq.JSB)then
                  EPSI       =  EPAD(I)*EPAD(J)
                  SIGM       =  SIGAD(I)+SIGAD(J)
                  go to 95
	          end if
	        end do
              EPSI       =  EPAD(I)*EPSIL(JSB)
              SIGM       =  SIGAD(I)+SIGMA(JSB)
              go to 95
	      end if
	    end do
	    do J=1,NNAD
	      JLA=ILJ(J)
	      if(JLA.eq.JSB)then
              EPSI       =  EPSIL(ISB)*EPAD(J)
              SIGM       =  SIGMA(ISB)+SIGAD(J)
              go to 95
	      end if
	    end do
          EPSI       =  EPSIL(ISB)*EPSIL(JSB)
          SIGM       =  SIGMA(ISB)+SIGMA(JSB)
 95	    A6= -EPSI*SIGM**6*FCTLJ    
	    B12= EPSI*SIGM**12*FCTLJ 
*  end LJ14-special
  	    QIJ=CHARGE(ISB)*CHARGE(JSB)*COULF*C14EL(ITYP)
	  else    ! normal case
          EPSI       =  EPSIL(ISB)*EPSIL(JSB)
          SIGM6       =  (SIGMA(ISB)+SIGMA(JSB))**6
          A6        = -EPSI*SIGM6
          B12       =  EPSI*SIGM6**2
  	    QIJ=CHARGE(ISB)*CHARGE(JSB)*COULF
	  end if
	  IMOL=NNUM(ISP)               !  molecule number
	  JMOL=NNUM(JSP)
	  MTR=MDX(ITYP,JTYP)
        DX           = SX(ISP)-SX(JSP)
        DY           = SY(ISP)-SY(JSP)
        DZ           = SZ(ISP)-SZ(JSP)
*                  call PBC(DX,DY,DZ)
        if(DX.gt. HBOXL)DX=DX-BOXL
        if(DX.lt.-HBOXL)DX=DX+BOXL
        if(DZ.gt. HBOZL)DZ=DZ-BOZL
        if(DZ.lt.-HBOZL)DZ=DZ+BOZL   
	  if(LHEX)then
C  hexagonal periodic cell)
	    XY=BOXYC*DX
          if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
            DY=DY-BOYL
            DX=DX-HBOXL
	    XY=BOXYC*DX
          end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
            DY=DY+BOYL
            DX=DX+HBOXL
	    XY=BOXYC*DX
          end if
          if(DY.gt.BOXY3+XY)then
            DY=DY-BOYL
            DX=DX+HBOXL
	    XY=BOXYC*DX
          end if
          if(DY.lt.-BOXY3+XY)then
            DY=DY+BOYL
            DX=DX-HBOXL
          end if
	  else                   
C  rectangular cell
          if(DY.gt. HBOYL)DY=DY-BOYL
          if(DY.lt.-HBOYL)DY=DY+BOYL
	  end if
	  if(LOCT)then
C  truncated octahedron abs(x)+abs(y)+abs(z) < 0.75*BOXL
	    CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	    DX=DX-sign(CORSS,DX)
	    DY=DY-sign(CORSS,DY)
	    DZ=DZ-sign(CORSS,DZ)
	  end if
*  
	  RR           = DX**2+DY**2+DZ**2
        R1           = DSQRT(RR)
        R2I          = 1.0D0/RR
	  R1I	   = R1*R2I
*  Electrostatic interaction
	  if(ISP0.le.0)then                             
	    if(LMOVE(ITYP))then
	      FORCE = EE1*R2I
	    else
	      FORCE=0.
	    end if 
	    EE1 = QIJ*R1I
	    EES = EE1
	  else
	    if(LMNBL)then
*  Reaction field
	      EE1 = QIJ*(R1I+RFF*RR)
	      EES = EE1
	      FORCE = QIJ*(R1I*R2I-RFF2)  
*   Ewald
	    else
            ALPHAR       = ALPHAD*R1
	      TTT          = 1.D0/(1.D0+B1*ALPHAR)
            EXP2A        = DEXP(-ALPHAR**2)
            ERFC = ((((A5*TTT+A4)*TTT+A3)*TTT+A2)*TTT+A1)*TTT*EXP2A
	      EE1	= QIJ*R1I
            EES          = EE1*ERFC
            FORCE        = EE1*(TOTPI*ALPHAR*EXP2A+ERFC)*R2I 
	    end if
	  end if
*  LJ interaction
	  R6I          = R2I*R2I*R2I
        ESR          = (     A6+      B12*R6I)*R6I
        FSR          = (6.D0*A6+12.D0*B12*R6I)*R6I*R2I
	  FORCE	= FORCE+FSR   
*  Energies
	  if(IMOL.eq.JMOL)then
	    if(LMOVE(ITYP))then
            PES141(ITYP) = PES141(ITYP)+EE1
            PSR141(ITYP) = PSR141(ITYP)+ESR
	      VIR1	= VIR1+FSR*RR
	      VIRX	= VIRX+FORCE*DX**2  
	      VIRY	= VIRY+FORCE*DY**2  
	      VIRZ	= VIRZ+FORCE*DZ**2  
	    end if
	  else			
	    POTE1(MTR)   = POTE1(MTR)+EE1
	    POTL1(MTR)    = POTL1(MTR)+ESR
	    VIR1	= VIR1+FSR*RR
	    VIRX	= VIRX+FORCE*DX**2  
	    VIRY	= VIRY+FORCE*DY**2  
	    VIRZ	= VIRZ+FORCE*DZ**2  
	  end if
	  PELS1        = PELS1+EES
	  PE1		= PE1+ESR                     
*	write(*,*)ISP,JSP,IMOL,JMOL,R1,ESR/EFACT,EES/EFACT
*  Forces
        GX(ISP)      = GX(ISP)+FORCE*DX     
        GY(ISP)      = GY(ISP)+FORCE*DY
        GZ(ISP)      = GZ(ISP)+FORCE*DZ
        GX(JSP)      = GX(JSP)-FORCE*DX
        GY(JSP)      = GY(JSP)-FORCE*DY
        GZ(JSP)      = GZ(JSP)-FORCE*DZ
*
      END DO! OF INP					
*
 100  timel	= timel+cputime(timel0) 
*
      RETURN
      END
*
*======================= LOCALF ==========================================
*
      SUBROUTINE LOCALF
*
*  LJ and electrostatic interactions of closest neigbours
*
      include "prcm.h"  
*
      times0	= cputime(0.d0)
	if(MBSH.le.0)return
      IF(NTYPES.EQ.1.AND.NSPEC(1).EQ.1) RETURN
	PELS1=0.
	PE1=0. 
	WIRSS=0.
	do I=1,MOLINT
	  POTE1(I)=0.
	  POTL1(I)=0.
	end do                   
	do I=1,NTYPES
	  PES141(I)=0.
	  PSR141(I)=0.
	end do
*
* Sum over atom pairs 
CM
CM     Local list of neigbours for each node
CM
      DO INP      = 1,MBSH
	  ISP0=NBS1(INP) 
	  ISP=iabs(ISP0)
	  JSP=NBS2(INP)
	  ITYP=ITYPE(ISP)
	  JTYP=ITYPE(JSP)
	  ISB =NSITE(ISP)
  	  JSB =NSITE(JSP)
	  if(ISP0.le.0)then  
*   Case of 1-4 interactions
	    if(ITYP.ne.JTYP)write(*,*)
     +'!!! different mol. types for 1-4 interaction:',
     +ITYP,JTYP,ISP,JSP,' FF'
	    FCTLJ=C14LJ(ITYP)
*  begin LJ14-special
	    do I=1,NNAD 
	      ILA=ILJ(I)
	      if(ILA.eq.ISB)then  
	        do J=1,NNAD 
	          JLA=ILJ(J)
	          if(JLA.eq.JSB)then
                  EPSI       =  EPAD(I)*EPAD(J)
                  SIGM       =  SIGAD(I)+SIGAD(J)
                  go to 195
	          end if
	        end do
              EPSI       =  EPAD(I)*EPSIL(JSB)
              SIGM       =  SIGAD(I)+SIGMA(JSB)
              go to 195
	      end if
	    end do
	    do J=1,NNAD
	      JLA=ILJ(J)
	      if(JLA.eq.JSB)then
              EPSI       =  EPSIL(ISB)*EPAD(J)
              SIGM       =  SIGMA(ISB)+SIGAD(J)
              go to 195
	      end if
	    end do
          EPSI       =  EPSIL(ISB)*EPSIL(JSB)
          SIGM       =  SIGMA(ISB)+SIGMA(JSB)
 195	    A6= -EPSI*SIGM**6*FCTLJ    
	    B12= EPSI*SIGM**12*FCTLJ 
*  end LJ14-special
  	    QIJ=CHARGE(ISB)*CHARGE(JSB)*COULF*C14EL(ITYP)
	    C10=0.d0
	  else
          EPSI       =  EPSIL(ISB)*EPSIL(JSB)
          SIGM       =  SIGMA(ISB)+SIGMA(JSB)
          A6         = -EPSI*SIGM**6
          IH	= IHYD(ISB)
	    JH	= IHYD(JSB)
	    TWLH = CHYD(IH,JH)*HYDF12
	    C10 = -DHYD(IH,JH)*HYDF10
          TTWL       =  EPSI*SIGM**12
          B12        =  TTWL+TWLH
  	    QIJ=CHARGE(ISB)*CHARGE(JSB)*COULF
	  end if
	  IMOL=NNUM(ISP)
	  JMOL=NNUM(JSP)
	  MTR=MDX(ITYP,JTYP)
        DX           = SX(ISP)-SX(JSP)
        DY           = SY(ISP)-SY(JSP)
        DZ           = SZ(ISP)-SZ(JSP)
*                  call PBC(DX,DY,DZ)
        if(DX.gt. HBOXL)DX=DX-BOXL
        if(DX.lt.-HBOXL)DX=DX+BOXL
        if(DZ.gt. HBOZL)DZ=DZ-BOZL
        if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	  if(LHEX)then
C  hexagonal periodic cell)
	    XY=BOXYC*DX
          if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
            DY=DY-BOYL
            DX=DX-HBOXL
	    XY=BOXYC*DX
          end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
            DY=DY+BOYL
            DX=DX+HBOXL
	    XY=BOXYC*DX
          end if
          if(DY.gt.BOXY3+XY)then
            DY=DY-BOYL
            DX=DX+HBOXL
	    XY=BOXYC*DX
          end if
          if(DY.lt.-BOXY3+XY)then
            DY=DY+BOYL
            DX=DX-HBOXL
          end if
	  else                   
C  rectangular cell
          if(DY.gt. HBOYL)DY=DY-BOYL
          if(DY.lt.-HBOYL)DY=DY+BOYL
	  end if
	  if(LOCT)then
C  truncated octahedron abs(x)+abs(y)+abs(z) < 0.75*BOXL
	    CORSS = HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	    DX=DX-sign(CORSS,DX)
	    DY=DY-sign(CORSS,DY)
	    DZ=DZ-sign(CORSS,DZ)
	  end if
*  
	  RR           = DX**2+DY**2+DZ**2
        R1           = DSQRT(RR)
        R2I          = 1.0D0/RR
	  R1I	   = R1*R2I
*  Electrostatic interaction
	  if(ISP0.le.0)then 
	    if(LMOVE(ITYP))then
	      EE1 = QIJ*R1I
	      FORCE = EE1*R2I
	    else
	      EE1 = QIJ*R1I
	      FORCE=0.
	    end if
	    EES = EE1
	  else
	    if(LMNBL)then
*  Reaction field
	      EE1 = QIJ*(R1I+RFF*RR)
	      EES = EE1
	      FORCE = QIJ*(R1I*R2I-RFF2)  
*   Ewald    
	    else
            ALPHAR       = ALPHAD*R1
	      TTT          = 1.D0/(1.D0+B1*ALPHAR)
            EXP2A        = DEXP(-ALPHAR**2)
            ERFC = ((((A5*TTT+A4)*TTT+A3)*TTT+A2)*TTT+A1)*TTT*EXP2A 
	      EE1	= QIJ*R1I
            EES          = EE1*ERFC
            FORCE        = EE1*(TOTPI*ALPHAR*EXP2A+ERFC)*R2I
	    end if
	  end if
	  if(IMOL.eq.JMOL)then
	    PES141(ITYP)=PES141(ITYP)+EE1
	  else
	    POTE1(MTR)    = POTE1(MTR)+EE1
	  end if 
	  PELS1=PELS1+EES
        PE1=PE1+EES
*  LJ interaction
	  if(A6.ne.0.d0.or.B12.ne.0.d0)then
	    R4I	  = R2I*R2I
          R6I   = R4I*R2I
	    EHD	  = C10*R4I
          ESR   = (     A6+      EHD+      B12*R6I)*R6I
          FSR   = (6.D0*A6+10.d0*EHD+12.D0*B12*R6I)*R6I*R2I
	    FORCE = FORCE+FSR
	    if(IMOL.eq.JMOL)then
	      if(LMOVE(ITYP))then
              PSR141(ITYP) = PSR141(ITYP)+ESR
              VIR1		= VIR1+FSR*RR
	      else
	        ESR=0.
	        FORCE=0.
 	      end if
	    else
	      POTL1(MTR)    = POTL1(MTR)+ESR
            VIR1		= VIR1+FSR*RR
	    end if                    
	    POTL1(MOLINT)= POTL1(MOLINT)+EHD*R6I
	    PE1		= PE1+ESR
	  end if
*	write(*,*)ISP,JSP,IMOL,JMOL,R1,ESR/EFACT,EES/EFACT
*  Forces
        HX(ISP)      = HX(ISP)+FORCE*DX
        HY(ISP)      = HY(ISP)+FORCE*DY
        HZ(ISP)      = HZ(ISP)+FORCE*DZ
        HX(JSP)      = HX(JSP)-FORCE*DX
        HY(JSP)      = HY(JSP)-FORCE*DY
        HZ(JSP)      = HZ(JSP)-FORCE*DZ 
	  VIRFX	= VIRFX+FORCE*DX**2  
	  VIRFY	= VIRFY+FORCE*DY**2  
	  VIRFZ	= VIRFZ+FORCE*DZ**2  
*
      END DO! OF INP					
      DO N         = 1,NSTOT
	  M	= NNUM(N)
        WIRSS	= WIRSS-HX(N)*(SX(N)-X(M))-HY(N)*(SY(N)-Y(M))-
     +               HZ(N)*(SZ(N)-Z(M))
      END DO! OF N
      times	= times+cputime(times0)
*
      RETURN
      END
*
*=============== FURIR =======================================
*
      SUBROUTINE FURIR
*  Receprocal Ewald summation
*
      include "prcm.h"
*     
	parameter (NKVM=10000,LTAB=50000) ! see also 2 next subroutines
	parameter (FKTX=1.05,FKTS=0.95)
      DIMENSION   TSIN(NTOT),TCOS(NTOT)
      dimension RX(NKVM),RY(NKVM),RZ(NKVM),AK(NKVM)
	common /TSNCS/ DTAB,SINT(0:LTAB),COST(0:LTAB)
      data INIT/0/
*
	timef0	= cputime(0.d0)
*
      if(INIT.eq.0)then 
        INIT=1 
	  BOXLO=BOXL
	  BOYLO=BOYL
	  BOZLO=BOZL
	  if(ALPHAD.gt.0.d0)then
          call INIFUR(RX,RY,RZ,NKV,BOXL,BOYL,BOZL,FEXP,ALPHAD,ICELL)
	    ALP2=ALPHAD**2
          if(TASKID.eq.MAST.and.IPRINT.ge.4)write(*,*)
     +'Ewald sum:  Num. of k-vectors ',NKV
        else
	    NKV=0
          if(TASKID.eq.MAST.and..not.LMNBL)write(*,*)
     +'No Ewald'
	  end if
	end if     
      IF(NTYPES.EQ.1.AND.NSPEC(1).EQ.1) RETURN
	if(NKV.eq.0)return
	DBX=BOXL/BOXLO
	DBY=BOYL/BOYLO
	DBZ=BOZL/BOZLO
	if(DBX.gt.FKTX.or.DBX.lt.FKTS.or.DBY.gt.FKTX.or.
     *   DBY.lt.FKTS.or.DBZ.gt.FKTX.or.DBZ.lt.FKTS)then
	  BOXLO=BOXL
	  BOYLO=BOYL
	  BOZLO=BOZL
        call INIFUR(RX,RY,RZ,NKV,BOXL,BOYL,BOZL,FEXP,ALPHAD,ICELL)
	    ALP2=ALPHAD**2
          if(TASKID.eq.MAST.and.IPRINT.ge.4)write(*,*)
     +'Box size changed. New num. of k-vectors ',NKV
      end if
*
      QSS         = 0.D0
      DO ITYP     = 1,NTYPES
        QSS         = QSS+QSUM(ITYP)
      END DO! OF ITYP
      IF(QSS.EQ.0.D0) RETURN
*
      QPE         = 0.D0
      CFUR=4.d0*PI*COULF/VOL     
*
*   reciprocal space Evald
CM
	IBEG=NUMTASK-TASKID
      do IKV=IBEG,NKV,NUMTASK
        RXV=RX(IKV)/BOXL
        RYV=RY(IKV)/BOYL
        RZV=RZ(IKV)/BOZL 
	  if(LHEX)then
	    RK2=1.3333333333333*RXV**2+RYV**2+RZV**2
	  else
	    RK2=RXV**2+RYV**2+RZV**2
	  end if
        SCS=0.
        SSN=0.
        do I=1,NSTOT       
	    if(LHEX)then
            SCP=RXV*SX(I)+(RXV/SQ3+RYV)*SY(I)+RZV*SZ(I)
	    else
            SCP=RXV*SX(I)+RYV*SY(I)+RZV*SZ(I)
	    end if  
*  sin and cos from tables
*          SINSC=Q(I)*sin(SCP)
*          COSSC=Q(I)*cos(SCP)
	    if(SCP.le.0.d0)then
	      XT=-SCP*DTAB
	      IID=1
          else
	      XT=SCP*DTAB
	      IID=0
	    end if
	    IOT=idint(XT)
	    IU=mod(IOT,LTAB)                             
	    IU1=IU+1
	    DD=XT-dfloat(IOT) 
	    DD1=1.d0-DD
          SINSC=Q(I)*(DD1*SINT(IU)+DD*SINT(IU1))
          COSSC=Q(I)*(DD1*COST(IU)+DD*COST(IU1))
	    if(IID.ne.0)SINSC=-SINSC
          TSIN(I)=SINSC
          TCOS(I)=COSSC
          SSN=SSN+SINSC
          SCS=SCS+COSSC
        end do
        AKC=CFUR*exp(-0.25d0*RK2/ALP2)/RK2
        QPE=QPE+AKC*(SSN**2+SCS**2)
        AK2=2.d0*AKC
        do I=1,NSTOT
          QFOR=AK2*(SCS*TSIN(I)-SSN*TCOS(I))
          GX(I)=GX(I)+RXV*QFOR
          GY(I)=GY(I)+RYV*QFOR
          if(LHEX)GY(I)=GY(I)+(RXV/SQ3)*QFOR
          GZ(I)=GZ(I)+RZV*QFOR
        end do
	  AKV=0.5*AKC*(4.*ALP2+RK2)/(ALP2*RK2) 
	  if(LHEX)then
	    VIRX=VIRX-1.3333333333*RXV**2*AKV*(SSN**2+SCS**2) 
	  else
	    VIRX=VIRX-RXV**2*AKV*(SSN**2+SCS**2) 
	  end if
	  VIRY=VIRY-RYV**2*AKV*(SSN**2+SCS**2)
	  VIRZ=VIRZ-RZV**2*AKV*(SSN**2+SCS**2)
      end do  
	VIRX=VIRX+QPE
	VIRY=VIRY+QPE
	VIRZ=VIRZ+QPE
	PELS1=PELS1+QPE
      timef	= timef+cputime(timef0)
      return
      end
*
*================= INIFUR =========================================
*
      subroutine INIFUR
     +(RX,RY,RZ,NKV,BOXL,BOYL,BOZL,FEXP,ALPHAD,ICELL) 
	implicit real*8 (A-H,O-Z)
      parameter (NKVM=10000,PI=3.1415926536)
      dimension RX(NKVM),RY(NKVM),RZ(NKVM)
	call SINTAB
	ALP2=ALPHAD**2
      CUTK2=4.d0*ALP2*FEXP
	CUTK=sqrt(CUTK2)
      TWOPI=2.d0*PI
      IKV=0
	KMAX=CUTK*BOXL/TWOPI+1
	KMAY=CUTK*BOYL/TWOPI+1
	KMAZ=CUTK*BOZL/TWOPI+1
      do IKZ=-KMAZ,KMAZ
        do IKX=0,KMAX
          if(IKX.eq.0)then
            if(IKZ.gt.0)then
              KY1=0
            else
              KY1=1
            end if
            KY2=KMAY
          else
            KY1=-KMAY
            KY2=KMAY
          end if
          do IKY=KY1,KY2 
	      if(ICELL.eq.2)then
              RK2=1.3333333333333333333*(IKX*TWOPI/BOXL)**2+
     +              (IKY*TWOPI/BOYL)**2+(IKZ*TWOPI/BOZL)**2
	      else
              RK2=(IKX*TWOPI/BOXL)**2+(IKY*TWOPI/BOYL)**2+
     +          (IKZ*TWOPI/BOZL)**2
	      end if
            if(RK2.le.CUTK2)then
      	IKV=IKV+1
              if(IKV.gt.NKVM)stop 
     +'increase NKVM in INIFUR or check input Ewald parameters'
              RX(IKV)=IKX*TWOPI
              RY(IKV)=IKY*TWOPI
              RZ(IKV)=IKZ*TWOPI
            end if
          end do
        end do
      end do      
      NKV=IKV
      return	
      end
*=========================== SINTAB =================================
*                                                                    
	subroutine SINTAB
	implicit real*8 (A-H,O-Z)
	parameter (PI= 3.1415926535897932d0, PI2=2.d0*PI, LTAB=50000)
	common /TSNCS/ DTAB,SINT(0:LTAB),COST(0:LTAB)
	do I=0,LTAB 
	  X=dfloat(I)*PI2/LTAB         
	  sint(I)=sin(X)
	  cost(I)=cos(X)
	end do 
	DTAB=dfloat(LTAB)/PI2
	return
	end
*
*============= ETERMS =================================================
*
      SUBROUTINE ETERMS
*
      include"prcm.h"         
	real*8 SPEEI(NTPS)
	data INIT/0/  
	save SPEEI,SPEI,ABC,INIT
*
      timee0	= cputime(0.d0)
      WIRF=0.                             
	if(LMNBL)return
*   electrostatic self-interaction
	if(INIT.eq.0)then
	  INIT=1
        ABC = ALPHAD/DSQRT(PI)
	  SPEI=0.
        do ITYP=1,NTYPES 
	    SPET=0.
	    do I=1,NSITS(ITYP)
	      IS=ISADR(ITYP)+I
  	      QII=COULF*CHARGE(IS)**2
            SPET         = SPET-NSPEC(ITYP)*ABC*QII
	    end do         
	    SPET=SPET/NUMTASK
	    SPEEI(ITYP)=SPET
	    SPEI=SPEI+SPET
	  end do
	end if       
	do I=1,NTYPES
	  SPEE(I)=SPEEI(I)
	end do            
	SPE=SPEI
*     
	IBEG=NUMTASK-TASKID 
	do ISP=IBEG,NSTOT,NUMTASK
	  NSP = NNBB(ISP)
	  do J=1,NSP
	    JSP=    INBB(ISP,J)
	    if(JSP.le.0)JSP=-JSP
	    if(ISP.gt.JSP)then  ! avoid double count!
	    IS	= NSITE(ISP)
	    JS	= NSITE(JSP)
	    ITYP  = ITYPE(ISP)
  	    QIJ=COULF*CHARGE(IS)*CHARGE(JS)
          DX          = SX(ISP)-SX(JSP)
          DY          = SY(ISP)-SY(JSP)
          DZ          = SZ(ISP)-SZ(JSP)
          if(DX.gt. HBOXL)DX=DX-BOXL
          if(DX.lt.-HBOXL)DX=DX+BOXL
	    if(LHEX)then
C  hexagonal periodic cell)
	      XY=BOXYC*DX
            if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
              DY=DY-BOYL
              DX=DX-HBOXL
	      XY=BOXYC*DX
            end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
              DY=DY+BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.gt.BOXY3+XY)then
              DY=DY-BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.lt.-BOXY3+XY)then
              DY=DY+BOYL
              DX=DX-HBOXL
            end if
	    else                   
C  rectangular cell
            if(DY.gt. HBOYL)DY=DY-BOYL
            if(DY.lt.-HBOYL)DY=DY+BOYL
	    end if
          if(DZ.gt. HBOZL)DZ=DZ-BOZL
          if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	    if(LOCT)then
	      CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	      DX=DX-sign(CORSS,DX)
	      DY=DY-sign(CORSS,DY)
	      DZ=DZ-sign(CORSS,DZ)
	    end if
*	  call PBC(DX,DY,DZ)
          R2          = DX**2+DY**2+DZ**2
          R2I         = 1.D0/R2
          R1          = DSQRT(R2)
          R1I         = R1*R2I
          ALPHAR      = ALPHAD*R1
*  	          call RERFC(ALPHAR,ERFC,EXP2A)
          TTT         = 1.D0/(1.D0+B1*ALPHAR)
          EXP2A       = DEXP(-ALPHAR**2)
          ERFC = ((((A5*TTT+A4)*TTT+A3)*TTT+A2)*TTT+A1)*TTT*EXP2A
          EES  = QIJ*(ERFC-1.d0)*R1I
          FES  = QIJ*((TOTPI*ALPHAR*EXP2A+ERFC)-1.d0)*R1I*R2I
          GX(ISP)     = GX(ISP)+FES*DX
          GY(ISP)     = GY(ISP)+FES*DY
          GZ(ISP)     = GZ(ISP)+FES*DZ
          GX(JSP)     = GX(JSP)-FES*DX
          GY(JSP)     = GY(JSP)-FES*DY
          GZ(JSP)     = GZ(JSP)-FES*DZ
          SPE         = SPE+EES
	    SPEE(ITYP)  = SPEE(ITYP)+EES
	    VIRX	= VIRX+FES*DX**2  
	    VIRY	= VIRY+FES*DY**2  
	    VIRZ	= VIRZ+FES*DZ**2  
          WIRF	    = WIRF-2.d0*QIJ*ABC*EXP2A-EES
	    end if
	  end do 
      END DO! OF I
*
 100  timee	= timee+cputime(timee0)
	RETURN
      END
*                 
*============= ELRCLJ =================================================
*
      SUBROUTINE ELRCLJ
*
*   long-range corrections to LJ energy and pressure
*
      include"prcm.h" 
	dimension PELRC0(NTPP),VRLRC0(NTPP)
      data INIT/0/
*     
	if(INIT.eq.0)then                                
      DO I        = 1,MOLINT
      PELRC0(I)    = 0.D0
      VRLRC0(I)    = 0.D0
      END DO! OF I
      FAC       = ENERF*1.D-3/DFLOAT(NOP)
*
      RC          = DSQRT(RSSQ)
      DO 400 ITYP = 1    ,NTYPES
      ISBEG       = ISADR(ITYP)+1
      ISEND       = ISADR(ITYP +1)
      NSPI        = NSPEC(ITYP)
      DO 400   IS = ISBEG,ISEND
      DO 300 JTYP = ITYP ,NTYPES
      MT          = MDX  (ITYP,JTYP)
      JSBEG       = ISADR(JTYP)+1
      JSEND       = ISADR(JTYP +1)
      NSPJ        = NSPEC(JTYP)
      FNOPIJ      = DFLOAT(NSPI*NSPJ)
      DO 300   JS = JSBEG,JSEND  
        EP       =   EPSIL(IS)*EPSIL(JS)
	  if(EP.gt.1.d-20)then
	  SI3	= (SIGMA(IS)+SIGMA(JS))**3     ! SI**3      
      PELRC0(MT)   = PELRC0(MT)+EP*SI3*(( 1.D0/9.D0)*(SI3/RC**3)**3
     X                                - ( 1.D0/3.D0)*(SI3/RC**3))*FNOPIJ
      VRLRC0(MT)   = VRLRC0(MT)+EP*SI3*((-4.D0/3.D0)*(SI3/RC**3)**3
     X                                + (      2.D0)*(SI3/RC**3))*FNOPIJ
	  end if
  300 CONTINUE
  400 CONTINUE         
	end if
*
      FCV	= UNITP/(3.*VOL)
      PELR	= 0.
      VIRD	= 0.
      DO I      = 1,MOLINT
        PELRC(I)  = PELRC0(I)/VOL
        VRLRC(I)  = -VRLRC0(I)/VOL
        PELR=PELR+PELRC(I)
        VIRD=VIRD+VRLRC(I)
        if(INIT.eq.0.and.IPRINT.ge.5)then
        PRINT "('*** PE  LRC ',I2,': ',F12.8,' kJ/mol')",I,PELRC(I)*FAC
        PRINT "('*** PR  LRC ',I2,': ',F12.4,' atm   ')",I,VRLRC(I)*FCV
        INIT=1
        end if
      END DO
*
      RETURN
      END
*
*================ CHCNB =======================================================
*     
	subroutine CHCNB(LRDF)     
	include "prcm.h"
	logical LGRC,LRDF 
      parameter (RMX2=5.**2,MMOL=5)
	data INIT/0/ 
*  List of  neigbours 
	timev0	= cputime(0.d0)
	MBLN=0
	MBSH=0
	LGRC=LGR.and.LRDF.and.(NHIST+1.ge.IHIST)
	IBEG=NUMTASK-TASKID 
	do I=IBEG,NSTOT,NUMTASK
	  IMOL=NNUM(I) 
	  ITYP=ITYPE(I)
*   Even strips
        do J=I-2,1,-2
	    JMOL=NNUM(J)
	    DX=SX(I)-SX(J)
	    DY=SY(I)-SY(J)
	    DZ=SZ(I)-SZ(J)
*	    call PBC (DX,DY,DZ)
	    if(DX.gt. HBOXL)DX=DX-BOXL
          if(DX.lt.-HBOXL)DX=DX+BOXL
          if(DZ.gt. HBOZL)DZ=DZ-BOZL
          if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	    if(LHEX)then
C  hexagonal periodic cell)
	      XY=BOXYC*DX
            if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
              DY=DY-BOYL
              DX=DX-HBOXL
	      XY=BOXYC*DX
            end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
              DY=DY+BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.gt.BOXY3+XY)then
              DY=DY-BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.lt.-BOXY3+XY)then
              DY=DY+BOYL
              DX=DX-HBOXL
            end if
	    else                   
C  rectangular cell
            if(DY.gt. HBOYL)DY=DY-BOYL
            if(DY.lt.-HBOYL)DY=DY+BOYL
	    end if
	    if(LOCT)then
C  truncated octahedron abs(x)+abs(y)+abs(z) < 0.75*BOXL
	      CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	      DX=DX-sign(CORSS,DX)
	      DY=DY-sign(CORSS,DY)
	      DZ=DZ-sign(CORSS,DZ)
	    end if                  
*  square distance betwen atoms
	    RR2=DX**2+DY**2+DZ**2  
*  If we do not use Ewald summation (LMNBL=.true.), 
*  it is important that at least
*  small molecules (less than MMOL atoms) where inside or outside
*  cut-off radius as a whole 
	    if(LMNBL)then
	      NMI=NSITS(ITYP) 
	      NMJ=NSITS(ITYPE(J))
	      if(NMI.gt.MMOL.and.NMJ.gt.MMOL)then
		RRM=RR2
		go to 110
	      else if(NMI.gt.MMOL.and.NMJ.le.MMOL)then
	        DX=SX(I)-X(JMOL)
	        DY=SY(I)-Y(JMOL)
	        DZ=SZ(I)-Z(JMOL)
	      else if(NMJ.gt.MMOL)then
	        DX=X(IMOL)-SX(J)
	        DY=Y(IMOL)-SY(J)
	        DZ=Z(IMOL)-SZ(J)
	      else 
	        DX=X(IMOL)-X(JMOL)
	        DY=Y(IMOL)-Y(JMOL)
	        DZ=Z(IMOL)-Z(JMOL)
	      end if
*	      call PBC (DX,DY,DZ)
	      if(DX.gt. HBOXL)DX=DX-BOXL
            if(DX.lt.-HBOXL)DX=DX+BOXL
            if(DZ.gt. HBOZL)DZ=DZ-BOZL
            if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	      if(LHEX)then
C  hexagonal periodic cell)
	        XY=BOXYC*DX
            if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
                DY=DY-BOYL
                DX=DX-HBOXL
	        XY=BOXYC*DX
              end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
                DY=DY+BOYL
                DX=DX+HBOXL
	        XY=BOXYC*DX
              end if
              if(DY.gt.BOXY3+XY)then
                DY=DY-BOYL
                DX=DX+HBOXL
	        XY=BOXYC*DX
              end if
              if(DY.lt.-BOXY3+XY)then
                DY=DY+BOYL
                DX=DX-HBOXL
              end if
	      else                   
C  rectangular cell
              if(DY.gt. HBOYL)DY=DY-BOYL
              if(DY.lt.-HBOYL)DY=DY+BOYL
	      end if
	      if(LOCT)then
C  truncated octahedron abs(x)+abs(y)+abs(z) < 0.75*BOXL
	        CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	        DX=DX-sign(CORSS,DX)
	        DY=DY-sign(CORSS,DY)
	        DZ=DZ-sign(CORSS,DZ)
	      end if                  
*  square distance betwen COM of small molecules
	      RRM=DX**2+DY**2+DZ**2 
	    else   ! .not.LMNBL
	      RRM=RR2              
	    end if
 110	    if(IMOL.eq.JMOL)then    ! bound atoms should not be in the list
	      if(RR2.le.RMX2)then
*   Check that the atoms are non-bound
	      if(NNBB(I).le.NNBB(J))then
		do K=1,NNBB(I) 
*   1-3 bound
		  if(INBB(I,K).eq.J)go to 125
                if(INBB(I,K).eq.-J.and.L14NB(ITYP))then
*   1-4 bound                                     
	            MBSH=MBSH+1
	            if(MBSH.gt.NBSMAX)write(*,*)
     +        '!!! list of closest neigbours overfilled. atoms ',I,J
	            NBS1(MBSH)=-I
		    NBS2(MBSH)=J
	            go to 125
		  end if  
	  	end do
	      else
		do K=1,NNBB(J) 
*   1-3 bound
		  if(INBB(J,K).eq.I)go to 125
                if(INBB(J,K).eq.-I.and.L14NB(ITYP))then
*   1-4 bound                                     
	            MBSH=MBSH+1
	            if(MBSH.gt.NBSMAX)write(*,*)
     +        '!!! list of closest neigbours overfilled. atoms ',I,J
	            NBS1(MBSH)=-I
		    NBS2(MBSH)=J 
	            go to 125
		  end if  
	  	end do
	      end if
	      end if ! (RR2.le.RMAX2
	    end if   ! (IMOL.eq.JMOL
	    if(RRM.le.SHORT2)then
	      MBSH=MBSH+1
	      if(MBSH.gt.NBSMAX)write(*,*)
     +      '!!! list of closest neigbours overfilled. atoms ',I,J
	      NBS1(MBSH)=I
	      NBS2(MBSH)=J
	    else if(RRM.le.RSSQ)then
	      MBLN=MBLN+1
	      if(MBLN.gt.NBLMAX)write(*,*)
     +     '!! list of far neigbours overfilled'
	      NBL1(MBLN)=I
	      NBL2(MBLN)=J
	    end if
*   RDF calculation
 125      IF(LGRC.and.RR2.le.RDFCUT2) THEN			!=====> LGR
	      ISB	= NSITE(J)
	      JSB	= NSITE(I) 
	      if(NGRI(ISB).le.NGRI(JSB))then
		do JS=1,NGRI(ISB) 
		  if(IGRI(ISB,JS).eq.JSB)then 
		    IP = MGRI(ISB,JS)
	            go to 127  
		  end if
		end do
	      else
		do JS=1,NGRI(JSB)
		  if(IGRI(JSB,JS).eq.ISB)then
		    IP = MGRI(JSB,JS)
	            go to 127
		  end if  
		end do         
	      end if  
	      go to 128
*  find RDF pair
 127	      R1	= sqrt(RR2)
            GG        = R1*DRDFI
	      MM        = IDINT(GG)+1
            if(MM.le.MAX)IRDF(MM,IP) = IRDF(MM,IP)+1
	    end if ! of LGRC
 128	    continue
	  end do
*   Odd strips    
        do J=I+1,NSTOT,2
	    JMOL=NNUM(J)
	    DX=SX(I)-SX(J)
	    DY=SY(I)-SY(J)
          DZ=SZ(I)-SZ(J)
*	    call PBC (DX,DY,DZ)
	    if(DX.gt. HBOXL)DX=DX-BOXL
          if(DX.lt.-HBOXL)DX=DX+BOXL
          if(DZ.gt. HBOZL)DZ=DZ-BOZL
          if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	    if(LHEX)then
C  hexagonal periodic cell)
	      XY=BOXYC*DX
            if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
              DY=DY-BOYL
              DX=DX-HBOXL
	      XY=BOXYC*DX
            end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
              DY=DY+BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.gt.BOXY3+XY)then
              DY=DY-BOYL
              DX=DX+HBOXL
	      XY=BOXYC*DX
            end if
            if(DY.lt.-BOXY3+XY)then
              DY=DY+BOYL
              DX=DX-HBOXL
            end if
	    else                   
C  rectangular cell
            if(DY.gt. HBOYL)DY=DY-BOYL
            if(DY.lt.-HBOYL)DY=DY+BOYL
	    end if
	    if(LOCT)then
C  truncated octahedron abs(x)+abs(y)+abs(z) < 0.75*BOXL
	      CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	      DX=DX-sign(CORSS,DX)
	      DY=DY-sign(CORSS,DY)
	      DZ=DZ-sign(CORSS,DZ)
	    end if
          RR2=DX**2+DY**2+DZ**2
	    if(LMNBL)then
	      NMI=NSITS(ITYP) 
	      NMJ=NSITS(ITYPE(J))
	      if(NMI.gt.MMOL.and.NMJ.gt.MMOL)then
		RRM=RR2
		go to 130
	      else if(NMI.gt.MMOL.and.NMJ.le.MMOL)then
	        DX=SX(I)-X(JMOL)
	        DY=SY(I)-Y(JMOL)
	        DZ=SZ(I)-Z(JMOL)
	      else if(NMJ.gt.MMOL)then
	        DX=X(IMOL)-SX(J)
	        DY=Y(IMOL)-SY(J)
	        DZ=Z(IMOL)-SZ(J)
	      else 
	        DX=X(IMOL)-X(JMOL)
	        DY=Y(IMOL)-Y(JMOL)
	        DZ=Z(IMOL)-Z(JMOL)
	      end if
*	      call PBC (DX,DY,DZ)
	      if(DX.gt. HBOXL)DX=DX-BOXL
            if(DX.lt.-HBOXL)DX=DX+BOXL
            if(DZ.gt. HBOZL)DZ=DZ-BOZL
            if(DZ.lt.-HBOZL)DZ=DZ+BOZL
	      if(LHEX)then
C  hexagonal periodic cell)
	        XY=BOXYC*DX
            if(DY.gt.BOXY3-XY.and.(DX.gt.0..or.DY.gt.2.*BOXY3-XY))then
                DY=DY-BOYL
                DX=DX-HBOXL
	        XY=BOXYC*DX
              end if
          if(DY.lt.-BOXY3-XY.and.(DX.lt.0..or.DY.lt.-2.*BOXY3-XY))then
                DY=DY+BOYL
                DX=DX+HBOXL
	        XY=BOXYC*DX
              end if
              if(DY.gt.BOXY3+XY)then
                DY=DY-BOYL
                DX=DX+HBOXL
	        XY=BOXYC*DX
              end if
              if(DY.lt.-BOXY3+XY)then
                DY=DY+BOYL
                DX=DX-HBOXL
              end if
	      else                   
C  rectangular cell
              if(DY.gt. HBOYL)DY=DY-BOYL
              if(DY.lt.-HBOYL)DY=DY+BOYL
	      end if
	      if(LOCT)then
C  truncated octahedron abs(x)+abs(y)+abs(z) < 0.75*BOXL
	        CORSS=HBOXL*int((4./3.)*(abs(DX)+abs(DY)+abs(DZ))/BOXL)
	        DX=DX-sign(CORSS,DX)
	        DY=DY-sign(CORSS,DY)
	        DZ=DZ-sign(CORSS,DZ)
	      end if                  
*  square distance betwen COM of small molecules
	      RRM=DX**2+DY**2+DZ**2 
	    else
	      RRM=RR2              
	    end if
 130	    if(IMOL.eq.JMOL)then 
	      if(RR2.le.RMX2)then
*   Check that the atoms are non-bound
	      if(NNBB(I).le.NNBB(J))then
		do K=1,NNBB(I) 
*   1-3 bound
		  if(INBB(I,K).eq.J)go to 135
                if(INBB(I,K).eq.-J.and.L14NB(ITYP))then
*   1-4 bound                                     
	            MBSH=MBSH+1
	            if(MBSH.gt.NBSMAX)write(*,*)
     +        '!!! list of closest neigbours overfilled. atoms ',I,J
	            NBS1(MBSH)=-I
		    NBS2(MBSH)=J
	            go to 135
		  end if  
	  	end do
	      else      
		do K=1,NNBB(J) 
*   1-3 bound
		  if(INBB(J,K).eq.I)go to 135
                if(INBB(J,K).eq.-I.and.L14NB(ITYP))then
*   1-4 bound                                     
	            MBSH=MBSH+1
	            if(MBSH.gt.NBSMAX)write(*,*)
     +        '!!! list of closest neigbours overfilled. atoms ',I,J
	            NBS1(MBSH)=-I
		    NBS2(MBSH)=J
	            go to 135
		  end if  
	  	end do
	      end if   ! if(NNB
	      end if   ! RR2.le
	    end if     ! IMOL.eq.JMOL
	    if(RRM.le.SHORT2)then
	      MBSH=MBSH+1
	      if(MBSH.gt.NBSMAX)then
              write(*,*)
     +'!!! list of closest neigbours overfilled, atoms ',I,J,TASKID   
	        stop
	      end if
	      NBS1(MBSH)=J
	      NBS2(MBSH)=I
	    else if(RRM.le.RSSQ)then
	      MBLN=MBLN+1
	      if(MBLN.gt.NBLMAX)write(*,*)
     +     '!!! list of far neigbours overfilled',TASKID
	      NBL1(MBLN)=J
	      NBL2(MBLN)=I
	    end if
*   RDF calculation
 135      IF(LGRC.and.RR2.le.RDFCUT2) THEN			!=====> LGR
	      ISB	= NSITE(J)
	      JSB	= NSITE(I) 
	      if(NGRI(ISB).le.NGRI(JSB))then
		do JS=1,NGRI(ISB) 
		  if(IGRI(ISB,JS).eq.JSB)then 
		    IP = MGRI(ISB,JS)
	            go to 137  
		  end if
		end do
	      else
		do JS=1,NGRI(JSB)
		  if(IGRI(JSB,JS).eq.ISB)then
		    IP = MGRI(JSB,JS)
	            go to 137
		  end if  
		end do         
	      end if  
	      go to 138
*  find RDF pair
 137	      R1	= sqrt(RR2)
            GG        = R1*DRDFI
	      MM        = IDINT(GG)+1
            if(MM.le.MAX)IRDF(MM,IP) = IRDF(MM,IP)+1
	    end if ! of LGRC
 138	    continue 
	  end do
	end do 
	if(LGRC)NRDF=NRDF+1 
      timev	= timev+cputime(timev0)
	if(IPRINN.lt.7)return
	write(*,*)' Task ',TASKID,
     +'total num.of interactions: ',MBSH,' and ',MBLN
	return
	end
