      PROGRAM MD
*
      include "prcm.h"
*-----------------------------------------------
      DIMENSION  QP(4)
	character*80 AUX,TAKESTR
      character*20 FNM, DATE*8,FINP*24
	logical LMA
      label = "MDYN_v4.2   "
	DATE  = '17.08.97'
CM    
	call PARAINI(numtask,taskid) 
	MAST=NUMTASK-1
CM
	if(TASKID.eq.MAST)then
        write(*,*)'*** MOLECULAR DYNAMICS',
     X' PROGRAM FOR MIXTURES OF RIGID or FLEXIBLE MOLECULES'
        write(*,*)'*** ',
     X '         BASED ON TWO TIME STEP METHOD BY TUCKERMAN ET AL.'
	  write(*,*)
	  if(NUMTASK.gt.1)then
	  write(*,*)' Parallel version for connected machines '
        write(*,*)' Running on ',NUMTASK,' processors'
        write(*,*)   
	  end if
	  write(*,*)'Version ',label,'           from ',DATE
        write(*,*)
      end if
	time0	= cputime(0.d0)
*
*Some control parameters
*
      BDTOL      = 0.0001   ! for constrained dynamics    
	do I=1,NTCF+4
	  ITCF(I)=0            ! which tcf calculate
	end do
      MSTEP      =  0 
*
      DO I       = 1,NTPS
        NRA(I)=0
        NRB(I)=0
        NRT(I)     = 0
        NRI(I)     = 0
	  LIST(I)    = 1  
	  N1(I)	= 1
	  N2(I) = 2 
	  IINIT(I)=0
	  LMOVE(I)=.true.  
	  L15NB(I)=.true.
      END DO  
	do I=1,NS
	  IHYD(I)=0
	end do
*
*Read in input data
*     
	call INPUT                            ! readmol.f
	IPRINN=IPRINT
      if(TASKID.ne.MAST)IPRINT=0
	if(.not.LRST) L0AVS=.true.
*
*   file names
*     
	IC=1
      do I=1,20
        if(FNAME(I:I).ne.' ')IC=I
      end do   
	if(MAX.gt.MAXS)stop ' increase MAXS in prcm.h'
      IC1=IC+1
      IC2=IC+4
	ICFN=IC+2
      FNM='                    '
	write(FDUMP,'(24(1h  ))')
	write(FLST,'(24(1h  ))')
	write(FRDF,'(24(1h  ))')
	write(FTCF,'(24(1h  ))')
	write(FTRK,'(24(1h  ))')
      write(FMOL,'(24(1h  ))')
      write(FINP,'(24(1h  ))')
      FNM(1:IC)=FNAME(1:IC)
      FDUMP(1:IC)=FNM
      FDUMP(IC1:IC2)='.dmp'
      FLST(1:IC)=FNM
      FLST(IC1:IC2)='.lst'
      FRDF(1:IC)=FNM
      FRDF(IC1:IC2)='.rdf'
      FTCF(1:IC)=FNM
      FTCF(IC1:IC2)='.tcf'
      FMOL(1:IC)=FNM
      FMOL(IC1:IC2)='.car'
      FTRK(1:IC)=FNM
      FTRK(IC1:IC2)='.000'  
      FINP(1:IC)=FNM
      FINP(IC1:IC2)='.inp'  
	if(IPRINT.ge.8)then
	  write(*,*)' file names:'
	  write(*,*)FDUMP
	  write(*,*)FLST
	  write(*,*)FRDF
	  write(*,*)FMOL
	  write(*,*)FTRK
	end if
	NTREK	= TTREK/DT+0.5    
	if(NTREK.le.0)NTREK=1
	BOXLN=BOXL
	BOYLN=BOYL
	BOZLN=BOZL
	RHON=RHO  
	RRLL=RLR
*
*---------------- DEFINE MOLECULE TYPES -------------------------------
*
      SUMM         = 0.
      NRBB         = 0
      NRAA         = 0
      NRTT         = 0
      NX           = 0
      IADB(1)      = 1
      IADA(1)      = 1
      IADT(1)      = 1
      TOTMAS       = 0.
	TOTCH	= 0. 
	NHYDB	= 0   
	NNAD=0
	NTYP	= 0         
	IE	= 0
	do I=0,NHYD
	  do J=0,NHYD
	    CHYD(I,J)=0.
	    DHYD(I,J)=0.
	  end do
	end do   
	NHDM=0
*
*  Input of molecules from data base
*     
	if(TASKID.eq.MAST)write(*,*)
     +'--------------------------------------------------------------'
	do ITYP=1,NTYPES
        CALL READMOL (SUMM,NX,NTYP,NAMOL(ITYP))
        TOTMAS       = TOTMAS+SUMM*NSPEC(ITYP)
        SUMMAS(ITYP) = SUMM 
	  NAME(ITYP)=NAMOL(ITYP)(1:6)
      end do
	if(NHDM.le.0)NHDM=1
	if(NHYDB.gt.0)call HYDRO
*     
	NTYP=NTYPES
	if(IPRINT.ge.5)write(*,*)
     +'--------------------------------------------------------------'
*
      IF(NTYPES.EQ.0.OR.NTYPES.NE.NTYP) THEN
        if(TASKID.eq.MAST)  
     +  PRINT "(/'??? NTYPES = ',I2,'  ---SET TO: ',I2)",NTYPES,NTYP
        NTYPES = NTYP
      END IF
*
      IF(NX  .GT.NS  ) STOP '!!! INCREASE NS   !'
      IF(NTYP.GT.NTPS) STOP '!!! INCREASE NTPS !'
      IF(NRBB.GT.NB  ) STOP '!!! INCREASE NB   !'
      IF(NRAA.GT.NA  ) STOP '!!! INCREASE NA   !'
      IF(NRTT.GT.NT  ) STOP '!!! INCREASE NT   !'
      IF(TOTMAS.EQ.0 ) STOP '!!! NO PARTICLES WITH MASSES DEFINED !'
*
      IF(LSHEJK) THEN
        NFREQ = 1 
	  if(TASKID.eq.MAST)
     +  PRINT "(/'*** CONSTRAINED DYNAMICS WILL BE USED! ***'/)"
      END IF 
	NRBND=0                            
	NRANG=0
	NRTOR=0
	do ITYP=1,NTYPES
	  NRBND=NRBND+NRB(ITYP)*NSPEC(ITYP)
	  NRANG=NRANG+NRA(ITYP)*NSPEC(ITYP)
	  NRTOR=NRTOR+NRT(ITYP)*NSPEC(ITYP)
	end do
*
      NOP     = 0
      NSITES  = 0
      NSTOT   = 0
	IATOM=0
	IMOL=0 
	FNST=0.            
	FTTR=0.
      FNSTR	= 0.
	IST=0  
	LMA=.true.
      if(IPRINT.ge.10)then
	  write(*,*)
	  write(*,*)' Check references:'
	  write(*,*)' Iatom    Imol    Isit   Ityp     Name'
	end if  
	DO ITYP = 1,NTYPES
        NOP     = NOP    + NSPEC(ITYP)
        NSITES  = NSITES + NSITS(ITYP)
	  if(LMOVE(ITYP))then                               
	    FNST  = FNST+3*NSPEC(ITYP)*NSITS(ITYP)
	    FTTR  = FTTR+3*NSPEC(ITYP)
	    if(LSHEJK.and.ISHEJK(ITYP).gt.0)
     +      FNST=FNST-NRB(ITYP)*NSPEC(ITYP)
          if(NSITS(ITYP).eq.2)FNSTR=FNSTR+2.*NSPEC(ITYP)
          if(NSITS(ITYP).ge.3)FNSTR=FNSTR+3.*NSPEC(ITYP)
	  else
	    LMA=.false.
	  end if
        NSTOT   = NSTOT  + NSPEC(ITYP)*NSITS(ITYP)
        FNSS3   = 3.*DFLOAT(NSITES)
        IF(NSPEC(ITYP).LE.0) STOP '!!! CHECK NSPEC !!!'
          TFACT(ITYP) = 1.D0
        IF(LSHEJK.and.ISHEJK(ITYP).gt.0) 
     +    TFACT(ITYP) = FNSS3/(FNSS3-NRB(ITYP))
        NRTSC(ITYP) = 0             
	  if(TASKID.eq.MAST)
     +  write(*,'(a6,i4,a3,a6,3x,a5,i5,4x,a6,i4)')
     +  ' type ',ITYP,' - ',NAME(ITYP),' Nmol',NSPEC(ITYP),
     +  'Nsites',NSITS(ITYP)
	  do IS=1,NSPEC(ITYP)
	    IMOL=IMOL+1
          do I=1,NSITS(ITYP)
	      ISITE=IST+I
	      IATOM=IATOM+1
	      NNUM(IATOM)=IMOL                  ! atom -> molec
	      NSITE(IATOM)=ISITE                ! atom -> site
	      ITYPE(IATOM)=ITYP                 ! atom -> type
	      ITS(ISITE)=ITYP                   ! site -> type
	      if(IPRINT.ge.10)write(*,'(4I7,3x,2a4,a6)')
     +      IATOM,IMOL,ISITE,ITYP,NM(ISITE),' on ',NAME(ITYP)  
	      TOTCH	= TOTCH+CHARGE(ISITE)
	    end do  
	    ITM(IMOL)=ITYP                      ! molec -> type
	  end do
	  IST=IST+NSITS(ITYP)
      END DO! OF ITYP
      IF(NOP.EQ.1) RHO = 0.
*
	if(TASKID.eq.MAST)then
        PRINT "(/'*** NR OF SITES/MOL (NSITES)  ',I6)" ,NSITES
        PRINT "( '*** NR OF SITES/TOT (NSTOT)   ',I6)" ,NSTOT
        PRINT "( '*** NR OF PARTICLES (NOP)     ',I6)",NOP
	  PRINT "( '*** NR OF BONDS               ',I6)",NRBND
	  PRINT "( '*** NR OF ANGLES              ',I6)",NRANG
	  PRINT "( '*** NR OF TORSIONS            ',I6)",NRTOR
	  PRINT "( '*** Total charge              ',f8.3)",TOTCH
	end if
*
      IF(NOP   .GT.NPART) STOP '!!! INCREASE NPART !'
      IF(NSITES.GT.NS   ) STOP '!!! INCREASE NS    !'
      IF(NSTOT .GT.NTOT ) STOP '!!! INCREASE NTOT  !'
*
*  FNST - number of degrees of freedom 
*  Obs!  total momenta is fixed! 
      FNSTI	= FNST-FTTR-FNSTR
      if(LMA)FNST        = FNST-3.
	FTIMES      = 1./DFLOAT(NFREQ) 
      FNOP        = DFLOAT(NOP)
	if(TASKID.eq.MAST)then
        write(*,'(a,f6.0)')'*** NR of DEGREES of FREEDOM ',FNST
        write(*,'(a,f6.0)')'***              rotational: ',FNSTR
        write(*,'(a,f6.0)')'***              internal:   ',FNSTI
	  write(*,*)
	end if
      CALL IUNITS
*
*Zero average accumulators
*     
	if(L0AVS)then
	  NAVT	= 0
	  if(TASKID.eq.MAST)write(*,*)' New averaging'
        NSTEPA	= 0
        TIMA	= 0.
	  call ZEROAV
        DO I        = 1,NRQS
          AV(I)       = 0.D0
          AW(I)       = 0.D0
        END DO! OF I
	end if
*
*	Parameters for NVT-ensemble:
*
      IF(LNVT) THEN
        DQT	= (UNITT*1.d15/QT)**2
	  if(TASKID.eq.MAST)then
	    write(*,*)
          write(*,'(a,f10.3)')'*** Constant temperature MD: T = ',TRTEMP
          PRINT *,'   NOSE-NVT RELAXATION TIME      ',QT,' fs'
	  end if
      END IF!(LNVT...
*
*	Parameters for NPT-ensemble:
*
      IF(LNPT) THEN
        if(.not.LNVT.and.TASKID.eq.MAST)
     +  write(*,*)'!!! Attention: NPE-ensemble???'
        DQT	= (UNITT*1.d15/QT)**2
        DQP	= UNITE*UNITT**2/(UNITP*FNOP*BOLTZ*TRTEMP*(QPR*1.d-15)**2)
        if(TASKID.eq.MAST)write(*,'(a,f10.3,a)')
     +  '*** Constant-pressure MD: P = ',TRPRES,' atm'
        if(TASKID.eq.MAST)
     +  PRINT *,'   NOSE-NPT RELAXATION TIME     ',QPR,' fs'
      END IF!(LNVT...                   
	if(LRR.and.TASKID.eq.MAST)write(*,*)
     +'!!! Forcible keeping of the initial structure. DR =',RRLL
      FACVT = 3*FNOP*TRTEMP*(QPR*1.d-15/UNITT)**2
      if(LSEP)FACVT=FACVT/3.
      SC	 = 0.
      SCL	= 0.   
	SCLX    = 0.
	SCLY    = 0.
	SCLZ    = 0.
*
Continue an old run:
*
      IF(LRST) THEN
*
        CALL RESTRT(1)
        CL=BOXL
        call RECLEN(1.d0,1.d0,1.d0)
        CALL GETCOM
        if(TASKID.eq.MAST)write(*,'(a,f12.4,a2)')
     +  ' The system was simulated ',TIM*1.d12,'ps'
        if(TASKID.eq.MAST)write(*,'(a,f12.4,a2)')
     +  ' Averages was collected   ',TIMA*1.d12,'ps'
*
      ELSE
*
*Prepare a new run:
*
*Generate start coordinates for C.O.M. points:
*
        NHIST	= 0
        TIM	= 0.
        timest	= 0.
	  NTRKF=0           ! num. of trace file
	  NTRKZ=0           ! num. of points in the trace file
        IF(NOP.EQ.1) THEN
          X(1)   = 0.
          Y(1)   = 0.
          Z(1)   = 0.
*
        ELSE                                                   
*   Different ways of distributing the molecules in the cell  
          IF(ICHECK.eq.1) THEN 
            CALL FCC(X,Y,Z,BOXL,BOYL,BOZL,NOP,ICELL)
          ELSE if(ICHECK.eq.2)then
            call DNASOL
          ELSE if(ICHECK.eq.3)then
            call SPHOLE
	    else if(ICHECK.eq.4)then
            CALL CUBIC(X,Y,Z,BOXL,BOYL,BOZL,NOP,ICELL)
	    else if(ICHECK.eq.0)then
*   raed coord. from input file
	      open(unit=13,file=FINP,status='old',err=298)
	      go to 299         
 297	      if(TASKID.eq.MAST)then
              write(*,*)'too few atoms in the input file'
	        IE=99
	        AUX=TAKESTR(13,IE)
	        write(*,*)' fatal processor error'
	      end if
	      stop                           
 298	      if(TASKID.eq.MAST)
     +write(*,*)' input file ',FINP,' not found (ICHECK=0)'
	      stop
 299        do I=1,NSTOT                                
		AUX=TAKESTR(13,IE)
	        read(AUX,*,err=297,end=297)SX(I),SY(I),SZ(I) 
	      end do          
	      if(TASKID.eq.MAST)write(*,*)
     +'read initial coordinetes from file ',FINP
	      close(13)  
	    else if(ICHECK.eq.-1)then
	      open(unit=13,file=FINP,status='old',err=398)
	      go to 399         
 397	      if(TASKID.eq.MAST)then
              write(*,*)'too few molecules in the input file'
	        IE=99
	        AUX=TAKESTR(13,IE)
	        write(*,*)' 1.e1000 thanks to your system administrator'
	      end if
	      stop
 398	      if(TASKID.eq.MAST)
     +write(*,*)' input file ',FINP,' not found (ICHECK=-1)'
	      stop
 399        do I=1,NOP                                
		AUX=TAKESTR(13,IE)
	        read(AUX,*,err=397,end=397)X(I),Y(I),Z(I)
		call PBC(X(I),Y(I),Z(I))
	      end do          
	      if(TASKID.eq.MAST)write(*,*)
     +'read initial COM from file ',FINP
	      close(13)  
	    else
	      write(*,*)' available values of ICHECK from -1 to 4'
	      write(*,*)' now ICHECK =',ICHECK
	      stop
          END IF!(ICHE...
*
        END IF!(NOP...
*
*Initialize velocities
*
        TMPRED     = 200.D0/TRTEMP 
        CALL COMVEL(VX,VY,VZ,TMPRED,NSTOT) 
*
	if(TASKID.eq.MAST)
     +  PRINT *,'*** RANDOM VELOCITIES FOR   ',NOP,'  PARTICLES'
*
        VSQ         = 0.0
        DO N        = 1,NSTOT  
	    ITYP=ITYPE(N)
          if(LMOVE(ITYP))VSQ = VSQ+
     +    (VX(N)**2+VY(N)**2+VZ(N)**2)*MASSDI(N)
        END DO! OF N
*
        TEMP        = 1.50*VSQ*ENERF*TEMPF/FNST
        FTMP        = SQRT(TRTEMP/TEMP)
        DO     N    = 1,NSTOT
	    ITYP=ITYPE(N)
	    if(LMOVE(ITYP))then
            VX(N)       = VX(N)*FTMP
            VY(N)       = VY(N)*FTMP
            VZ(N)       = VZ(N)*FTMP 
	    else
            VX(N)       = 0.
            VY(N)       = 0.
            VZ(N)       = 0. 
	    end if
        END DO! OF N
*
        VSQ         = 0.0
        DO N        = 1,NSTOT
          VSQ         = VSQ+(VX(N)**2+VY(N)**2+VZ(N)**2)*MASSDI(N)
        END DO! OF N
*
        TEMP        = 1.5*VSQ*ENERF*TEMPF/FNST
*       
	  if(TASKID.eq.MAST)then
          PRINT *,'*** INITIAL TEMPERATURE CALCULATED',TEMP
          PRINT *,'*** VELOCITIES INITIATED'
          PRINT * 
	  end if
*
*Orientations of the molecules:
*
	  if(ICHECK.eq.0)then  
	    call GETCOM
	    do N=1,NSTOT
              GX(N)          = 0.D0
              GY(N)          = 0.D0
              GZ(N)          = 0.D0
              HX(N)          = 0.D0
              HY(N)          = 0.D0
              HZ(N)          = 0.D0
              OX(N)          = SX(N)
              OY(N)          = SY(N)
              OZ(N)          = SZ(N)
	    end do
	  else
          N              = 0
          I              = 0  
          DO ITYP        = 1,NTYPES
          IBES           = ISADR (ITYP)+1
          IENS           = ISADR (ITYP +1) 
          DO J           = 1,NSPEC(ITYP)
            I              = I+1
            CALL RANQ(QP)
            DO IS          = IBES,IENS
              N              = N+1
              RXI            = R(IS,1)
              RYI            = R(IS,2)
              RZI            = R(IS,3)
              if(IINIT(ITYP).ne.1)CALL ROTATE  (QP,RXI,RYI,RZI)
              SX(N)          = RXI+X(I)
              SY(N)          = RYI+Y(I)
              SZ(N)          = RZI+Z(I)
              GX(N)          = 0.D0
              GY(N)          = 0.D0
              GZ(N)          = 0.D0
              HX(N)          = 0.D0
              HY(N)          = 0.D0
              HZ(N)          = 0.D0
              OX(N)          = SX(N)
              OY(N)          = SY(N)
              OZ(N)          = SZ(N)
            END DO! OD IS
          END DO! OF I
          END DO! OF ITYP
	  end if
	  call GETCOM
*
        NSTTOT	= 0      
*
        if(TASKID.eq.MAST)
     +  PRINT "('*** MOLECULAR ORIENTATIONS INITIALIZED')"
*
      END IF!(LRST...
	if(LSHEJK)then 
	  do N=1,NSTOT       
          HX(N)          = VX(N)
          HY(N)          = VY(N)
          HZ(N)          = VZ(N)
	  end do
	end if
* Parameter for Ewald sum      
	if(ICELL.eq.1)ALPHA=-abs(ALPHA)
	CL=BOXL
	if(CL.gt.BOYL)CL=BOYL
	if(CL.gt.BOZL)CL=BOZL
	if(RCUTT.le.0.5*CL)then
        ALPHAD	= ALPHA/RCUTT
	else
	  ALPHAD	= 2.d0*ALPHA/CL 
	end if  
	if(ALPHA.lt.0.d0)then 
*  case of reaction field method
	  LMNBL=.true.  
	  if(RCUTT.gt.0.5*CL)then
	    RCUTT=0.5*CL
	    RSSQ= RCUTT**2
	    if(TASKID.eq.MAST)write(*,*)' Cut off distance set to ',RCUTT
	  end if
	  DIEL=-ALPHA 
*   Standard reaction field method:
*	  RFF=(DIEL-1.d0)/(2.d0*DIEL+1)/RCUTT**3  
*   Generalised reaction field method (take into account ion concentration:
*   Tironi et al, J.Chem.Phys. v.102,p.5451 (1995)) 
	  RDEB=FEXP            ! now it is Debue length in     
	  if(RDEB.gt.1.d-3)then
	    RCK=RCUTT/RDEB
	  else
	    RCK=0.
	  end if
	  RFF=((DIEL-1.)*(RCK+1.)+DIEL*RCK**2)/
     &      (((2.*DIEL+1.)*(RCK+1.)+DIEL*RCK**2)*RCUTT**3)  
	  if(DIEL.le.1.0000001d0)RFF=0.
	  RFF2=2.d0*RFF
	  ALPHAD=0.d0   
	  if(TASKID.eq.MAST)then
	    write(*,*)
	    write(*,*)
     +' reaction field method for electrostatic interactions'
	    write(*,*) 
	    write(*,*)' macroscopic dielectric constant ',DIEL 
	    if(RDEB.gt.1.d-3)write(*,*)' Debue length ',RDEB
	    write(*,*)
	  end if
	else
	  LMNBL=.false.
	end if
*
      CALL ELRCLJ
*
*  concentrations in M/l
*     
	if(TASKID.eq.MAST)then
        write(*,'(a)')'   Concentrations of different molecules:'
	  do ITYP=1,NTYPES
	    CONC=NSPEC(ITYP)/(AVSNO*1.d-27*VOL)
	    write (*,'(4x,a4,f9.4,a4)')NAME(ITYP)(1:4),CONC,' M/l'  
	  end do
*     
	  PRINT "(/'*** DENSITY           ',D12.6,' g/cm**3 ' )",RHO
        PRINT "( '*** BOX VOLUME        ',D12.6,' A**3    ' )",VOL
        PRINT "( '*** BOX LENGTHS       ',3(D12.6,' A ') )"
     +  ,BOXL,BOYL,BOZL
        PRINT "( '*** CUT-OFF           ',D12.6,' A       ' )",RCUTT
	  PRINT "( '*** Closest R         ',D12.6,' A       ' )",SHORT
	  PRINT "( '*** RDF cut-off       ',D12.6,' A       ' )",RDFCUT
	  PRINT "( '*** ALPHA (Ew.sum)    ',D12.6)",ALPHA  
	  PRINT "( '*** Fexp  (Ew.sum)    ',D12.6)",FEXP
        PRINT *
        if(.not.LRST)then
	    PRINT "(/'*** LONG  TIME STEP   ',F12.6,' fs ' )",DT*1.d15
          if(.not.LSHEJK)PRINT 
     +"('*** SHORT TIME STEP   ',F12.6,' fs' )",DT*1.d15/(NFREQ+1.d-14)    
	  end if
	end if       
*
      IF(LGR)   CALL RDFINP
      IF(LCF)   CALL TCFINP
*
*  List of 1-5 interactions
*
      CALL BNDLST
*        
	if(IPRINT.ge.8)then
	  write(*,*)' Coordinates and velocities of all particles:'

	  do I=1,NSTOT
	    write(*,'(I5,2x,a4,3(2x,f9.3),2x,3(2x,f9.7))')
     +I,NM(NSITE(I)),SX(I),SY(I),SZ(I),VX(I),VY(I),VZ(I)
	  end do
	end if
      IF(LINPUT)then
	  if(LRST)then
          if(IHIST.gt.NHIST)IHIST=NHIST
	    call GETAVR(3)
	    IF(LGR.and.LGRST)   CALL RDFOUT(1)
          IF(LCF.and.LCFRST)  CALL TCFOUT(1)
        else  
	    if(TASKID.eq.MAST)WRITE(*,*)' STOP after cheking the input' 
	  end if
	  if(LXMOL)call XMOLDUMP
	  go to 9999
      end if  
	if(LCHP)RHO=RHON
*        call GROUPMOL
	call CHTERM(BOXLN,BOYLN,BOZLN)
	call TESTCONF
*                  
	if(TASKID.eq.MAST)
     +PRINT "('*** MD STEPS ABOUT TO START FOR',I8,' STEPS:')",NSTEPS
      if(TASKID.eq.MAST)PRINT * 
*
	if(IPRINT.ge.5)WRITE(6,900)
	if(.not.LRST.and.TASKID.eq.MAST)call TRACE
* A MD step 
      IF(LSHEJK) THEN
        CALL SULTAN
      ELSE
        CALL DOUBLE
      END IF
*     
      if(IHIST.gt.NHIST)IHIST=NHIST
      call GETAVR(3)         
      IF(LGR)   CALL RDFOUT(1) 
	if(TASKID.ne.MAST)go to 9999
      IF(LCF)   CALL TCFOUT(1) 
	if(LXMOL) call XMOLDUMP
*
  900 FORMAT(/1X,'  STEP     POTE      PE(int)   E(el)'
     X,'   Etot       TEMP     PRES      Dens '/)
*
      IF(.NOT.LNVT) THEN
      PRINT *,'... TEMP SCALED:'
      DO ITYP = 1,NTYPES
      PRINT *,'...',NRTSC(ITYP),'  TIMES IN'
     X,NSTEPS,'  STEPS - FOR TYPE: ',ITYP
      END DO! OF ITYP
      END IF
 9999 call FINAL
*
      END
*
