C           Subroutines for parallel execution (MPI)
C                                                  
	subroutine PARAINI(numtask,taskid)   
	include "mpif.h"
	integer numtask,taskid
      call MPI_INIT( ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, taskid, ierr )
      call MPI_COMM_SIZE( MPI_COMM_WORLD, numtask, ierr ) 
      print *, "Process ", taskid, " of ", numtask, " is alive"
	return
	end 
CM
CM================ SINHR ============================================
CM                                                                   
	subroutine SINHR(IND)
	include "prcm.h"
	real BUFF(NBUFF),BUF2(NBUFF)
	include "mpif.h"      
      timen0	= cputime(0.d0)
*      call MPI_BARRIER(MPI_COMM_WORLD,IERR)
	if(IND.eq.2)then
*  in DOUBLE - each short time step 
	  NAPC3=NAPC*3
	  ISH=NABS(TASKID)                
	  if(NBUFF.le.NAPC3)then
	    write(*,*)' Increase NBUFF in prcm.h to ',NAPC3
	    stop
	  end if
	  do I=1,NAPC    
	    BUFF(I)=SX(I+ISH)
	    BUFF(I+NAPC)=SY(I+ISH)
	    BUFF(I+2*NAPC)=SZ(I+ISH)
	  END DO 
        call MPI_ALLGATHER(BUFF,NAPC3,MPI_REAL,BUF2,NAPC3,
     +  MPI_REAL,MPI_COMM_WORLD,ierr)
	  do K=0,NUMTASK-1
	    if(K.ne.TASKID)then
            do J=NAB(K),NAE(K)  
	        I=J+2*NABS(K)
	        SX(J)=BUF2(I)
	        SY(J)=BUF2(I+NAPC)
	        SZ(J)=BUF2(I+2*NAPC)
	      end do
	    end if
	  end do
	end if
	if(IND.eq.1)then   !    (used in constrain dynamics)    
        NPC=NAP(TASKID)          
	  NPC3=NPC*3
	  do K=1,NPC    
	    I=NABS(TASKID)+K
	    BUFF(K)=SX(I)
	    BUFF(K+NPC)=SY(I)
	    BUFF(K+2*NPC)=SZ(I)
	  end do
        call MPI_ALLGATHERV(BUFF,NPC3,MPI_REAL,BUF2,NAP3,NABS3,
     +MPI_REAL,MPI_COMM_WORLD,ierr)
	  do K=0,NUMTASK-1
	    if(K.ne.TASKID)then 
	      NPC=NAP(K)
            do J=NAB(K),NAE(K)  
	        I=J+2*NABS(K)
	        SX(J)=BUF2(I)
	        SY(J)=BUF2(I+NPC)
	        SZ(J)=BUF2(I+2*NPC)
	      end do
	    end if
	  end do
	end if
      HBOXL=0.5*BOXL
      HBOYL=0.5*BOYL
      HBOZL=0.5*BOZL
      RF          = HBOXL
*      RCUTT       = DMIN1(RF,RCUT)
	RCUTT=RCUT
      IF(RCUT.LE.0.D0)then
        RCUTT = HBOXL
	  if(RCUTT.gt.HBOYL.and..not.LHEX)RCUTT=HBOYL
	  if(RCUTT.gt.HBOZL)RCUTT=HBOZL
	end if
      RSSQ        = RCUTT**2
      VOL	= BOXL*BOYL*BOZL  
	if(LOCT)VOL=0.5*VOL
	RHO	= TOTMAS*1.d27/VOL
      timen	= timen+cputime(timen0) 
	return
	end            
CM
CM================ SINHV ============================================
CM                                                                   
	subroutine SINHV(IND)
	include "prcm.h"
	include "mpif.h"      
	real BUFF(NBUFF),BUF2(NBUFF)
      timen0	= cputime(0.d0)
	ISH=NAB(TASKID) 
	if(IND.eq.2)then 
	  call MPI_GATHER(VX(ISH),NAPC,MPI_DOUBLE_PRECISION,VX,
     +NAPC,MPI_DOUBLE_PRECISION,MAST,MPI_COMM_WORLD,ie)
	  call MPI_GATHER(VY(ISH),NAPC,MPI_DOUBLE_PRECISION,VY,
     +NAPC,MPI_DOUBLE_PRECISION,MAST,MPI_COMM_WORLD,ie)
	  call MPI_GATHER(VZ(ISH),NAPC,MPI_DOUBLE_PRECISION,VZ,
     +NAPC,MPI_DOUBLE_PRECISION,MAST,MPI_COMM_WORLD,ie) 
	else
	  NAPP=NAP(TASKID)             
	  call MPI_GATHERV(VX(ISH),NAPP,MPI_DOUBLE_PRECISION,VX,
     +NAP,NABS,MPI_DOUBLE_PRECISION,MAST,MPI_COMM_WORLD,ie)
	  call MPI_GATHERV(VY(ISH),NAPP,MPI_DOUBLE_PRECISION,VY,
     +NAP,NABS,MPI_DOUBLE_PRECISION,MAST,MPI_COMM_WORLD,ie)
	  call MPI_GATHERV(VZ(ISH),NAPP,MPI_DOUBLE_PRECISION,VZ,
     +NAP,NABS,MPI_DOUBLE_PRECISION,MAST,MPI_COMM_WORLD,ie)
	end if 
	if(TASKID.eq.MAST)then
	  BUFF(1)=SC
	  BUFF(2)=BOXL
	  BUFF(3)=BOYL
	  BUFF(4)=BOZL
	  BUFF(5)=SCL
	  BUFF(6)=SCLX
	  BUFF(7)=SCLY
	  BUFF(8)=SCLZ
	end if
	call MPI_BCAST(BUFF,8,MPI_REAL,MAST,
     +MPI_COMM_WORLD,ie)	
	if(TASKID.ne.MAST)then
	  SC=BUFF(1)
	  BOXL=BUFF(2)
	  BOYL=BUFF(3)
	  BOZL=BUFF(4)
	  SCL=BUFF(5)
	  SCLX=BUFF(6)
	  SCLY=BUFF(7)
	  SCLZ=BUFF(8)
	end if
      HBOXL=0.5*BOXL
      HBOYL=0.5*BOYL
      HBOZL=0.5*BOZL
      RF          = HBOXL
*      RCUTT       = DMIN1(RF,RCUT)
	RCUTT=RCUT
      IF(RCUT.LE.0.D0)then
        RCUTT = HBOXL
	  if(RCUTT.gt.HBOYL)RCUTT=HBOYL
	  if(RCUTT.gt.HBOZL)RCUTT=HBOZL
	end if
      RSSQ        = RCUTT**2
      VOL	= BOXL*BOYL*BOZL
	if(LOCT)VOL=0.5*VOL
	RHO	= TOTMAS*1.d27/VOL
      timen	= timen+cputime(timen0) 
	return
	end            
CM
CM=================== CM_ADDF ======================================
CM
	subroutine CM_ADDF(LAVER)
	include "prcm.h" 
	include "mpif.h"
	real BUFF(NBUFF),BUF2(NBUFF) 
	logical LAVER
      timen0	= cputime(0.d0)             
	BUFF(1)=PE1
	BUFF(2)=PELS1
	BUFF(3)=PINT
	BUFF(4)=VIR1
	BUFF(5)=WIRSS
	BUFF(6)=VIRB
	BUFF(7)=VIRFX
	BUFF(8)=VIRFY
	BUFF(9)=VIRFZ
	ICNT=9
	if(LAVER)then 
	  ICNT=ICNT+MOLINT           
	  do INT=1,MOLINT
	    BUFF(9+INT)=POTE1(INT)
	    BUFF(ICNT+INT)=POTL1(INT)
	  end do
	  ICNT=ICNT+MOLINT
	  ICNT2=ICNT+NTYPES
	  do I=1,NTYPES
	    BUFF(ICNT+I)=PES141(I)
	    BUFF(ICNT2+I)=PSR141(I)
	  end do
	  ICNT=ICNT2+NTYPES
	  if(NRBB.gt.0)then 
	    ICNT2=ICNT+NRBB
	    do I=1,NRBB
	      BUFF(ICNT+I)=BR(I)
	      BUFF(ICNT2+I)=BE(I)
	    end do
	    ICNT=ICNT2+NRBB
	  end if
	  if(NRAA.gt.0)then 
	    ICNT2=ICNT+NRAA
	    do I=1,NRAA
	      BUFF(ICNT+I)=AR(I)
	      BUFF(ICNT2+I)=AE(I)
	    end do
	    ICNT=ICNT2+NRAA
	  end if
	  if(NRTT.gt.0)then 
	    ICNT2=ICNT+NRTT
	    do I=1,NRTT
	      BUFF(ICNT+I)=TR(I)
	      BUFF(ICNT2+I)=TE(I)
	    end do
	    ICNT=ICNT2+NRTT
	  end if
	  ICNTS=ICNT  
	  if(ICNT.gt.NBUFF)then
	    write(*,*) 'increase NBUFF to ',ICNT
	    stop
	  end if       
	end if    !  of LAVER
      call MPI_REDUCE(BUFF,BUF2,ICNT,MPI_REAL,MPI_SUM,
     $     MAST,MPI_COMM_WORLD,ierr)
 	if(TASKID.eq.MAST)then 
	  PE1=BUF2(1)
	  PE=PE+BUF2(1)
	  PELS = PELS+BUF2(2)
	  PINT = BUF2(3)
        VIRS=VIRS+BUF2(4)+BUF2(6)
	  VIRLS=VIRLS+BUF2(4)
	  VIR1=BUF2(4)   
	  WIRSS=BUF2(5) 
	  VIRB=BUF2(6)
	  VIRFX=BUF2(7)        
	  VIRFY=BUF2(8)        
	  VIRFZ=BUF2(9)        
	  if(.not.LAVER)go to 100        
	  ICNT2=9+MOLINT
	  do INT=1,MOLINT
	    POTES(INT)=POTES(INT)+BUF2(9+INT)
	    POTLJ(INT)=POTLJ(INT)+BUF2(ICNT2+INT)
	  end do                  
	  ICNT=ICNT2+MOLINT
	  ICNT2=ICNT+NTYPES
	  do I=1,NTYPES
	    PES14(I)=PES14(I)+BUF2(ICNT+I)
	    PSR14(I)=PSR14(I)+BUF2(ICNT2+I)
	  end do   
	  ICNT=ICNT2+NTYPES
	  if(NRBB.gt.0)then
	    ICNT2=ICNT+NRBB
	    do I=1,NRBB
	      BB(I)=BB(I)+BUF2(ICNT+I)
	      EB(I)=EB(I)+BUF2(ICNT2+I)
	    end do                   
	    ICNT=ICNT2+NRBB
	  end if
	  if(NRAA.gt.0)then
	    ICNT2=ICNT+NRAA
	    do I=1,NRAA
	      AA(I)=AA(I)+BUF2(ICNT+I)
	      EA(I)=EA(I)+BUF2(ICNT2+I)
	    end do                   
	    ICNT=ICNT2+NRAA
	  end if
	  if(NRTT.gt.0)then
	    ICNT2=ICNT+NRTT
	    do I=1,NRTT
	      TT(I)=TT(I)+BUF2(ICNT+I)
	      ET(I)=ET(I)+BUF2(ICNT2+I)
	    end do                   
	    ICNT=ICNT2+NRTT
	  end if
	  if(ICNT.ne.ICNTS)write(*,*)' sent ',ICNTS,' received ',ICNT
	end if     
 100	do J=0,NUMTASK-1
	  I0=3*NABS(J)
	  I1=I0+NAP(J)
	  I2=I1+NAP(J)
	  do K=1,NAP(J)    
	    I=NABS(J)+K
	    BUFF(I0+K)=HX(I)
	    BUFF(I1+K)=HY(I)
	    BUFF(I2+K)=HZ(I)
	  END DO
	end do
      call MPI_REDUCE_SCATTER(BUFF,BUF2,NAP3,MPI_REAL,
     +MPI_SUM,MPI_COMM_WORLD,ierr)
      do J=NAB(TASKID),NAE(TASKID)  
	  I=J-NABS(TASKID)
	  HX(J)=BUF2(I)
	  HY(J)=BUF2(I+NAP(TASKID))
	  HZ(J)=BUF2(I+2*NAP(TASKID))
	end do
	timen	= timen+cputime(timen0)      
	return
	end
CM
CM=================== CM_ADDLF ======================================
CM
	subroutine CM_ADDLF
	include "prcm.h" 
	real BUFF(NBUFF),BUF2(NBUFF)
	include "mpif.h"
      timen0	= cputime(0.) 
	BUFF(1) = VIRX
	BUFF(2) = VIRY
	BUFF(3) = VIRZ
      ICNT=3
      do INT=1,MOLINT
	  BUFF(INT+ICNT)=POTE1(INT)
	  BUFF(INT+MOLINT+ICNT)=POTL1(INT)
	end do
	ICNT=3+2*MOLINT
	ICNT2=ICNT+NTYPES
	ICNT3=ICNT2+NTYPES
	do I=1,NTYPES
	  BUFF(I+ICNT)=PES141(I)
	  BUFF(I+ICNT2)=PSR141(I)
	  BUFF(I+ICNT3)=SPEE(I)
	end do 
	ICNT=ICNT3+NTYPES
	call MPI_REDUCE(BUFF,BUF2,ICNT,MPI_REAL,MPI_SUM,
     $     MAST,MPI_COMM_WORLD,ierr)
 	if(TASKID.eq.MAST)then 
	  VIRX = BUF2(1)
	  VIRY = BUF2(2)
	  VIRZ = BUF2(3)
	  ICNT=3
	  do INT=1,MOLINT
	    POTES(INT)=POTES(INT)+BUF2(INT+ICNT)
	    POTLJ(INT)=POTLJ(INT)+BUF2(INT+MOLINT+ICNT)
	  end do                                 
	  ICNT=ICNT+2*MOLINT
	  ICNT2=ICNT+NTYPES
	  ICNT3=ICNT2+NTYPES
	  do I=1,NTYPES
	    PES14(I)=PES14(I)+BUF2(I+ICNT)
	    PSR14(I)=PSR14(I)+BUF2(I+ICNT2)
	    SELFPE(I)=SELFPE(I)+BUF2(I+ICNT3)
	  end do
	end if       
 	do J=0,NUMTASK-1
	  I0=3*NABS(J)
	  I1=I0+NAP(J)
	  I2=I1+NAP(J)
	  do K=1,NAP(J)    
	    I=NABS(J)+K
	    BUFF(I0+K)=GX(I)
	    BUFF(I1+K)=GY(I)
	    BUFF(I2+K)=GZ(I)
	  END DO
	end do
      call MPI_REDUCE_SCATTER(BUFF,BUF2,NAP3,MPI_REAL,
     +MPI_SUM,MPI_COMM_WORLD,ierr)
      do J=NAB(TASKID),NAE(TASKID)  
	  I=J-NABS(TASKID)
	  GX(J)=BUF2(I)
	  GY(J)=BUF2(I+NAP(TASKID))
	  GZ(J)=BUF2(I+2*NAP(TASKID))
	  M	= NNUM(J)
	  WIRS	= WIRS-GX(J)*(SX(J)-X(M))-GY(J)*(SY(J)-Y(M))-
     +               GZ(J)*(SZ(J)-Z(M))
	end do
	BUFF(1)=PE1
	BUFF(2)=PELS1
	BUFF(3)=VIR1    
	BUFF(4)=WIRS
	BUFF(5)=SPE
	BUFF(6)=WIRF
      call MPI_ALLREDUCE(BUFF,BUF2,6,MPI_REAL,MPI_SUM,
     $     MPI_COMM_WORLD,ierr)         

	PE    = PE+BUF2(1)+BUF2(2)+BUF2(5)
	PEST  = BUF2(2)+BUF2(5)
      VIR   = VIR+BUF2(3)
      VIRL  = BUF2(3)
	WIRS  = BUF2(4)
	SPE   = BUF2(5)
	WIRF  = BUF2(6)
      timen	= timen+cputime(timen0) 
	return
	end         
*
*==================== ADD_RDF ======================================
*                                                                   
	subroutine ADD_RDF(IRDF,IRDF1,MAXS,MAXGR,MAST)
	include "mpif.h"
	integer IRDF(MAXS,MAXGR),IRDF1(MAXS,MAXGR) 
	LEN=MAXS*MAXGR
      call MPI_REDUCE(IRDF,IRDF1,LEN,MPI_INTEGER,MPI_SUM,MAST,
     $     MPI_COMM_WORLD,ierr)                 
	return
	end
*
*===================== GATHER =======================================
*                                                                    
	subroutine GATHER(NRNOD)
	include "prcm.h"
	include "mpif.h" 
	integer AUX(NBDMAX*NTOT),NRNOD(NTPS)
	do ITYP=1,NTYPES	
	  IABEG=ISADDR(ITYP)+1
	  IAEND=ISADDR(ITYP+1) 
	  NRN  =NRNOD(ITYP)       
*  prepare to send       
	  if(NRN.eq.TASKID)then
	    J=0
	    do I=IABEG,IAEND
	      J=J+1
	      AUX(J)=NNBB(I)
	      do INB=1,NNBB(I)
	        J=J+1
	        AUX(J)=INBB(I,INB)
	      end do
	    end do  
	    JBUF=J
	  end if
*  transfer buffer size         
        call MPI_BCAST(JBUF,1,MPI_INTEGER,NRN,MPI_COMM_WORLD,ie) 
*  transfer data
	  call MPI_BCAST(AUX,JBUF,MPI_INTEGER,NRN,MPI_COMM_WORLD,ie)
*  unpack data
	  if(NRN.ne.TASKID)then
	    J=0
	    do I=IABEG,IAEND
	      J=J+1
	      NNBB(I)=AUX(J)
	      do INB=1,NNBB(I)
	        J=J+1
	        INBB(I,INB)=AUX(J)
	      end do
	    end do  
	  end if
	  if(J.ne.JBUF)write(*,*)' in GATHER: send ',JBUF,' received ',J,
     +' for type ',ITYP,' node ',TASKID
      end do
	return
	end 
*
*======================== TRANSRDF ========================
*
 	subroutine TRANSRDF(NS,MXGRS,MAST,TASKID,NGRI,IGRI,MGRI)
	include "mpif.h"
	integer NGRI(NS),IGRI(NS,MXGRS),MGRI(NS,MXGRS),IAUX(NS),TASKID
	call MPI_BCAST(NGRI,NS,MPI_INTEGER,MAST,MPI_COMM_WORLD,ie)
	do I=1,MXGRS
	  if(TASKID.eq.MAST)then 
	    do J=1,NS
	      IAUX(J)=IGRI(J,I)
	    end do
	  end if  
	  call MPI_BCAST(IAUX,NS,MPI_INTEGER,MAST,MPI_COMM_WORLD,ie) 
	  if(TASKID.eq.MAST)then 
	    do J=1,NS
	      IAUX(J)=MGRI(J,I)
	    end do
	  else
	    do J=1,NS
	      IGRI(J,I)=IAUX(J)
	    end do
	  end if  
	  call MPI_BCAST(IAUX,NS,MPI_INTEGER,MAST,MPI_COMM_WORLD,ie)  
	  if(TASKID.ne.MAST)then 
	    do J=1,NS
	      MGRI(J,I)=IAUX(J)
	    end do
	  end if
	end do  
	return  
	end                 
*
*============================= ALLSUM ==================================
*     
	subroutine ALLSUM(A,B,N)
	real*8 A(*),B(*)
	include "mpif.h"
	  call MPI_ALLREDUCE(A,B,N,MPI_DOUBLE_PRECISION,MPI_SUM,
     $     MPI_COMM_WORLD,ierr)     
	return
	end
*
*============================ SUMMA ===============================
*                                                                  
      subroutine SUMMA(A,B,N,MAST)
	real*8 A(*),B(*)
	include "mpif.h"
      call MPI_REDUCE(A,B,N,MPI_DOUBLE_PRECISION,MPI_SUM,
     $     MAST,MPI_COMM_WORLD,ierr)
	return
	end   
*
*============================ BCAST ===============================
*                                                                  
      subroutine BCAST(A,N,MAST)
	real*8 A(*)
	include "mpif.h"
	call MPI_BCAST(A,N,MPI_DOUBLE_PRECISION,MAST,MPI_COMM_WORLD,ie)	
	return
	end   
*
*============================= FINAL ========================
*                                                            
	subroutine FINAL
	include "mpif.h"
      call MPI_BARRIER(MPI_COMM_WORLD,IERR)
	call MPI_FINALIZE(ie)
	stop 
	end
