	program TRH2O
*  Analys of trajectory file 
*  Calculations of orientational correlation functions 
*  and three-body correlations
*
	include "mdan.h"
	parameter (MAXFIL=500)
	character*64 filnam(MAXFIL),fildif*16,filres*16,fildif2*16,fildfm
	dimension TIMIN(MAXFIL) 
	dimension OX(NTOT),OY(NTOT),OZ(NTOT)
	real*4 TX(NTOT),TY(NTOT),TZ(NTOT) 
	real*8 fdir(3)
	logical logo,LORIENT,LCOR3,LDIFF,LRES,LDIF2,LMUT,LDM
	namelist /INPUT/LCOR3,LORIENT,IS1,IS2,IS3,AMPL,fil3cor,filori
     +,RMAXX,NRX,RMAXY,NRY,ITH,ISOR,ROMAX,NOM,RB12,D12,IPRINT,NDUP,
     +ZB,DZB,IPROC,LDIFF,IDF,MTR,DTT,NTT,ISTEP,FILDIF,FILRES,ICNT,
     +LRES,IR1,IR2,RRN,RRX,RRD,NITT,TIMM,TTER,LCOL2,NDUR,NM,IDFM1,IDFM2,
     +RDIF2,DDIF2,fildif2,fildfm,LDIF2,LMUT,IMT1,IMT2,LDM
*  default values
	NDUP=1  
      ISTEP=1
	NTT=200
	MTR=MTRM
	RRD=0.25
	TTER=2.            
	IS1(1)=1
	IS2(1)=1
	IS3(1)=1
	IPROC=1                     ! perp. Z axes
	do I=1,MAXCOLOR
	  AMPL(I)=0.2*I
	end do
	NRX=NMX
	NRY=NMY
	ITH=1
	ISOR(1)=1
	ROMAX=5.
	NOM=50
      IPRINT=2
	ZB=0.
	DZB=0.1 
	fil3cor='correl3.ps'
	filori='orient.ps'
	fildif='tcor.dat' 
	fildif2='dif2.lst' 
      filres='restime.lst' 
	fildfm='difmut.lst'
	read(*,*)NF
	if(NF.gt.MAXFIL)stop '!!! increase MAXFIL !!!'
* Check and reconstruct file list
	J=0             
	NTP=0
	do I=1,NF
	  read(*,'(a)')filnam(I)
	  write(*,*)' looking for file ',filnam(I)
	  if(filnam(I)(1:1).eq.'#')go to 30     ! down 20 lines
        open (unit=12,file=filnam(I),status='old',
     +  form='unformatted',err=5)      
	if(IPRINT.ge.5)write(*,*)' file ',filnam(I),' is open'
        read(12,err=10) IA, dt, boxl, boyl, bozl, unitl, ntypes
	if(IPRINT.ge.5)write(*,*)' num.of types ',NTYPES  
	  if(J.ne.0)then
	    if(NTP.ne.NTYPES)then
	      write(*,*)
     +      ' uncompatible NTYPES in ',filnam(I),' and ',filnam(I-1) 
	      stop
	    end if
	  else
	    rewind (12)
          read(12,err=10) IA, dt, boxl, boyl, bozl, unitl, ntypes,
     x                (nspec(it),nsits(it),logo,it=1,ntypes)
	    if(.not.logo)go to 10
	  end if
	  NTP=NTYPES  
	if(IPRINT.ge.5)write(*,*)' dt ',DT  
	  if(IA.ne.0)go to 10
	  do IT=1,NTYPES
	    read(12,err=10)
	    if(IPRINT.ge.5)write(*,*)' type ',IT,' OK'  
	  end do
	  read(12)IA,FULTIM
	    if(IPRINT.ge.5)write(*,*)' FULTIM ',FULTIM  
	  if(IA.ne.0)go to 10
	  J=J+1
	  TIMIN(J)=FULTIM
	  filnam(J)=filnam(I)
	  go to 20 
  5	  write(*,*)' File not found: ',filnam(I)
	  go to 20
 10	  write(*,*)' File ',filnam(I),': input error'
 20	  close(12)
	end do
      write(*,*)' input of the file list is completed'	  
 30	NF=J
	read(*,INPUT) 
 	TTER=TTER*1.d-12    
	if(LDM)LDIFF=.false.
	if(LORIENT)then
	  if(NOMAX.gt.NMX)stop 'too large NOMAX'
	  if(NOMAX.gt.NMY)stop 'too large NOMAX'
	  if(NOM.gt.NOMAX)stop 'increase NOMAX' 
	end if 
	if(LDIFF)then
	  if(MTR.gt.MTRM)stop ' increase MTRM'
	  if(NTT.gt.NTCF)stop ' increase NTCF'
	  do IT=1,NTT
	    RCUM(IT)=0.d0
	    NCUM(IT)=0
	    RCUM2(IT)=0.d0
	    NCUM2(IT)=0
	    NCUV(IT)=0
	    VACS1(IT)=0.
	    VACS2(IT)=0.
	    VACM11(IT)=0.
	    VACM12(IT)=0.
	    VACM21(IT)=0.
	    VACM22(IT)=0.
	  end do   
	  do I=1,MAXMOL
	    ISHX(I)=0
	    ISHY(I)=0
	    ISHZ(I)=0
	  end do
	end if 
	if(LRES)then  
	  if(NITT.gt.NITTM)stop 'increase NITTM'
	  if(RRN.gt.RRX)stop 'RRN>RRX'
	  RRNN=RRN-RRD
	  RRNX=RRN+RRD
	  RRXN=RRX-RRD
	  RRXX=RRX+RRD
	end if
	if(NRX.gt.NMX)stop ' increase NMX' 
	if(NRY.gt.NMY)stop ' increase NMY' 
	RMX12=(RB12+0.5*D12)**2
	RMN12=(RB12-0.5*D12)**2 
	DXX=2.d0*RMAXX/NRX
	DYY=RMAXY/NRY
	ROMAX2=3.*ROMAX**2
	DDO=ROMAX/NOM     
	RDF2X=(RDIF2+DDIF2)**2
	RDF2N=(RDIF2-DDIF2)**2
*  Input other parameters
*  Adresses and referenses
	IAN=0 
	ISADR(1)=0
	ISADDR(1)=0    
	IADDR(1)=0
	NOP=0 
	NSITES=0
	NSTOT=0 
	FNSTR=0.
	IATOM=0
	IMOL=0
	IST=0   
	NCOR=0    
	JBREAK=1                      
	if(.not.LCOR3.and..not.LORIENT.and..not.LDIFF.and..not.LRES
     +   .and..not.LDIF2.and..not.LMUT.and..not.LDM)then
	  write(*,*)' Nothing to do...'
	  stop
	end if                              
      do ityp=1, ntypes
	  ISADR(ITYP+1)  = ISADR(ITYP)+ NSITS(ITYP)          ! site addr
	  ISADDR(ITYP+1) = ISADDR(ITYP)+NSPEC(ITYP)*NSITS(ITYP)  ! atom adr
        IADDR (ITYP+1) = IADDR (ITYP)+NSPEC(ITYP)         ! mol. addr
        NOP     = NOP    + NSPEC(ITYP)
        NSITES  = NSITES + NSITS(ITYP)
        NOP     = NOP    + NSPEC(ITYP)
        NSITES  = NSITES + NSITS(ITYP)
        if(NSITS(ITYP).eq.2)FNSTR=FNSTR+2.d0*NSPEC(ITYP)
        if(NSITS(ITYP).ge.3)FNSTR=FNSTR+3.d0*NSPEC(ITYP)
        NSTOT   = NSTOT  + NSPEC(ITYP)*NSITS(ITYP)
        FNSS3   = 3.D0*DFLOAT(NSITES)
        write(*,'(a6,i4,3x,a5,i5,4x,a6,i4)')
     +' type ',ITYP,' Nmol',NSPEC(ITYP),
     +'Nsites',NSITS(ITYP)
	  do J=ISADR(ITYP)+1,ISADR(ITYP+1)
	    ITS(J)=ITYP
	  end do                     !    Nsite -> type
	  do IS=1,NSPEC(ITYP)
	    IMOL=IMOL+1
          do I=1,NSITS(ITYP)
	      ISITE=IST+I
	      IATOM=IATOM+1
	      NNUM(IATOM)=IMOL        !   Natom -> Nmol
	      NSITE(IATOM)=ISITE      !   Natom -> Nsite
	      ITYPE(IATOM)=ITYP       !   Natom -> type
	      if(IPRINT.ge.9)write(*,'(4I6,2x,2a4,a6)')
     +      IATOM,IMOL,ISITE,ITYP,NM(ISITE)
	    end do
	  end do
      end do  
	HBOXL=0.5*BOXL
	HBOYL=0.5*BOYL
	HBOZL=0.5*BOZL
	VOL=BOXL*BOYL*BOZL 
*  Zero tables
	do IX=0,NRX
	  do IY=0,NRY
	    P3COR(IX,IY)=0.d0
	    P3CO2(IX,IY)=0.d0
	  end do
	end do
	do IX=0,2*NOM
	  do IY=0,NOM
	    POR(IX,IY)=0.
	  end do
	end do 
	ITIR=0
	ITIR1=0
	ITIR2=0
	TIMRS=0
	TIMRS1=0.
	TIMRS2=0.
	COR2=0.d0
	COR22=0.d0                 
	FULTIM1=TIMIN(1)
	if(LDIFF)write(*,*)
     +' Calculation of the diffusion coefficients for type ',IDF,
     + NSPEC(IDF),NSITS(IDF)
*  Begin reading data file
	do IFL=1,NF        
	  IIN=0
        open (unit=12,file=filnam(IFL),status='old',
     +  form='unformatted')
        read(12) IA, dt, boxl, boyl, bozl, unitl, ntypes,
     x                (nspec(i),nsits(i),logo,i=1,ntypes)
 
        do ityp=1, ntypes
          NSB            = ISADR (ITYP)+1
          NSE            = ISADR (ITYP+1)
* Lines from 2 to NTYPES+1
          read( 12 ) (mass(j), j=NSB,NSE)
        end do 
* First line of a point
  35    read(12,err=40,end=45) 
     +  IA, fultim, cumtim, fdir,BOXL,BOYL,BOZL,LIST
	  if(IIN.eq.0)then
 	    write(*,'(2a/a,f14.3,a8,6I3)')
     +  ' begin analys of file  ',filnam(IFL), 
     +  ' init. T = ',fultim*1.d12,'   LIST=',(LIST(I),I=1,NTYPES)
	    IIN=1
	  end if  
	  IBREAK=0
	  DIFT=FULTIM-FULTIM1
	  if(DIFT.gt.5.d-12)then
	    write(*,*)
     +    'break in trajectory file. from ',FULTIM1*1.d12,' to ',
     +    FULTIM*1.d12,'ps'
	    IBREAK=1
	  end if    
	  if(IPRINT.ge.4.and.(LCOR3.or.LORIENT))
     +    write(*,'(a,f10.3,3x,a,f12.0,I12)')
     +    ' time=',fultim*1.d12,' N conf.',COR2,NCOR
	  if(IFL.lt.NF.and.fultim.ge.TIMIN(IFL+1))go to 45
	  FULTIM1=FULTIM
c
c - dlya kazhdogo tipa!
        do ityp=1,ntypes
           NSB          = ISADDR(ITYP)+1
           NSE         = ISADDR(ITYP+1) 
* Other NTYPES lines of each point
           if(LIST(ITYP).ne.0)read(12,err=40,end=45) (TX(j),j=NSB,NSE),
     *                (TY(j),j=NSB,NSE),
     *                (TZ(j),j=NSB,NSE)
	    do J=NSB,NSE
	      SX(J)=TX(J)
	      SY(J)=TY(J)
	      SZ(J)=TZ(J)
	    end do
        end do    
	  if(JBREAK.eq.1)then  
	    do I=1,NSTOT
	      OX(I)=SX(I)
	      OY(I)=SY(I)
	      OZ(I)=SZ(I)
	    end do           
	  end if
	  JBREAK=0
	  DIFT=DIFT*1.d12
	  if(DIFT.le.0.0001)DIFT=0.0001
	  do I=1,NSTOT
	    DX=SX(I)-OX(I)
	    DY=SY(I)-OY(I)
	    DZ=SZ(I)-OZ(I)
 	    call PBC(DX,DY,DZ)
	    VX(I)=DX/DIFT
	    VY(I)=DY/DIFT
	    VZ(I)=DZ/DIFT
	    OX(I)=SX(I)
	    OY(I)=SY(I)
	    OZ(I)=SZ(I)
	  end do
	  if(LCOR3)then
	    do IGR=1,NDUP   
	      if(IGR.le.NDUR)then
	        call COR3(IGR,1)
	      else
		call COR3(IGR,2)
	      end if
	    end do
	  end if
	  if(LORIENT)then
	    do IGR=1,NDUP
	      call ORIENT(IGR)
	    end do
	  end if           
	  if(mod(IAN/NDUP,ISTEP).eq.0.and.LDM.and.LIST(IMT1).ne.0.
     +     .and.LIST(IMT2).ne.0)then
	    call DIFCROS
	  end if
	  if(mod(IAN/NDUP,ISTEP).eq.0.and.LDIFF.and.LIST(IDF).ne.0)then
	    call DIFFUS
	  end if
	  if(mod(IAN/NDUP,ISTEP).eq.0.and.LMUT.and.LIST(IMT1).ne.0.
     +     .and.LIST(IMT2).ne.0.and.DIFT.gt.0.001)then
	    call VACFS
	  end if
	  if(LDIF2.and.mod(IAN/NDUP,ISTEP).eq.0.and.LIST(IDFM1).ne.0
     +  .and.LIST(IDFM2).ne.0)then
	    call DIFF2
	  end if
	  if(LRES)then
	    call RESTIM
	  end if
	  IAN=IAN+NDUP
	  go to 35
 40	  write(*,*)' input error in file ',filnam(IFL),' T=',FULTIM*1.d12
 45	  write(*,'(2a/a,f10.3,a,f12.0,3i8)')
     +' finish analys of file ',filnam(IFL), 
     +  ' final T = ',fultim*1.d12,'      N conf.  ',COR2,NCOR,ITIR,NDP2
	end do
	write(*,*)' finish analys of the trajectory'
      write(*,*)' total number of configurations ',IAN  
*   Base pair RDF
	if(LCOR3)then  
	  NSS=NSPEC(ITS(IS1(1)))
	  NPAIRS=NSS*NSPEC(ITS(IS2(1)))
	  if(IS1(1).eq.IS2(1))NPAIRS=NSS*(NSS-1)
	  SH12=4*PI*D12*(RB12**2+D12**2/12.d0)
	  RDF2=COR2*VOL/(dfloat(IAN*NPAIRS)*SH12)
	  write(*,'(a,f8.3,a,f9.5)')
     +' 1-2 pair correlation at r=',RB12,' is ',RDF2
	end if
*   Final output
	if(LCOR3)call MCOR3
	if(LORIENT)call MORI
	if(LDIFF)call MDIFF(fildif)
	if(LDM)call MDFM(fildif)
	if(LMUT)call MDIFM(fildfm)
	if(LDIF2)then
	  open(unit=16,file=fildif2,status='unknown')
	  write(16,'(a)')'#  mutual diffusion <dR1*dR2>(t) '
	  write(16,'(a,i5,a,i5)')'#  sites ',IDFM1,' and ',IDFM2
	  write(16,'(a,f8.3,a,f8.4)')'#  base ',RDIF2, ' +/- ',DDIF2
	  write(16,'(a)')'#  time         <dR1*dR2>'
	  do I=1,NTT
	    if(NCUM2(I).gt.0)write(16,*)
     +    I*DTT*1.d12,RCUM2(I)/NCUM2(I),NCUM2(I) 
	  end do
	end if                                     
	if(LRES)then
        open(unit=15,file=filres,status='unknown')
	  write(15,*)'#  distribution over time residence '
	  write(15,*)'#  sites ',IR1,' and ',IR2
	  write(15,*)'#  between ',RRN,' and ',RRX,' +/- ',RRD 
	  write(15,*)'#  total ',ITIR2,' and ',ITIR,' events'
	  write(15,*)'#  longer T* time ',ITIR1
	  write(15,*)
	  write(15,*)'#  average residence time sta',TIMRS2/ITIR2,' ps' 
	  write(15,*)'#  average residence time alt',TIMRS/ITIR,' ps' 
	  write(15,*)'#  exponent decay            ',
     +  TIMRS1/ITIR1-TTER*1.d12,' ps'
	  write(15,*)
	  write(15,*)'#  time(ps)      hits1      P1     DECAY    ',
     +  ' hits2      P2'
	  DTIRS=ITIR2
	  do I=1,NITT  
	    PPP1=DIST2(I)/ITIR2
	    DTIRS=DTIRS-DIST2(I)
	    PFUN=DTIRS/ITIR2          
	    TTT=I*TIMM/NITT                 
	    PPP=DISTT(I)/ITIR          
	    write(15,'(f12.3,2x,f6.0,2f13.8,2x,f6.0,f13.8)')
     +    TTT,DIST2(I),PPP1,PFUN,DISTT(I),PPP
	  end do
	end if
	stop
	end  
*          
*========================= COR3 ======================================
*
	subroutine COR3(IGR,ICL)
	include 'mdan.h'
*  calculation of 3-body correlations
	IT1=ITS(IS1(IGR))     ! num of type
	IT2=ITS(IS2(IGR))     
	IT3=ITS(IS3(IGR))    
	NBG1=ISADDR(IT1)+IS1(IGR)-ISADR(IT1)
	NEN1=ISADDR(IT1+1)
	NST1=NSITS(IT1) 
	NBG2=ISADDR(IT2)+IS2(IGR)-ISADR(IT2)
	NEN2=ISADDR(IT2+1)
	NST2=NSITS(IT2) 
	NBG3=ISADDR(IT3)+IS3(IGR)-ISADR(IT3)
	NEN3=ISADDR(IT3+1)
	NST3=NSITS(IT3) 
      NB12=(sqrt(RB12)-RMIN12)/DR12+1
	do I=NBG1,NEN1,NST1
	  do J=NBG2,NEN2,NST2
	    DX12=SX(I)-SX(J)
	    DY12=SY(I)-SY(J)
	    DZ12=SZ(I)-SZ(J)
	    call PBC(DX12,DY12,DZ12)
	    R12S=DX12**2+DY12**2+DZ12**2   
	    if(R12S.gt.RMN12.and.R12S.lt.RMX12)then
*	write(*,'(6I4,3f12.3)')I,J,IT1,IT2,IS1(IGR),IS2(IGR),RMN12,R12S,RMX12
	      R12=sqrt(R12S)
	      COR2=COR2+1.d0                   
	      do K=NBG3,NEN3,NST3
	        if(I.ne.K.and.J.ne.K)then
	          DX13=SX(I)-SX(K)
	          DY13=SY(I)-SY(K)
	          DZ13=SZ(I)-SZ(K)
	          call PBC(DX13,DY13,DZ13)
	          R13=DX13**2+DY13**2+DZ13**2
		  SCP=(DX12*DX13+DY12*DY13+DZ12*DZ13)/R12
		  X3=SCP-0.5d0*R12
		  Y3=dsqrt(R13-SCP**2)
		  IX3=(X3+RMAXX)/DXX
		  IY3=Y3/DYY            
* 	write(*,'(3I4,3f12.4,3I4)')I,J,K,R12,X3,Y3,IX3,IY3,NRX 
		  if(ICL.eq.1)then
	  	  if(IX3.le.NRX.and.X3+RMAXX.gt.0.d0.and.IY3.le.NRY)
     +            P3COR(IX3,IY3)=P3COR(IX3,IY3)+1.d0
		  else
	  	  if(IX3.le.NRX.and.X3+RMAXX.gt.0.d0.and.IY3.le.NRY)
     +            P3CO2(IX3,IY3)=P3CO2(IX3,IY3)+1.d0
		  end if 
	  	end if
	      end do
	    end if
	  end do
	end do
	return
	end
*
*============================== ORIENT ==============================
*	                                                               
	subroutine ORIENT(IGR)
	include 'mdan.h'
	IM1=ISADDR(ITH)+1
	IM2=ISADDR(ITH+1)
	IM3=NSITS(ITH) 
	NOM2=2*NOM
	IZY=ROMAX/DDO
	if(IM3.lt.3)return
	do I=IM1,IM2,IM3          !  over O in H2O molecules
	  JT=ITS(ISOR(IGR))
	  NBG=ISADDR(JT)+ISOR(IGR)-ISADR(JT)
	  NEN=ISADDR(JT+1)
	  NST=NSITS(JT)
	  I1=I+1
	  I2=I+2
        DX1=SX(I)-SX(I1)
        DY1=SY(I)-SY(I1)
        DZ1=SZ(I)-SZ(I1)
        DX2=SX(I)-SX(I2)
        DY2=SY(I)-SY(I2)
        DZ2=SZ(I)-SZ(I2)
	  call PBC(DX1,DY1,DZ1)
	  call PBC(DX2,DY2,DZ2)
	  XN= DY1*DZ2-DY2*DZ1        ! normal v. to HOH plane  (Z axis)
	  YN=-DX1*DZ2+DX2*DZ1
	  ZN= DX1*DY2-DX2*DY1
	  RN=sqrt(XN**2+YN**2+ZN**2)
	  XN=XN/RN
	  YN=YN/RN
	  ZN=ZN/RN
	  XN2=DX1+DX2                 ! mediana of HOH angle  ( X axis)
	  YN2=DY1+DY2
	  ZN2=DZ1+DZ2
	  RN2=sqrt(XN2**2+YN2**2+ZN2**2)
	  do J=NBG,NEN,NST        ! over other atoms
	    DX=SX(J)-SX(I)
	    DY=SY(J)-SY(I)
	    DZ=SZ(J)-SZ(I)
	    call PBC(DX,DY,DZ)
	    RR2=DX**2+DY**2+DZ**2
	    if(RR2.lt.ROMAX2)then
	      RR=sqrt(RR2)
            ZM=XN*DX+YN*DY+ZN*DZ       ! Z-coord in molec.c.s. 
	      RRP2=RR2-ZM**2               
	      RRP=sqrt(RRP2)
 	      PX=DX-XN*ZM            ! projection RR to HOH plane
	      PY=DY-YN*ZM
	      PZ=DZ-ZN*ZM  
	      CF=(PX*XN2+PY*YN2+PZ*ZN2)/(RN2*RRP)
	      XM=-RRP*CF                     !  X coord in molec. c.s.
	      YM=sqrt(RRP2-XM**2)  
	      if(IPROC.eq.1.and.abs(abs(ZM)-ZB).le.DZB)then  ! case of Z=ZB plane            
	        NXM=(XM+ROMAX)/DDO
	        NYM=YM/DDO
		if(NXM.ge.0.and.NXM.le.NOM2.and.NYM.le.NOM)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if
	      if(IPROC.eq.2.and.abs(YM-ZB).le.DZB)then   ! Y=ZB plane         
	        NXM=(XM+ROMAX)/DDO
	        NYM=abs(ZM)/DDO
		if(NXM.ge.0.and.NXM.le.NOM2.and.NYM.le.NOM)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if
	      if(IPROC.eq.3.and.abs(XM-ZB).le.DZB)then    ! X=ZB plane        
	        NXM=(ZM+ROMAX)/DDO
	        NYM=YM/DDO
		if(NXM.ge.0.and.NXM.le.NOM2.and.NYM.le.NOM)then
	   	  NCOR=NCOR+1
     		  POR(NXM,NYM)=POR(NXM,NYM)+1.
		end if
	      end if
	    end if
	  end do
*  Mark hydrogens of the water molecule  
	  RRH2=DX1**2+DY1**2+DZ1**2
	  RRH=sqrt(RRH2)
	  CF=(DX1*XN2+DY1*YN2+DZ1*ZN2)/(RN2*RRH)
	  XM=RRH*CF                   
	  YM=sqrt(RRH2-XM**2)  
	  NXM=(XM+ROMAX)/DDO
	  NYM=YM/DDO  
	  if(IPROC.eq.1.and.XM+ROMAX.gt.0.d0.and.NXM.le.NOM2
     +    .and.NYM.le.NOM)
     +    POR(NXM,NYM)=POR(NXM,NYM)+1.
	  if(IPROC.eq.2.and.NXM.ge.0.and.NXM.le.NOM2)
     +    POR(NXM,0)=POR(NXM,0)+1.
	  if(IPROC.eq.3.and.NYM.le.NOM)
     +    POR(IZY,NYM)=POR(IZY,NYM)+1.
	end do
	return
	end
*
*==================== MCOR3 ==========================================
*
	subroutine MCOR3 
	include 'mdan.h'
	dimension ZI(0:NMX)
c     
	write(*,*)' Enter MCOR3'
      NB12=(sqrt(RB12)-RMIN12)/DR12+1 
	NOP3=0
	do I=1,NDUR
	  NOP3=NOP3+NSPEC(ITS(IS3(I)))
	end do
	if(LCOL2)then
	  NOP4=0
	  do I=NDUR+1,NDUP
	    NOP4=NOP4+NSPEC(ITS(IS3(I))) 
	  end do
	end if
	X0=-RMAXX             ! koord. polya vyvoda
	X1= RMAXX
	Y0=-RMAXY
	Y1= RMAXY             
	XA1=-0.5*RB12
	XA2=-XA1              ! koord. pervogo i vtorogo atomov
	YA1=0.               
	YA2=0.
	FCC=1.
*	if(IS1(1).eq.IS2(1))FCC=2.   
*   Write data file for 3-d plot (Mathematica)
	open(unit=15,file='3cor.data',status='unknown')  
 201  format(202f10.4) 
	do IYT=-NRY,NRY
	  IY=iabs(IYT)
	  Y3=IYT*DYY
	  YIY=(IY+0.5)*DYY             
	  SH3=abs(2.*PI*DXX*DYY*YIY)
	  FACR=NDUP*VOL/(COR2*NOP3*SH3*FCC) 
	  do IX=0,NRX
	    X3=IX*DXX-RMAXX     
	    ZI(IX)=P3COR(IX,IY)*FACR
*	    write(15,'(3f10.5)')X3,Y3,ZI
	  end do
	  write(15,201)(ZI(I),I=0,NRX)
	end do 
	close(15)
	write(*,*)' num. of part.',NOP3,NOP4
	do IYT=0,NTY             ! abs. coord. na grafike    
        YI=(IYT+0.5)*RMAXY/NTY 
	  IY=YI/DYY
	  YIY=(IY+0.5)*DYY             
	  SH3=abs(2.*PI*DXX*DYY*YIY)
	  FACR=NDUP*VOL/(COR2*NOP3*SH3*FCC)
	  if(LCOL2)FAC2=NDUP*VOL/(COR2*NOP4*SH3*FCC)  
	if(IPRINT.ge.5)write(*,*)IYT,FACR,FAC2
	  do IXT=-NTX,NTX
	    XI=(IXT+0.5)*RMAXX/NTX               ! dec.coord.tochki
	    IX=(XI-X0)/DXX+0.001
	    if(IX.le.NRX.and.IX.ge.0.and.IY.le.NRY.and.IY.ge.0)then
	      COREL=P3COR(IX,IY)*FACR
	      CORE2=P3CO2(IX,IY)*FAC2
	    else
	      COREL=0.               
	      CORE2=0.
	    end if 
	    if(LCOL2)then
 	      ICOL=NCOLOR2(COREL,CORE2,AMPL,MAXCOLOR)
	      if(IPRINT.ge.6)write(*,'(2I4,2f8.3,2x,2I5,2f12.6,I5)')
     +IX,IY,XI,YI,IXT,IYT,COREL,CORE2,ICOL
	    else
   	      ICOL=NCOLOR(COREL,AMPL,MAXCOLOR) 
	      if(ICOL.gt.MAXCOLOR)ICOL=MAXCOLOR
	      if(IPRINT.ge.6)write(*,'(2I4,2f8.3,2x,2I5,f12.6,I5)')
     +IX,IY,XI,YI,IXT,IYT,COREL,ICOL
	    end if
          ITAB(IYT,IXT)=ICOL 
	  end do
	end do
*  Mark point 1,2
	IX1=XA1*NTX/RMAXX
	IX2=XA2*NTX/RMAXX
	IY =YA1*NTY/RMAXY 
	if(LCOL2)then
	  ITAB(IY,IX1)=(MAXCOLOR+1)**2
	  ITAB(IY,IX2)=(MAXCOLOR+1)**2
	  call MAKEPS2(fil3cor,IX1,IX2,IY)
	else
	  ITAB(IY,IX1)=MAXCOLOR
	  ITAB(IY,IX2)=MAXCOLOR
	  call MAKEPS(fil3cor)
	end if
	return
	end
*
*=================== MORI ===============================
*
	subroutine MORI 
	include 'mdan.h'  
	X0=-ROMAX             ! koord. polya vyvoda
	X1= ROMAX
	Y0=-ROMAX
	Y1= ROMAX             
	XA=0.
	YA=0. 
	NOP2=2*NOP
	NH2O=NSPEC(ITH)
	NMOL=NSPEC(ITS(ISOR(1))) 
	if(DZB.ge.ZB)then 
	  SH=4.d0*DDO**2*(DZB+ZB)
	else
	  SH=8.d0*DDO**2*DZB
	end if
	FACR=VOL/(NH2O*NMOL*SH*IAN)               
	do IYT=0,NTY
        YI=(IYT+0.5)*ROMAX/NTY
	  do IXT=-NTX,NTX
	    XI=(IXT+0.5)*ROMAX/NTX               ! dec.coord.tochki
	    IY=YI/DDO+0.5
	    IX=(XI-X0)/DDO+0.5
	    COREL=POR(IX,IY)*FACR 
 	    ICOL=NCOLOR(COREL,AMPL,MAXCOLOR)
	    if(ICOL.gt.MAXCOLOR)ICOL=MAXCOLOR
	    if(IPRINT.ge.5)write(*,'(2I4,2f8.3,2x,2I5,f12.6,I5)')
     +IX,IY,XI,YI,IXT,IYT,COREL,ICOL
	    ITAB(IYT,IXT)=ICOL
	  end do
	end do
*  Mark C.O.
	IX =XA*NTX/ROMAX
	IY =YA*NTY/ROMAX  
	ITAB(IX,IY)=MAXCOLOR
	call MAKEPS(filori)
	return
	end
*          
*========================= DIFFUS ======================================
*
	subroutine DIFFUS
	include 'mdan.h'
	data IREC/1/,IINIT/0/
	save IREC,IINIT  
*  calculation of diffusion coefficients 
	ITYP		= IDF
      N           = ISADDR(ITYP)
      I           = IADDR(ITYP)
      NSBEG       = ISADR  (ITYP)+1
      NSEND       = ISADR  (ITYP +1)
	if(IREC.eq.1.and.IINIT.eq.0)then
	  SUMM=0.
	  do IS=NSBEG,NSEND
	    SUMM=SUMM+MASS(IS)
	  end do
	end if  
	IML=NSPEC(ITYP)
	if(IML.gt.MAXMOL)IML=MAXMOL
      DO J        = 1,IML   ! sum over molecules
        I           = I+1
        XX       = 0.D0
        YY       = 0.D0
        ZZ       = 0.D0 
Calculate C.O.M. vectors:
        DO IS       = NSBEG,NSEND
          N           = N+1
          XX       = XX+MASS(IS)*SX(N)
          YY       = YY+MASS(IS)*SY(N)
          ZZ       = ZZ+MASS(IS)*SZ(N)
        END DO! OF IS
        XX       = XX/SUMM+ISHX(J)*BOXL
        YY       = YY/SUMM+ISHY(J)*BOYL
        ZZ       = ZZ/SUMM+ISHZ(J)*BOZL
*  PBC**(-1)
	  if(IINIT.ne.0.or.IREC.ne.1)then
	    IREC1=IREC-1
	    if(IREC1.le.0)IREC1=IREC1+MTR 
	    if(XX-TRCX(IREC1,J).gt. HBOXL)then
	      ISHX(J)=ISHX(J)-1
	      XX=XX-BOXL
	    end if
	    if(XX-TRCX(IREC1,J).lt.-HBOXL)then
	      ISHX(J)=ISHX(J)+1
	      XX=XX+BOXL
	    end if
	    if(YY-TRCY(IREC1,J).gt. HBOYL)then
	      ISHY(J)=ISHY(J)-1
	      YY=YY-BOYL
	    end if
	    if(YY-TRCY(IREC1,J).lt.-HBOYL)then
	      ISHY(J)=ISHY(J)+1
	      YY=YY+BOYL
	    end if
	    if(ZZ-TRCZ(IREC1,J).gt. HBOZL)then
	      ISHZ(J)=ISHZ(J)-1
	      ZZ=ZZ-BOZL
	    end if
	    if(ZZ-TRCZ(IREC1,J).lt.-HBOZL)then
	      ISHZ(J)=ISHZ(J)+1
	      ZZ=ZZ+BOZL
	    end if
	  end if	  
*  remember 
	  TRCX(IREC,J)=XX	  
	  TRCY(IREC,J)=YY	  
	  TRCZ(IREC,J)=ZZ  
	  JM=J
      END DO! OF J   
	TTIM(IREC)=FULTIM 
	if(IPRINT.ge.6)write(*,'(4f10.3,I7,2x,3I3)')
     +FULTIM*1.d12,TRCX(IREC,ICNT),TRCY(IREC,ICNT),TRCZ(IREC,ICNT),
     +IREC,ISHX(ICNT),ISHY(ICNT),ISHZ(ICNT)
*  calculate <R(t)-R(0)>
	IRB=IREC  
	IRB1=IRB+1
	if(IRB1.gt.MTR)IRB1=1
	IROUND=0
	do IT=1,NTT
	  TBACK=FULTIM-IT*DTT
*	  write(*,*)IT,FULTIM*1.d12,TBACK*1.d12,IRB,TTIM(IRB)*1.d12
 10	  if(TTIM(IRB).le.TBACK)then
	    if(TTIM(IRB1)-TTIM(IRB).lt.5.*DTT)then
	    AL=(TBACK-TTIM(IRB))/(TTIM(IRB1)-TTIM(IRB))      
	    if(AL.lt.0.d0.or.AL.gt.1.d0)write(*,'(a,f9.5,I7,3e14.5)')
     +  ' strange ALPHA: ',AL,IRB,TTIM(IRB),TBACK,TTIM(IRB1)  
          DO J        = 1,IML   ! sum over molecules
	      X0=TRCX(IRB,J)*(1.-AL)+TRCX(IRB1,J)*AL
	      Y0=TRCY(IRB,J)*(1.-AL)+TRCY(IRB1,J)*AL
	      Z0=TRCZ(IRB,J)*(1.-AL)+TRCZ(IRB1,J)*AL
	      RR=(X0-TRCX(IREC,J))**2+(Y0-TRCY(IREC,J))**2+
     +              (Z0-TRCZ(IREC,J))**2
	      RCUM(IT)=RCUM(IT)+RR
	      NCUM(IT)=NCUM(IT)+1  
	      if(IPRINT.ge.8)write(*,'(2I6,2f12.6)')
     +      IT,J,IT*DTT*1.d12,sqrt(RR)
	    end do   
	    end if
	  else
	    IRB1=IRB
	    IRB=IRB-1
	    if(IRB.le.0)then
	      if(IINIT.eq.0)go to 30
	      IRB=MTR
	      IROUND=1
	    end if
	    if(IRB.le.IREC.and.IROUND.eq.1)go to 30
	    go to 10
	  end if
	end do ! of IT
 30	IREC=IREC+1
	if(IREC.gt.MTR)then
	  IREC=1
	  IINIT=1
	end if
	return
	end   
*          
*========================= DIFCROS ======================================
*
	subroutine DIFCROS
	include 'mdan.h'
	data IREC/1/,IINIT/0/
	save IREC,IINIT  
*  calculation of diffusion coefficients 
	ITRAP=0
 10	if(ITRAP.eq.0)then
	  ITYP		= IMT1     
	  IM0=1
	else
	  ITYP= IMT2
	  IM0=IML+1
	end if
      N           = ISADDR(ITYP)
      I           = IADDR(ITYP)
      NSBEG       = ISADR  (ITYP)+1
      NSEND       = ISADR  (ITYP +1)
	  SUMM=0.
	  do IS=NSBEG,NSEND
	    SUMM=SUMM+MASS(IS)
	  end do
	IML=NSPEC(ITYP)
	if(IML.gt.MAXMOL)stop "increase MAXMOL"
      DO J        = IM0,IM0+IML-1   ! sum over molecules
        I           = I+1
        XX       = 0.D0
        YY       = 0.D0
        ZZ       = 0.D0 
Calculate C.O.M. vectors:
        DO IS       = NSBEG,NSEND
          N           = N+1
          XX       = XX+MASS(IS)*SX(N)
          YY       = YY+MASS(IS)*SY(N)
          ZZ       = ZZ+MASS(IS)*SZ(N)
        END DO! OF IS
        XX       = XX/SUMM+ISHX(J)*BOXL
        YY       = YY/SUMM+ISHY(J)*BOYL
        ZZ       = ZZ/SUMM+ISHZ(J)*BOZL
*  PBC**(-1)
	  if(IINIT.ne.0.or.IREC.ne.1)then
	    IREC1=IREC-1
	    if(IREC1.le.0)IREC1=IREC1+MTR 
	    if(XX-TRCX(IREC1,J).gt. HBOXL)then
	      ISHX(J)=ISHX(J)-1
	      XX=XX-BOXL
	    end if
	    if(XX-TRCX(IREC1,J).lt.-HBOXL)then
	      ISHX(J)=ISHX(J)+1
	      XX=XX+BOXL
	    end if
	    if(YY-TRCY(IREC1,J).gt. HBOYL)then
	      ISHY(J)=ISHY(J)-1
	      YY=YY-BOYL
	    end if
	    if(YY-TRCY(IREC1,J).lt.-HBOYL)then
	      ISHY(J)=ISHY(J)+1
	      YY=YY+BOYL
	    end if
	    if(ZZ-TRCZ(IREC1,J).gt. HBOZL)then
	      ISHZ(J)=ISHZ(J)-1
	      ZZ=ZZ-BOZL
	    end if
	    if(ZZ-TRCZ(IREC1,J).lt.-HBOZL)then
	      ISHZ(J)=ISHZ(J)+1
	      ZZ=ZZ+BOZL
	    end if
	  end if	  
*  remember 
	  TRCX(IREC,J)=XX	  
	  TRCY(IREC,J)=YY	  
	  TRCZ(IREC,J)=ZZ  
      END DO! OF J   
	if(ITRAP.eq.0)then
	  IM1=IML
	  ITRAP=1
	  go to 10	
      else
        IM2=IM0+IML-1
      end if
	TTIM(IREC)=FULTIM 
	if(IPRINT.ge.6)write(*,'(4f10.3,I7,2x,3I3)')
     +FULTIM*1.d12,TVX(IREC,ICNT),TVY(IREC,ICNT),TVZ(IREC,ICNT),
     +IREC,IM1,IM2
	if(IM2.gt.MAXMOL)stop "increase MAXMOL"
*   calculation of cross-correlation
	TTIM(IREC)=FULTIM 
	if(IPRINT.ge.6)write(*,'(4f10.3,I7,2x,3I3)')
     +FULTIM*1.d12,TRCX(IREC,ICNT),TRCY(IREC,ICNT),TRCZ(IREC,ICNT),
     +IREC,ISHX(ICNT),ISHY(ICNT),ISHZ(ICNT)
*  calculate <R(t)-R(0)>
	IRB=IREC  
	IRB1=IRB+1
	if(IRB1.gt.MTR)IRB1=1
	IROUND=0
	do IT=1,NTT
	  TBACK=FULTIM-IT*DTT
*	  write(*,*)IT,FULTIM*1.d12,TBACK*1.d12,IRB,TTIM(IRB)*1.d12
 20	  if(TTIM(IRB).le.TBACK)then
	    if(TTIM(IRB1)-TTIM(IRB).lt.5.*DTT)then
	    AL=(TBACK-TTIM(IRB))/(TTIM(IRB1)-TTIM(IRB))      
	    if(AL.lt.0.d0.or.AL.gt.1.d0)write(*,'(a,f9.5,I7,3e14.5)')
     +  ' strange ALPHA: ',AL,IRB,TTIM(IRB),TBACK,TTIM(IRB1)
	    do I	= 1,IM2   ! double
	      XI0=TRCX(IRB,I)*(1.-AL)+TRCX(IRB1,I)*AL
	      YI0=TRCY(IRB,I)*(1.-AL)+TRCY(IRB1,I)*AL
	      ZI0=TRCZ(IRB,I)*(1.-AL)+TRCZ(IRB1,I)*AL
              DO J        = 1,IM2   ! sum over molecules
	        XJ0=TRCX(IRB,J)*(1.-AL)+TRCX(IRB1,J)*AL
	        YJ0=TRCY(IRB,J)*(1.-AL)+TRCY(IRB1,J)*AL
	        ZJ0=TRCZ(IRB,J)*(1.-AL)+TRCZ(IRB1,J)*AL
	        SC=(XI0-TRCX(IREC,I))*(XJ0-TRCX(IREC,J))+
     +	   (YI0-TRCY(IREC,I))*(YJ0-TRCY(IREC,J))+
     +	   (ZI0-TRCZ(IREC,I))*(ZJ0-TRCZ(IREC,J))
		if(I.eq.J.and.I.le.IM1)RCUM11(IT)=RCUM11(IT)+SC
		if(I.eq.J.and.I.gt.IM1)RCUM22(IT)=RCUM22(IT)+SC
		if(I.ne.J)then 
	if((I.le.IM1.and.J.le.IM1).or.(I.gt.IM1.and.J.gt.IM1))then
	            RCUM12(IT)=RCUM12(IT)+SC 
		  else
	            RCUM12(IT)=RCUM12(IT)-SC
		  end if
		end if 
	      end do
	    end do
	    NCUM(IT)=NCUM(IT)+1  
	    end if
	  else
	    IRB1=IRB
	    IRB=IRB-1
	    if(IRB.le.0)then
	      if(IINIT.eq.0)go to 30
	      IRB=MTR
	      IROUND=1
	    end if
	    if(IRB.le.IREC.and.IROUND.eq.1)go to 30
	    go to 20
	  end if
	end do ! of IT
 30	IREC=IREC+1
	if(IREC.gt.MTR)then
	  IREC=1
	  IINIT=1
	end if
	return
	end   
*========================= VACFS ======================================
*
	subroutine VACFS
	include 'mdan.h'
	data IREC/1/,IINIT/0/
	save IREC,IINIT  
*  calculation of diffusion coefficients 
	ITRAP=0
 10	if(ITRAP.eq.0)then
	  ITYP		= IMT1     
	  IM0=1
	else
	  ITYP= IMT2
	  IM0=IML+1
	end if
      N           = ISADDR(ITYP)
      I           = IADDR(ITYP)
      NSBEG       = ISADR  (ITYP)+1
      NSEND       = ISADR  (ITYP +1)
	if(IREC.eq.1.and.IINIT.eq.0)then
	  SUMM=0.
	  do IS=NSBEG,NSEND
	    SUMM=SUMM+MASS(IS)
	  end do
	end if  
	IML=NSPEC(ITYP)
	if(IML.gt.MAXMOL)IML=MAXMOL
      DO J        = IM0,IM0+IML-1   ! sum over molecules
        I           = I+1
        XX       = 0.D0
        YY       = 0.D0
        ZZ       = 0.D0 
Calculate C.O.M. vectors:
        DO IS       = NSBEG,NSEND
          N           = N+1
          XX       = XX+MASS(IS)*VX(N)
          YY       = YY+MASS(IS)*VY(N)
          ZZ       = ZZ+MASS(IS)*VZ(N)
        END DO! OF IS
*  remember 
	  TVX(IREC,J)=XX	  
	  TVY(IREC,J)=YY	  
	  TVZ(IREC,J)=ZZ  
      END DO! OF J   
	if(ITRAP.eq.0)then
	  IM1=IML
	  ITRAP=1
	  go to 10	
      else
        IM2=IM0+IML-1
      end if
	TTIM(IREC)=FULTIM 
	if(IPRINT.ge.6)write(*,'(4f10.3,I7,2x,3I3)')
     +FULTIM*1.d12,TVX(IREC,ICNT),TVY(IREC,ICNT),TVZ(IREC,ICNT),
     +IREC,IM1,IM2
*  calculate <R(t)-R(0)>
	IRB=IREC  
	IRB1=IRB+1
	if(IRB1.gt.MTR)IRB1=1
	IROUND=0
	do IT=0,NTT
	  TBACK=FULTIM-IT*DTT
 20	  if(TTIM(IRB).lt.TBACK-DTT*0.001)then
*	  write(*,'(i5,2f12.5,2(I5,f12.5))')IT,FULTIM*1.d12,TBACK*1.d12,
*     +IRB,TTIM(IRB)*1.d12,IRB1,TTIM(IRB1)*1.d12
          DO J        = 1,IM2   ! sum over molecules
	      X0=TVX(IRB1,J)
	      Y0=TVY(IRB1,J)
	      Z0=TVZ(IRB1,J)
	      do I=1,IM2
	        SCAL=X0*TVX(IREC,I)+Y0*TVY(IREC,I)+Z0*TVZ(IREC,I)
	        if(I.eq.J)then                                    
		  if(I.le.IM1)then
	  	    VACS1(IT)=VACS1(IT)+SCAL
		  else 
	  	    VACS2(IT)=VACS2(IT)+SCAL
	    	  end if
	        else 
	  	  if(I.le.IM1.and.J.le.IM1)then
                  VACM11(IT)=VACM11(IT)+SCAL
		  else if(I.le.IM1.and.J.gt.IM1)then
                  VACM12(IT)=VACM12(IT)+SCAL
		  else if(I.gt.IM1.and.J.le.IM1)then
                  VACM21(IT)=VACM21(IT)+SCAL
		  else if(I.gt.IM1.and.J.gt.IM1)then
                  VACM22(IT)=VACM22(IT)+SCAL
                end if
	        end if
	      end do
	    end do 
	if(IPRINT.ge.7)write(*,'(i5,6e12.4)')
     +IT,VACS1(IT),VACS2(IT),VACM11(IT),VACM12(IT),VACM21(IT),VACM22(IT)
	    NCUV(IT)=NCUV(IT)+1  
	  else
	    IRB1=IRB
	    IRB=IRB-1
	    if(IRB.le.0)then
	      if(IINIT.eq.0)go to 30
	      IRB=MTR
	      IROUND=1
	    end if
	    if(IRB.le.IREC.and.IROUND.eq.1)go to 30
	    go to 20
	  end if
	end do ! of IT
 30	IREC=IREC+1
	if(IREC.gt.MTR)then
	  IREC=1
	  IINIT=1
	end if
	return
	end   
*========================= DIFF2 ======================================
*
	subroutine DIFF2
*   mutual diffusion
	include 'mdan.h'
	integer ISFX(NDPM),ISFY(NDPM),ISFZ(NDPM),JSFX(NDPM)
     +,JSFY(NDPM),JSFZ(NDPM),III(NDPM),JJJ(NDPM)
	real*8 TDI(NDPM),XDI(NDPM),YDI(NDPM),ZDI(NDPM),XDI0(NDPM),
     +YDI0(NDPM),ZDI0(NDPM),XDJ(NDPM),YDJ(NDPM),ZDJ(NDPM),XDJ0(NDPM),
     +YDJ0(NDPM),ZDJ0(NDPM)
	data IINIT/0/
	save 
*  calculation of diffusion coefficients
	ITYP		= IDFM1
	JTYP		= IDFM2
      IBEG       = IADDR  (ITYP)+1
      IEND       = IADDR  (ITYP +1)
      JBEG       = IADDR  (JTYP)+1
      JEND       = IADDR  (JTYP +1)
	if(IINIT.eq.0)then 
	  SUMMI=0.
	  do IS=ISADR(ITYP)+1,ISADR(ITYP+1)
	    SUMMI=SUMMI+MASS(IS)
	  end do
	  SUMMJ=0.
	  do IS=ISADR(JTYP)+1,ISADR(JTYP+1)
	    SUMMJ=SUMMJ+MASS(IS)
	  end do   
	  do I=1,NDPM
	   ISFX(I)=0
	   ISFY(I)=0
	   ISFZ(I)=0
	   JSFX(I)=0
	   JSFY(I)=0
	   JSFZ(I)=0   
	  end do
	end if  
*  Search for new pairs
      DO I        = IBEG,IEND   ! sum over molecules
        XXI       = 0.D0
        YYI       = 0.D0
        ZZI       = 0.D0 
Calculate C.O.M. vectors:
        DO II       = 1,NSITS(ITYP)  
	    IS	= ISADR(ITYP)+II
          NI           = ISADDR(ITYP)+(I-IBEG)*NSITS(ITYP)+II
          XXI       = XXI+MASS(IS)*SX(NI)
          YYI       = YYI+MASS(IS)*SY(NI)
          ZZI       = ZZI+MASS(IS)*SZ(NI)     
	if(IPRINT.ge.9)write(*,'(4i5,3f12.3)')
     +II,IS,I,NI,SX(NI),SY(NI),SZ(NI)
        END DO! OF IS
	  X(I)=XXI/SUMMI
	  Y(I)=YYI/SUMMI
	  Z(I)=ZZI/SUMMI
        DO J        = JBEG,JEND   ! sum over molecules
          XXJ       = 0.D0
          YYJ       = 0.D0
          ZZJ       = 0.D0 
Calculate C.O.M. vectors:
          DO JJ       = 1,NSITS(JTYP)  
	      JS	= ISADR(JTYP)+JJ
            NJ        = ISADDR(JTYP)+(J-JBEG)*NSITS(JTYP)+JJ
            XXJ       = XXJ+MASS(JS)*SX(NJ)
            YYJ       = YYJ+MASS(JS)*SY(NJ)
            ZZJ       = ZZJ+MASS(JS)*SZ(NJ)     
	if(IPRINT.ge.9)write(*,'(4i5,3f12.3)')
     +JJ,JS,J,NJ,SX(NJ),SY(NJ),SZ(NJ)
          END DO! OF IS
	    X(J)=XXJ/SUMMJ
	    Y(J)=YYJ/SUMMJ
	    Z(J)=ZZJ/SUMMJ
          DX=X(I)-X(J)
	    DY=Y(I)-Y(J)
	    DZ=Z(I)-Z(J)
	    call PBC(DX,DY,DZ)
	    RR2=DX**2+DY**2+DZ**2      
	if(IPRINT.ge.8)write(*,*)I,J,RR2
	    if(RR2.le.RDF2X.and.RR2.ge.RDF2N)then
*   New pair
	      if(NDP2.ge.NDPM)go to 22    
	      NDP2=NDP2+1
	      III(NDP2)=I
	      JJJ(NDP2)=J
	      XDI(NDP2)=X(I)
	      YDI(NDP2)=Y(I)
	      ZDI(NDP2)=Z(I)
	      XDJ(NDP2)=X(J)
	      YDJ(NDP2)=Y(J)
	      ZDJ(NDP2)=Z(J)
	      XDI0(NDP2)=0.
	      YDI0(NDP2)=0.
	      ZDI0(NDP2)=0.
	      XDJ0(NDP2)=0.
	      YDJ0(NDP2)=0.
	      ZDJ0(NDP2)=0.
	      TDI(NDP2)=FULTIM
	      ISFX(NDP2)=0
	      ISFY(NDP2)=0
	      ISFZ(NDP2)=0
	      JSFX(NDP2)=0
	      JSFY(NDP2)=0
	      JSFZ(NDP2)=0  
	if(IPRINT.ge.6)write(*,*)'new pair:',I,J,' num ',NDP2
	    end if         
 22	    continue
	  end do
	end do
*  dr1*dr2 calculation
*      do I=1,NDP2
	I=1
 10	if(I.gt.NDP2)go to 30
        IM=III(I)
	  JM=JJJ(I) 
	  XXI=X(IM)-XDI(I)+ISFX(I)*BOXL
	  YYI=Y(IM)-YDI(I)+ISFY(I)*BOXL
	  ZZI=Z(IM)-ZDI(I)+ISFZ(I)*BOZL
	  XXJ=X(JM)-XDJ(I)+JSFX(I)*BOXL
	  YYJ=Y(JM)-YDJ(I)+JSFY(I)*BOYL
	  ZZJ=Z(JM)-ZDJ(I)+JSFZ(I)*BOZL
*  PBC**(-1)
	  if(IINIT.ne.0)then
	    if(XXI-XDI0(I).gt. HBOXL)then
	      ISFX(I)=ISFX(I)-1
	      XXI=XXI-BOXL
	    end if
	    if(XXI-XDI0(I).lt.-HBOXL)then
	      ISFX(I)=ISFX(I)+1
	      XXI=XXI+BOXL
	    end if
	    if(YYI-YDI0(I).gt. HBOYL)then
	      ISFY(I)=ISFY(I)-1
	      YYI=YYI-BOYL
	    end if
	    if(YYI-YDI0(I).lt.-HBOYL)then
	      ISFY(I)=ISFY(I)+1
	      YYI=YYI+BOYL
	    end if
	    if(ZZI-ZDI0(I).gt. HBOZL)then
	      ISFZ(I)=ISFZ(I)-1
	      ZZI=ZZI-BOZL
	    end if
	    if(ZZI-ZDI0(I).lt.-HBOZL)then
	      ISFZ(I)=ISFZ(I)+1
	      ZZI=ZZI+BOZL
	    end if
	    if(XXJ-XDJ0(I).gt. HBOXL)then
	      JSFX(I)=JSFX(I)-1
	      XXJ=XXJ-BOXL
	    end if
	    if(XXJ-XDJ0(I).lt.-HBOXL)then
	      JSFX(I)=JSFX(I)+1
	      XXJ=XXJ+BOXL
	    end if
	    if(YYJ-YDJ0(I).gt. HBOYL)then
	      JSFY(I)=JSFY(I)-1
	      YYJ=YYJ-BOYL
	    end if
	    if(YYJ-YDJ0(I).lt.-HBOYL)then
	      JSFY(I)=JSFY(I)+1
	      YYJ=YYJ+BOYL
	    end if
	    if(ZZJ-ZDJ0(I).gt. HBOZL)then
	      JSFZ(I)=JSFZ(I)-1
	      ZZJ=ZZJ-BOZL
	    end if
	    if(ZZJ-ZDJ0(I).lt.-HBOZL)then
	      JSFZ(I)=JSFZ(I)+1
	      ZZJ=ZZJ+BOZL
	    end if
	  end if	              
	if(abs(XXI-XDI0(I)).gt.0.5*HBOXL.or.abs(YYI-YDI0(I)).gt.0.5*HBOXL
     +.or.abs(ZZI-ZDI0(I)).gt.0.5*HBOXL)
     +write(*,'(a,i4,3f10.3,a,3f10.3)')
     +' big jump:',IM,XXI,YYI,ZZI,' -> ',XDI0(I),YDI0(I),ZDI0(I)
	if(abs(XXJ-XDJ0(I)).gt.0.5*HBOXL.or.abs(YYJ-YDJ0(I)).gt.0.5*HBOXL
     +.or.abs(ZZJ-ZDJ0(I)).gt.0.5*HBOXL)
     +write(*,'(a,i4,3f10.3,a,3f10.3)')
     +' big jump:',JM,XXJ,YYJ,ZZJ,' -> ',XDJ0(I),YDJ0(I),ZDJ0(I)
*  remember   
	if(IPRINT.ge.6.and.I.eq.ICNT)write(*,'(2(3f10.2,3i3))')
     +XXI,YYI,ZZI,ISFX(I),ISFY(I),ISFZ(I),
     +XXJ,YYJ,ZZJ,JSFX(I),JSFY(I),JSFZ(I)
	  XDI0(I)=XXI
	  YDI0(I)=YYI
	  ZDI0(I)=ZZI
	  XDJ0(I)=XXJ
	  YDJ0(I)=YYJ
	  ZDJ0(I)=ZZJ      
*  accumulate
        IREC=(FULTIM-TDI(I))/DTT+0.49d0
	  if(IREC.gt.0.and.IREC.le.NTT)then
          RCUM2(IREC)=RCUM2(IREC)+XXI*XXJ+YYI*YYJ+ZZI*ZZJ
	    NCUM2(IREC)=NCUM2(IREC)+1        
	  end if
*  max time reached
	  if(IREC.gt.NTT)then          
	if(IPRINT.ge.6)write(*,*)
     +' max time for ',IM,JM,' from ',TDI(I)*1.d12,'  num ',I
	      III(I)=III(NDP2)
	      JJJ(I)=JJJ(NDP2)
	      XDI(I)=XDI(NDP2)
	      YDI(I)=YDI(NDP2)
	      ZDI(I)=ZDI(NDP2)
	      XDJ(I)=XDJ(NDP2)
	      YDJ(I)=YDJ(NDP2)
	      ZDJ(I)=ZDJ(NDP2)
	      XDI0(I)=XDI0(NDP2)
	      YDI0(I)=YDI0(NDP2)
	      ZDI0(I)=ZDI0(NDP2)
	      XDJ0(I)=XDJ0(NDP2)
	      YDJ0(I)=YDJ0(NDP2)
	      ZDJ0(I)=ZDJ0(NDP2)
	      TDI(I)=TDI(NDP2)
	      ISFX(I)=ISFX(NDP2)
	      ISFY(I)=ISFY(NDP2)
	      ISFZ(I)=ISFZ(NDP2)
	      JSFX(I)=JSFX(NDP2)
	      JSFY(I)=JSFY(NDP2)
	      JSFZ(I)=JSFZ(NDP2)
	      ISFX(NDP2)=0
	      ISFY(NDP2)=0
	      ISFZ(NDP2)=0
	      JSFX(NDP2)=0
	      JSFY(NDP2)=0
	      JSFZ(NDP2)=0
            NDP2=NDP2-1 
	  else
	    I=I+1
	  end if 
	go to 10	  
*      END DO! OF    
 30   IINIT=1
	if(IPRINT.ge.6)write(*,'(f10.3,a,i8)')
     +fultim*1.d12,' diff2: ',NDP2
	return
	end   
*

*==================== RESTIM ==========================================
*                                                                      
	subroutine RESTIM
	include 'mdan.h'
	real*4 TIIN(NPART,NPART),TIINI(NPART,NPART),TIINO(NPART,NPART)
	integer IRS(NPART,NPART)
	data IINIT/0/
	save 
	if(IINIT.eq.0)then
	  IINIT=1
	  do I=1,NPART
	    do J=1,NPART
	      IRS(I,J)=0
	    end do
	  end do 
	  do I=1,NTYPES
	    if(ISADR(I).lt.IR1)ITYP=I
	    if(ISADR(I).lt.IR2)JTYP=I
	  end do                
	  IEND=NSPEC(ITYP)
	  write(*,*)'sites ',IR1,' and ',IR2,' are on ',ITYP,' and ',JTYP
	  ISHIFT=ISADDR(ITYP)+IR1-ISADR(ITYP)
	  JSHIFT=ISADDR(JTYP)+IR2-ISADR(JTYP)
	end if 
	if(IBREAK.ne.0)then
	  do I=1,NPART
	    do J=1,NPART
	      IRS(I,J)=0
	    end do
	  end do 
	  write(*,*)' residence time tables set to zero'
	end if     
	if(LIST(ITYP).eq.0.or.LIST(JTYP).eq.0)return
	do I=1,IEND
	  if(IR1.eq.IR2)then
	    JEND=I-1
	  else
          JEND=NSPEC(JTYP)
        end if   
	  ISP=(I-1)*NSITS(ITYP)+ISHIFT
	  do J=1,JEND
	    JSP=(J-1)*NSITS(JTYP)+JSHIFT 
	    DX=SX(ISP)-SX(JSP)
	    DY=SY(ISP)-SY(JSP)
	    DZ=SZ(ISP)-SZ(JSP)
	    call PBC(DX,DY,DZ)
	    RR=sqrt(DX**2+DY**2+DZ**2)
	    if(IPRINT.ge.8)write(*,*)I,J,ISP,JSP,RR
*  standard criteria
 15	    if(mod(IRS(I,J),3).eq.0)then 
*  bulk
	      if(RR.gt.RRN.and.RR.lt.RRX)then
		IRS(I,J)=IRS(I,J)+2
	 	TIINI(I,J)=FULTIM
	        if(IPRINT.ge.6)write(*,*)' new st',I,J
	      end if   
*  Temporarily out
	    else if(mod(IRS(I,J),3).eq.1)then 
	      if(FULTIM-TIINO(I,J).gt.TTER)then
	        IRS(I,J)=IRS(I,J)-1
	        if(IPRINT.ge.6)write(*,*)' out st',I,J
	        TIMR=(TIINO(I,J)-TIINI(I,J))*1.d12
	        TIMRS2=TIMRS2+TIMR     
	        NR=TIMR*NITT/TIMM+1
	        if(NR.gt.0.and.NR.le.NITT)DIST2(NR)=DIST2(NR)+1 
	        ITIR2=ITIR2+1
	        if(TIMR.gt.TTER*1.d12)then
	          TIMRS1=TIMRS1+TIMR
	 	  ITIR1=ITIR1+1
		end if
	 	go to 15
	      end if
	      if(RR.gt.RRN.and.RR.lt.RRX)IRS(I,J)=IRS(I,J)+1
*  hydrated
	    else
	      if(RR.le.RRN.or.RR.ge.RRX)then
	        IRS(I,J)=IRS(I,J)-1
	        TIINO(I,J)=FULTIM
            end if
	    end if	    
*  alt. criteria	     
	    if(IRS(I,J).le.2)then
	      if(RR.gt.RRNX.and.RR.lt.RRXN)then
	        IRS(I,J)=IRS(I,J)+3
	        TIIN(I,J)=FULTIM 
	        if(IPRINT.ge.6)write(*,*)' new alt',I,J
	      end if
	    else    
	      if(RR.lt.RRNN.or.RR.gt.RRXX)then 
	        TIMR=(FULTIM-TIIN(I,J))*1.d12
		IRS(I,J)=IRS(I,J)-3
	        TIMRS=TIMRS+TIMR     
	        NR=TIMR*NITT/TIMM+1
	        if(NR.gt.0.and.NR.le.NITT)DISTT(NR)=DISTT(NR)+1 
	        ITIR=ITIR+1
	        if(IPRINT.ge.6)write(*,*)' out ',I,J
	      end if
	    end if
	  end do
	end do
	if(IPRINT.ge.7)write(*,*)fultim*1.d12,ITIR,TIMRS/ITIR
      return
	end
*
*=================== MDIFF ============================================
*                                                                      
	subroutine MDIFF(fildif)
	include 'mdan.h'
	character*12 fildif
	open(unit=9,file=fildif,status='unknown')
	write(*,*)
     +'translational time -correlation function of type',IDF
	write(9,'(a,I3)')
     +'#  translational time -correlation function of type',IDF
	write(9,*)'  t           Dav       Ddif       R      sqrt(t)',
     +'       Nconf' 
	write(*,*)NTT 
	TSHO=0.
	do I=1,NTT
	  TIM=I*DTT*1.d12
	  if(NCUM(I).gt.0)then
	    TCOR=10.*RCUM(I)/(6.d0*TIM*NCUM(I))
	    TSH2=RCUM(I)/NCUM(I)
	    TSH=sqrt(TSH2)
	    TSD=1.d-11*TSH*(TSH-TSHO)/(3.*DTT) 
	    TSHO=TSH
	    write(9,'(f10.3,2(1x,f12.6),2(1x,f11.5),I10)')
     +TIM,TCOR,TSD,TSH,sqrt(TIM),NCUM(I)
	    write(*,'(f10.3,2(1x,f12.6),2(1x,f11.5),I10)')
     +TIM,TCOR,TSD,TSH,sqrt(TIM),NCUM(I)
	  end if
	end do
	return
	end
*
*=================== MDFM ============================================
*                                                                      
	subroutine MDFM(fildif)
	include 'mdan.h'
	character*12 fildif
	open(unit=9,file=fildif,status='unknown')
	write(*,*)
     +'translational time -correlation function of types',IMT1,IMT2
	write(9,'(a,I3,I3)')
     +'#  translational time -correlation function of type',IMT1,IMT2
	write(9,*)'  t        D1av     D2av      Dm      D12',
     +'       Nconf' 
	TSHO=0.                    
	N1=NSPEC(IMT1)
	N2=NSPEC(IMT2)
	do I=1,NTT
	  TIM=I*DTT*1.d12
	  if(NCUM(I).gt.0)then
	    D1=10.*RCUM11(I)/(6.d0*TIM*NCUM(I)*N1)
	    D2=10.*RCUM22(I)/(6.d0*TIM*NCUM(I)*N1)
	    DM=(D1+D2)/2.
	    D12=10.*(RCUM11(I)+RCUM22(I)+RCUM12(I))/
     +        (6.d0*TIM*NCUM(I)*(N1+N2))
	    write(9,'(f10.3,2(1x,f12.6),2(1x,f11.5),I10)')
     +TIM,D1,D2,DM,D12
	  end if
	end do
	return
	end
*=================== MDIFM ============================================
*                                                                      
	subroutine MDIFM(fildfm)
	include 'mdan.h'  
	dimension VACT(0:NTCF)
	character*16 fildfm
	  open(unit=17,file=fildfm,status='unknown')
	  write(17,'(a)')'#  velocity correlation functions'
	  write(17,'(a,a)')'#  time   VACF1    VACF2    VCF11   VCF12', 
     +  '    VCF21     VCF22    total   Nconf'   
	  N1=NSPEC(IMT1)
	  N2=NSPEC(IMT2) 
	  ILAST=0
	  do I=0,NTT
*	    write(17,'(f7.2,6e11.4,I6)')
*     +    TIM,VACS1(I),VACS2(I),VACM11(I),VACM12(I),VACM21(I),
*     +	VACM22(I),NCUV(I)
          if(NCUV(i).ne.0)then
	    VACS1(I)=VACS1(I)/NCUV(I)
	    VACS2(I)=VACS2(I)/NCUV(I)
	    VACM11(I)=VACM11(I)/NCUV(I)
	    VACM12(I)=VACM12(I)/NCUV(I)
	    VACM21(I)=VACM21(I)/NCUV(I)
	    VACM22(I)=VACM22(I)/NCUV(I)
	    VACT(I)=VACS1(I)+VACS2(I)+VACM11(I)-VACM12(I)
     +           -VACM21(I)+VACM22(I)  
	    ILAST=I
	    end if
	  end do   
	  if(ILAST.le.0)then
	    write(17,*)' EMPTY TCF ARRAY'
	    return
	  end if               
	  FAC1=1./VACS1(0)
	  FAC2=1./VACS2(0)
	  FACM=sqrt(FAC1*FAC2)  
	  do I=0,ILAST
	    VACS1(I)=VACS1(I)*FAC1
	    VACS2(I)=VACS2(I)*FAC2
          VACM11(I)=VACM11(I)*FAC1
	    VACM12(I)=VACM12(I)*FACM
          VACM21(I)=VACM21(I)*FACM
	    VACM22(I)=VACM22(I)*FAC2
	    VACT(I)=(VACS1(I)+VACS2(I)+VACM11(I)-VACM12(I)-VACM21(I)+
     +            VACM22(I))*0.5
	  end do
	  do I=0,ILAST
	    TIM=I*DTT*1.d12
	    write(17,'(f8.3,7f8.4,I7)')
     +    TIM,VACS1(I),VACS2(I),VACM11(I),VACM12(I),VACM21(I),
     +    VACM22(I),VACT(I),NCUV(I)
	  end do                     
	  S1=XINTGR(DTT,VACS1,ILAST)*1.d15
	  S2=XINTGR(DTT,VACS2,ILAST)*1.d15
	  S11=XINTGR(DTT,VACM11,ILAST)*1.d15
	  S12=XINTGR(DTT,VACM12,ILAST)*1.d15
	  S21=XINTGR(DTT,VACM21,ILAST)*1.d15
	  S22=XINTGR(DTT,VACM22,ILAST)*1.d15
	  ST=XINTGR(DTT,VACT,ILAST)*1.d15
	  write(17,'(a)')'#--------------------------------------------'
	  write(17,'(a)')'#   Correlation tomes (fs):'
	  write(17,'(a9,7f8.3)')
     +  '#   Tcor ',S1,S2,S11,S12,S21,S22,ST
	return
	end
*
*=================== MAKEPS ============================================
*                                                                       
	subroutine MAKEPS(filps)
	include 'mdan.h'     
      character*2 color(0:maxcolor)
	character*12 filps
	character*80 com 
	data color/
     *   '0C', !  'bC', ! esli zadat' maxcolor==20,
     *   '1C', !  'cC', ! to nado ubrat' vosklicatel'nye
     *   '2C', !  'dC', ! znaki mezhdu dannymi
     *   '3C', !  'eC',
     *   '4C', !  'fC',
     *   '5C', !  'gC',
     *   '6C', !  'hC',
     *   '7C', !  'iC',
     *   '8C', !  'jC',
     *   '9C', !  'kC',
     *   'aC' /                        
	write(*,*)' Enter MAKEPS' 
	ICHAN=20
      open( ICHAN, file='tmp.ps', status='unknown' )
      do j=0,NTY
        m = -NTX
        IC = ITAB(j,1)
        do i=-NTX+1,NTX
          n = ITAB(j,i)
c n - eto uzhe No. tsveta ot 0 do maxcolor
          if( n .ne. IC ) then  
            write( 20, 100 )   j,    m, i-1, color(ic)
            IC = n
            m = i
          endif
        enddo
        write( 20, 100 )   j,    m, NTY, color(ic)
        write( 20, * )
      enddo
	write(20,*)IY,IX1,'(',NM(IS1(1)),') l-show'
	write(20,*)IY,IX2,'(',NM(IS2(1)),') l-show'
	write(20,'(a)')'showpage'
      close( 20 )
100   format( i4, 1x, i4, 1x, i4, 1x, a2 )  
	com(1:23)='/usr/bin/cp predlogpsf '
	com(24:35)=filps 
	call system(com(1:35))
	com(1:35)='cat tmp.ps >>                      '
	com(16:27)=filps
	call system(com(1:27))
	return
	end
*
*=================== MAKEPS2 ============================================
*                                                                       
	subroutine MAKEPS2(filps,IX1,IX2,IY)
	include 'mdan.h'     
      character color(0:maxcolor,0:maxcolor)*3,SYM(0:MAXCOLOR)*1
	character*12 filps
	character*80 com      
	data SYM /'0','1','2','3','4','5','6','7','8','9','a'/
	do I=0,MAXCOLOR
	  do J=0,MAXCOLOR
	    color(I,J)(1:1)=SYM(J)
	    color(I,J)(2:2)=SYM(I)
	    color(I,J)(3:3)='x'
	  end do
	end do
	write(*,*)' Enter MAKEPS' 
	ICHAN=20             
	MCL=MAXCOLOR+1
      open( ICHAN, file='tmp.ps', status='unknown' )
      do j=0,NTY
        m = -NTX
        IC = ITAB(j,1)
        do i=-NTX+1,NTX
          n = ITAB(j,i)
c n - eto uzhe No. tsveta ot 0 do maxcolor
          if( n .ne. IC ) then
	      I1C=mod(IC,MCL)
	      I2C=(IC-I1C)/MCL  
            if(I2C.le.MAXCOLOR)then
	        write( 20, 100 )   j,    m, i-1, color(I1C,I2C)
	      else
	        write( 20, 100 )   j,    m, i-1, 'xxx'
	      end if
            IC = n
            m = i
          endif
        enddo
	  I1C=mod(IC,MCL)
	  I2C=(IC-I1C)/MCL  
        if(I2C.le.MAXCOLOR)then
	    write( 20, 100 )   j,    m, NTY, color(I1C,I2C)
	  else
	    write( 20, 100 )   j,    m, NTY, 'xxx'
	  end if
        write( 20, * )
      enddo                              
	write(20,'(a)')'0 setgray'
	write(20,*)IY,IX1,'(',NM(IS1(1)),') l-show'
	write(20,*)IY,IX2,'(',NM(IS2(1)),') l-show'
	write(20,'(a)')'showpage'
      close( 20 )
100   format( i4, 1x, i4, 1x, i4, 1x, a3 )  
	com(1:23)='/usr/bin/cp color2psf '
	com(24:35)=filps 
	call system(com(1:35))
	com(1:35)='cat tmp.ps >>                      '
	com(16:27)=filps
	call system(com(1:27))
	return
	end
*
*======================= PBC ========================================
*
      subroutine PBC(XX,YY,ZZ)
      include "mdan.h"
      if(XX.gt. HBOXL)XX=XX-BOXL
      if(XX.lt.-HBOXL)XX=XX+BOXL
      if(YY.gt. HBOYL)YY=YY-BOYL
      if(YY.lt.-HBOYL)YY=YY+BOYL
      if(ZZ.gt. HBOZL)ZZ=ZZ-BOZL
      if(ZZ.lt.-HBOZL)ZZ=ZZ+BOZL
      return
      end 
*
*======================= COLOR ==================================
*
	function NCOLOR(X,AMPL,MAXCOLOR)
	real*8 X,AMPL(MAXCOLOR)
	NCOLOR=0  
	do I=1,MAXCOLOR    
	  if(X.gt.AMPL(I))NCOLOR=I
	end do
	return
	end
*
*======================= COLOR2 ==================================
*
	function NCOLOR2(X,Y,AMPL,MAXCOLOR)
	real*8 X,Y,AMPL(MAXCOLOR)
	J=0
	K=0  
	do I=1,MAXCOLOR    
	  if(X.gt.AMPL(I))J=I
	  if(Y.gt.AMPL(I))K=I
	end do
	NCOLOR2=J*(MAXCOLOR+1)+K
	return
	end
*....
*======== XINTGR =======================================================
*....
      FUNCTION XINTGR(H,Y,NDIM)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Y(0:NDIM)
      HT=H/3.0
      IF(NDIM.LT.5)RETURN
      SUM1=4.00*Y(1)
      SUM1=HT*(Y(0)+SUM1+Y(2))
      AUX1=4.00*Y(3)
      AUX1=SUM1+HT*(Y(2)+AUX1+Y(4))
      AUX2=HT*(Y(0)+3.8750*(Y(1)+Y(4))+2.6250*(Y(2)+Y(3))+Y(5))
      SUM2=4.00*Y(4)
      SUM2=AUX2-HT*(Y(3)+SUM2+Y(5))
      AUX=4.00*Y(2)
      IF(NDIM-6)5,5,2
    2 DO 4 I=6,NDIM,2
      SUM1=AUX1
      SUM2=AUX2
      AUX1=4.00*Y(I-1)
      AUX1=SUM1+HT*(Y(I-2)+AUX1+Y(I))
      IF(I-NDIM)3,6,6
    3 AUX2=4.00*Y(I)
      AUX2=SUM2+HT*(Y(I-1)+AUX2+Y(I+1))
    4 CONTINUE
    5 CONTINUE
      XINTGR=AUX2
      RETURN
    6 CONTINUE
      XINTGR=AUX1
      RETURN
      END
