*=============== IUNITM ===============================================
* 
*  Memory saving version (with expense of speed) 
*
      SUBROUTINE IUNITS
*
      include "prcm.h"
*
      DIMENSION  DM(3),QM(3,3),OM(3,3,3),HM(3,3,3,3)
     X          ,DI(3),QI(3,3),OI(3,3,3),HI(3,3,3,3)
*
*Calculate box dimensions etc:
*
      FACTM       = AVSNO*1000.0
      TOTMAS      = TOTMAS/FACTM
      FNOP        = DFLOAT(NOP)
      AVOFNR      = AVSNO/FNOP
      IF(RHO.NE.0.D0) THEN
        VOLM        = AVOFNR*(TOTMAS/(RHO*1000.0))
        IF(BOXL*BOYL*BOZL.lt.1.D-20) THEN
	   if(TASKID.eq.MAST)write(*,*)' Define box size from the density'
          VOL      = VOLM*FNOP*1.d30/AVSNO    
	    if(ICELL.eq.1)VOL=2.*VOL
	    if(ICELL.eq.2)VOL=VOL/cos30
          CL        = VOL**(1.0/3.0)       
	    BOXL=CL
	    BOYL=CL
	    BOZL=CL
	    if(ICELL.eq.1)VOL=0.5*VOL
	    if(ICELL.eq.2)then
	      BOYL=BOXL*cos30
	      VOL=BOXL*BOYL*BOZL
	    end if
        else
          CL=BOXL
        ENDIF
      ELSE
*Vacuum simulation - arbitrary box size:
        BOXL        = 1000.D0
        BOYL        = 1000.D0
        BOZL        = 1000.D0  
	  ALPHA	      = 0.d0
        PRINT "(/,'*** VACUUM SIMULATION ***',/)"
      END IF          
	if(ICELL.eq.1.and.TASKID.eq.MAST)write(*,*)
     +' Truncated octahedron geometry is used'
	if(ICELL.eq.2.and.TASKID.eq.MAST)write(*,*)
     +' Hexagonal periodic cell is used'
      call RECLEN(1.d0,1.d0,1.d0) 
      VOLM        = 1.d-30*VOL*AVOFNR
*
      
*Generate internal units:
*      
      UNITL       = 1.d-10
      UNITM       = TOTMAS
      UNITT       = DT
      UNITE       = UNITM*(UNITL/UNITT)**2
      UNITP       = UNITE*1.e-5/UNITL**3 
	BETA	    = UNITE/(BOLTZ*TRTEMP)
*
*Define dimensionless quantities and conversion factors
*
      TSTEP       = UNITT/SQRT((UNITM/UNITE)*UNITL**2)
      TSTEB       = TSTEP*FTIMES
      ENERF       = AVSNO*UNITE
      TEMPF       = 2.0/(3.0*AVSNO*BOLTZ)
      COULF       = (ELECHG/EPS0)*(ELECHG/UNITE)/(4.D0*PI*UNITL)
      PERMOL      = ENERF*1.D-3/FNOP 
	SHORT2	    = SHORT**2
	SHORTA	    = SHORT-1.d-11/UNITL   !  -0.1A
	RLR	    = 1.d0/(BETA*RLR**2) 
*	SHORTA=0.
	if(.not.LGRST.and.RDFCUT.le.0.d0)RDFCUT=HBOXL 
	RDFCUT2=RDFCUT**2
*
	if(IPRINT.ge.7)then
        PRINT "(/'*** UNIT MASS         ',D12.6,' kg      ' )",UNITM
        PRINT "( '*** UNIT TIME         ',D12.6,' S       ' )",UNITT
        PRINT "( '*** UNIT ENERGY       ',D12.6,' J       ' )",UNITE
        PRINT "( '*** UNIT LENGTH       ',D12.6,' m       ' )",UNITL
        PRINT"('*** UNIT PRESSURE     ',D12.6,' 10**5 N/m**2  '/)",UNITP
        PRINT "( '*** ENERGY  FACTOR    ',D12.6,' J/mol   ' )",ENERF
        PRINT "( '*** TEMP    FACTOR    ',D12.6,' K/J     ' )",TEMPF
        PRINT "( '*** COULOMB FACTOR    ',D12.6,'         '/)",COULF
        PRINT "( '*** 1/kT (beta)       ',D12.6,' u.e.    ' )",BETA
        PRINT "( '*** LONG  TIME STEP   ',F12.6,' .I.U.   ' )",TSTEP
        if(.not.LSHEJK)PRINT 
     +"( '*** SHORT TIME STEP   ',F12.6,' .I.U.   ' )",TSTEB
	end if
*
*dimensionless mass parameters:
*
      DO IS      =  1,NSITES
      MASSD (IS)  = MASS (IS)/FACTM/UNITM
      END DO! OF I
*
*Specific data for molecule types:
*
      IADDR (1)      = 0
      ISADR (1)      = 0
      ISADDR(1)      = 0
      DO ITYP        = 1,NTYPES
      IADDR (ITYP+1) = IADDR (ITYP)+NSPEC(ITYP)            ! molecules
      ISADR (ITYP+1) = ISADR (ITYP)+NSITS(ITYP)            ! sites
      ISADDR(ITYP+1) = ISADDR(ITYP)+NSITS(ITYP)*NSPEC(ITYP)   ! atoms
      END DO! OF ITYP
*     
	if(IPRINT.ge.10)then            
	write(*,*)
      PRINT "(25X,'*** ADDRESSES: ***')"
      DO ITYP        = 1,NTYPES+1
      PRINT "(10X,4(1X,I8))",ITYP,ISADR(ITYP),IADDR(ITYP),ISADDR(ITYP)
      END DO! OF ITYP
	end if
*
      N              = 0
      MT             = 0
      DO ITYP        = 1,NTYPES
      QS             = 0.D0
      if(IPRINT.ge.10)
     +PRINT "(/'*** POTENTIAL MODEL FOR :',A6)",NAME(ITYP)
      NSB            =  ISADR (ITYP)+1
      NSE            =  ISADR (ITYP+1)
      IF(IPRINT.GT.10) PRINT "(/,' SOME SITE DATA: ')"
      DO I           = 1,NSPEC(ITYP)
      DO IS          = NSB,NSE
      N              = N+1
      MASSDI(N)      = 1.0/MASSD(IS)
      Q     (N)      =    CHARGE(IS)
      NAM   (N)      = NM(IS)
      QS             = QS+DABS(Q(N))
      IF(IPRINT.GT.10) 
     XPRINT "(I4,3X,I4,3X,A4,6X,'Q: ',F6.3,5X,'MI:  ',F12.6)",
     XN,IS,NAM(N),Q(N),MASSDI(N)
      END DO! OF I
      END DO! OF IS
*
      QSUM(ITYP)     = QS
*
      NNN            = NS
      CALL MPOLES(R,CHARGE,DM,QM,OM,HM,NSB,NSE,NNN)
*
      DO I		= 1,3
      DI(I)		= DM(I)*2.5418
      DO J		= 1,3
      QI(I,J)		= QM(I,J)*1.345
      DO K		= 1,3
      OI(I,J,K)		= OM(I,J,K)*0.7118
      DO L		= 1,3
      HI(I,J,K,L)	= HM(I,J,K,L)*0.3767
      END DO! OF L
      END DO! OF K
      END DO! OF J
      END DO! OF I
*	 
      DII		= DSQRT(DI(1)**2+DI(2)**2+DI(3)**2)
      DMM		= DSQRT(DM(1)**2+DM(2)**2+DM(3)**2)
*
      IF(DABS(DMM).GT.0.0001D0) THEN
      if(IPRINT.ge.9)WRITE(6,160) DMM,DII
  160 FORMAT(/1X,'*** DIPOLE MOMENT    (MAGNITUDE)   ',F10.5,
     +' A.U.  -> ',F10.5,'  10**-18 esu '/)
      END IF
*
      DO JTYP        = ITYP,NTYPES
      MT             = MT+1
      MDX(ITYP,JTYP) = MT
      MDX(JTYP,ITYP) = MT
      POTES(MT)      = 0.D0
      POTLJ(MT)      = 0.D0
      END DO! OF JTYP
      END DO! OF ITYP      
      MOLINT         = MT+1
	POTES(MOLINT)=0.
	POTLJ(MOLINT)=0.
*
      if(IPRINT.ge.9)
     +PRINT "(/' *** ',I2,' MOLECULAR INTERACTIONS ***'/)",MT
*
      DO ITYP         = 1,NTYPES
      DO JTYP         = ITYP,NTYPES
      MT              = MDX(ITYP,JTYP)
      if(IPRINT.ge.9)
     +PRINT "(' NR: ',I2,5X,A6,'  <-->  ',A6)",MT,NAME(ITYP),NAME(JTYP)
      END DO! OF JTYP
      END DO! OF ITYP
*  Creating bonds-angles-torsions list - for each node 
	NRBT=0    
	NRAT=0    
	NRRT=0
	NRIT=0    
	ICNB=0
	ICNA=0
	ICNT=0
	do ITYP=1,NTYPES
	  NSS=NSPEC(ITYP) 
	  if(IPOT(ITYP).eq.0)then     ! otherwise special subroutine used (STRBND)
	  NBS=NRB(ITYP) 
	  JSFB=IADB(ITYP)-1
	  NAS=NRA(ITYP) 
	  JSFA=IADA(ITYP)-1
	  NTS=NRT(ITYP) 
	  JSFT=IADT(ITYP)-1
 	  do I=1,NSS                 ! over molecules
          IML=ISADDR(ITYP)+(I-1)*NSITS(ITYP)
	    do J=1,NBS               ! over bonds
	      IS=JSFB+J
	      IBD=ICNB+(I-1)*NBS+J
	      if(mod(IBD,NUMTASK).eq.TASKID)then
		NRBT=NRBT+1
	        if(NRBT.gt.NBO)stop "increase NBO"
		  IBI(NRBT)=IB(IS)+IML
		  JBJ(NRBT)=JB(IS)+IML
	          IBUK(NRBT)=IS
       	end if
	    end do 
	    do J=1,NAS   
	      IS=JSFA+J
	      IBD=ICNA+(I-1)*NAS+J
	      if(mod(IBD,NUMTASK).eq.TASKID)then
		NRAT=NRAT+1                
	        if(NRAT.gt.NAO)stop "increase NAO"
		IAI(NRAT)=IA(IS)+IML
		JAJ(NRAT)=JA(IS)+IML
		KAK(NRAT)=KA(IS)+IML
	        IAUK(NRAT)=IS
	      end if
	    end do 
	    do J=1,NTS   
	      IS=JSFT+J
	      IBD=ICNT+(I-1)*NTS+J
	      if(mod(IBD,NUMTASK).eq.TASKID)then
		NRRT=NRRT+1
	        if(NRRT.gt.NTO)stop "increase NTO"
		ITI(NRRT)=IT(IS)+IML
		JTJ(NRRT)=JT(IS)+IML
		KTK(NRRT)=KT(IS)+IML
		LTL(NRRT)=LT(IS)+IML 
	 	ITUK(NRRT)=IS
	      end if
	    end do 
	  end do
	  ICNB=ICNB+NSS*NBS
	  ICNA=ICNA+NSS*NAS
	  ICNT=ICNT+NSS*NTS
	  end if     
	end do
*      write(*,*)' node ',TASKID,' angles ',NRAT  
*	do I=1,NRAT
*	  write(*,*)TASKID,I,IAI(I),JAJ(I),KAK(I),IAUK(I)
*	end do
*      write(*,*)' node ',TASKID,' torsions ',NRRT
*	do I=1,NRRT
*	  write(*,*)TASKID,I,ITI(I),JTJ(I),KTK(I),LTL(I),ITUK(I)
*	end do
CM   lengths of transfer arrays
	LENMB=8*NRBB
	LENMA=8*NRAA
	LENMT=8*NRTT
        LENMP=8*NSTOT
        LENIT=8*MOLINT
        LENTT=8*NTYPES
*
*	CONVERSION TO INTERNAL UNITS:
*
*	Bond stretching 
*
*Harmonic potentials
*
      FACTOR     = 1.D3/AVSNO/UNITE
*      EFACT      = FKCALJ*FACTOR      !  kcal
 	EFACT      = FACTOR              ! kJ
	HYDF10=EFACT/(UNITL/1.d-10)**10
	HYDF12=EFACT/(UNITL/1.d-10)**12
      DO I       = 1,NB
        FB(I)      = FB(I)*EFACT
      END DO! OF I
*
* Morse potentials:
*
      DO I       = 1,NB
        DB(I)      = DB(I)*EFACT
      END DO! OF I
*                  
*	Angle bending:
*
      DO I         = 1,NA
      FA(I)        = FA(I)*EFACT
      RA(I)        = RA(I)/TODGR
      END DO! OF I
*
*	Torsional angles
*
      DO  I        = 1,NT
        RT (I)       = RT (I)/TODGR
        FT (I)       = FT (I)*EFACT
        FT1(I)       = FT1(I)*EFACT
        FT2(I)       = FT2(I)*EFACT
        FT3(I)       = FT3(I)*EFACT
        FT4(I)       = FT4(I)*EFACT
        FT5(I)       = FT5(I)*EFACT
      END DO! OF I
*  Lennard-Jones parameters:
	do IS=1,NS
	  EPSIL(IS)=2.d0*dsqrt(EPSIL(IS)*EFACT)
	  SIGMA(IS)=0.5d0*SIGMA(IS)
	end do
	do IS=1,NNAD
	  EPAD(IS)=2.d0*dsqrt(EPAD(IS)*EFACT)
	  SIGAD(IS)=0.5d0*SIGAD(IS)
	end do
*                 
*  Relevant only for parallel execution -
*  distribution of atoms over procesors
*     
	NAPC=NSTOT/NUMTASK+1
	if(LSHEJK)then
*  distribution of molecules - trying to give equal work for SHEJK
	  I=0 
	  NABS(0)=0
	  NAB(0)=1
	  IWRK=0  
	  AWRK=NRBND*1./NUMTASK
	  do ITYP=1,NTYPES
	    IBEG=IADDR(ITYP)+1
	    IEND=IADDR(ITYP+1) 
	    NSS =NSITS(ITYP)
	    NWRK=NRB(ITYP)
	    if(ITYP.lt.NTYPES)NWRK1=NRB(ITYP+1)
	    do IMOL=IBEG,IEND
            IWRK=IWRK+NWRK   
	      DIFF=IWRK-AWRK*(I+1)
	      if(DIFF.ge.0)then
	        NAE(I)=ISADDR(ITYP)+(IMOL-IBEG)*NSS  
	      if(DIFF.le.0.5*NWRK.or.NAE(I).eq.NABS(I))NAE(I)=NAE(I)+NSS
	        NAP(I)=NAE(I)-NABS(I)
	        NAP3(I)=3*NAP(I)
	        I=I+1
	        if(I.ge.NUMTASK)go to 65
	        NABS(I)=NAE(I-1)
	        NAB(I)=NABS(I)+1
	      end if
	    end do
	  end do
 65	  NAE(NUMTASK-1)=NSTOT
	  NAP(NUMTASK-1)=NSTOT-NABS(NUMTASK-1) 
	  NAP3(NUMTASK-1)=3*NAP(NUMTASK-1)              
	else
*  equilibrium distribution of atoms over processors
	  do I=0,NUMTASK-1
	    NABS(I)=NAPC*I
	    NAB(I)=NABS(I)+1
	    NAE(I)=NABS(I)+NAPC 
	    NAP(I)=NAPC 
	    NAP3(I)=3*NAPC
	    NABS3(I)=3*NABS(I)
	  end do   
	  if(NAE(NUMTASK-1).gt.NTOT)stop 'increase NTOT for overhead' 
	  NAE(NUMTASK-1)=NSTOT
	  NAP(NUMTASK-1)=NSTOT-NABS(NUMTASK-1) 
	  NAP3(NUMTASK-1)=3*NAP(NUMTASK-1)              
	end if
	do I=0,NUMTASK-1
	  NABS3(I)=3*NABS(I)
	end do   
	if(IPRINT.ge.7)then
	  write(*,*)' node   Nat   from    to   NABS '
	  do I=0,NUMTASK-1
	     write(*,'(5i7)')I,NAP(I),NAB(I),NAE(I),NABS(I)
	  end do
	end if
      RETURN
      END
*
*=============== RECLEN ===============================================
*
      SUBROUTINE RECLEN(SCX,SCY,SCZ)
*
      include "prcm.h"
*                
	BOXL=SCX*BOXL
	if(LHEX)then
	  BOYL=BOXL*cos30  
	  BOXY3=0.66666666666666666667d0*BOYL
	  BOZL=SCZ*BOZL      
	else if(LOCT)then  
	  BOYL=BOXL
	  BOZL=BOXL
	else
	  BOYL=SCY*BOYL
	  BOZL=SCZ*BOZL      
	end if
      HBOXL=0.5*BOXL
      HBOYL=0.5*BOYL
      HBOZL=0.5*BOZL 
      RF          = HBOXL
*      RCUTT       = DMIN1(RF,RCUT)
	RCUTT=RCUT
      IF(RCUT.LE.0.D0)then
	  RCUTT = HBOXL
	  if(.not.LHEX.and.RCUTT.gt.HBOYL)RCUTT=HBOYL
	  if(RCUTT.gt.HBOZL)RCUTT=HBOZL
	end if
      RSSQ        = RCUTT**2
      VOL	= BOXL*BOYL*BOZL
	if(ICELL.eq.1)VOL=0.5*VOL
	RHO	= TOTMAS*1.d27/VOL
      return
      end  
*
*=============== BNDLST ===========================================
*
      SUBROUTINE BNDLST
*
      include "prcm.h" 
	integer NRNOD(NTPS)
	parameter (RMX2=5.**2)
*                                 
	do I=1,NSTOT
	  NNBB(I)=0
	  do IS=1,NBDMAX
           INBB(I,IS)=0
	  end do
	end do       
	IBEG=TASKID+1 
	NRN=NUMTASK  
	if(NRN.gt.NTYPES)NRN=NTYPES
	do ITYP=1,NTYPES
	  NRNOD(ITYP)=mod(ITYP-1,NUMTASK)
	end do  
	if(IBEG.gt.NTYPES)go to 101
	do ITYP=IBEG,NTYPES,NUMTASK
*           
        NNMAX     = -99999
        NSP       = NSPEC(ITYP)     ! num of mol of this type
        NSS       = NSITS(ITYP)     ! num of sites on a mol of this type
        NRBS      = NRB(ITYP)       ! num of bonds 
        NRAS      = NRA (ITYP)      ! num of angles 
        NRTS      = NRT(ITYP)       ! num of torsions
*
        NBBEG     = IADB(ITYP)
        NBEND     = NBBEG+NRBS-1
        NABEG     = IADA(ITYP)
        NAEND     = NABEG+NRAS-1
        NTBEG     = IADT(ITYP)
        NTEND     = NTBEG+NRTS-1                       
*             
*
        ISBEG     = ISADR(ITYP)+1
        ISEND     = ISADR(ITYP+1)
        ISHF      = ISADR(ITYP)  ! shift of global site num. relatevely local
	  ISHA	    = ISADDR(ITYP)-ISHF
*
*  Double sum over sites 
*  
	  DO IS=ISBEG,ISEND-1
	    DO JS=IS+1,ISEND   
*  IS, JS - site number
*  Bonds    
	      if(.not.L15NB(ITYP))go to 100
	      I=ISHA+IS
	      J=ISHA+JS                
	      DX=SX(I)-SX(J)
	      DY=SY(I)-SY(J)
	      DZ=SZ(I)-SZ(J)
	      call PBC(DX,DY,DZ)                
*   atoms are too far
              RRR=DX**2+DY**2+DZ**2
              if(RRR.gt.RMX2)go to 150
	      do IIS=NBBEG,NBEND
		II=IB(IIS)+ISHF
		JJ=JB(IIS)+ISHF
		if(II.eq.IS.and.JJ.eq.JS)go to 100
		if(II.eq.JS.and.JJ.eq.IS)go to 100
	      end do
*  Angles
	      do IIS=NABEG,NAEND
		II=IA(IIS)+ISHF
		KK=KA(IIS)+ISHF
		if(II.eq.IS.and.KK.eq.JS)go to 100
		if(II.eq.JS.and.KK.eq.IS)go to 100
	      end do          
*  Torsions      
	      do IIS=NTBEG,NTEND
		II=IT(IIS)+ISHF
		LL=LT(IIS)+ISHF 
		ITR=ITORS(IIS)
		if((II.eq.IS.and.LL.eq.JS).or.(II.eq.JS.and.LL.eq.IS))
     +	then
		  if(ITR.eq.-1.or..not.L14NB(ITYP))then
		    go to 100
		  else
	  	    go to 90
	 	  end if
		end if
	      end do
*  Pass all checks - non-bound 
            go to 150
*  These atoms are 1-4 bound (Scaling LJ parameters may be used)
 90         do IIM=0,NSP-1
	        ISHIFT=ISADDR(ITYP)-ISADR(ITYP)+IIM*NSS 
		ISA=IS+ISHIFT 
		JSA=JS+ISHIFT 
	 	NNBB(ISA)=NNBB(ISA)+1      ! number of bound neigbours for this atom
		INBB(ISA,NNBB(ISA))=-JSA   ! bound neigbours ( - for 1-4 interactions)
		if(NNBB(ISA).gt.NBDMAX)then
		  write(*,*)
     +' list of bound atoms exceeded for atom ',ISA,' ',NM(ISA)
		  stop
		end if 
	 	NNBB(JSA)=NNBB(JSA)+1
		INBB(JSA,NNBB(JSA))=-ISA  
		if(NNBB(JSA).gt.NBDMAX)then
		  write(*,*)
     +' list of bound atoms exceeded for atom ',JSA,' ',NM(JSA)
		  stop
		end if 
	      end do 
	      go to 150
*   Atoms are 1-3 or 1-2 bounded. 
 100        do IIM=0,NSP-1
	        ISHIFT=ISADDR(ITYP)-ISADR(ITYP)+IIM*NSS
		ISA=IS+ISHIFT 
		JSA=JS+ISHIFT 
	 	NNBB(ISA)=NNBB(ISA)+1
		INBB(ISA,NNBB(ISA))=JSA
		if(NNBB(ISA).gt.NBDMAX)then
		  write(*,*)
     +' list of bound atoms exceeded for atom ',ISA,' ',NM(ISA)
		  stop
		end if 
	 	NNBB(JSA)=NNBB(JSA)+1
		INBB(JSA,NNBB(JSA))=ISA  
		if(NNBB(JSA).gt.NBDMAX)then
		  write(*,*)
     +' list of bound atoms exceeded for atom ',JSA,' ',NM(JSA)
		  stop
		end if 
	      end do
 150        continue
	    end do
	  end do
*----------------------------
 	  write(*,*)
     +  ' node ',TASKID,'  list of bound atoms for ',NAME(ITYP)
	end do   ! of ITYP      
 101	call  GATHER(NRNOD)
CM
	if(IPRINT.ge.8)then
	  write(*,*)' list of bound atoms: '
	  do I=1,NSTOT
	    write(*,'(i5,i3,2x,40i5)')I,NNBB(I),(INBB(I,J),J=1,NNBB(I))
	  end do 
	end if
*----------------------------------------
      RETURN
      END   
